commit dfb94946cf58ca16f7f94308a4f91b0c9a06c124
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sat Jul 14 12:53:03 2018 -0500

    Makefile.am: remove rsvg-filter.h

 Makefile.am | 1 -
 1 file changed, 1 deletion(-)

commit 44abb1eca7a0dd94503366697b58a0c759866342
Merge: 05391bd6 215e5aca
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sat Jul 14 12:51:15 2018 -0500

    Merge branch 'pborelli/librsvg-cleanup'

commit 215e5aca1eb644cc85b49fc146c93231ff0aaf89
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sat Jul 14 12:51:06 2018 -0500

    Rustfmt

 rsvg_internals/src/load.rs    | 2 +-
 rsvg_internals/src/parsers.rs | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 05391bd6fc892d6e7c093033fda5fc6af96ea342
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sat Jul 14 12:45:56 2018 -0500

    Update NEWS

 NEWS | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 81e74f0b72c2fe67e67d685c92154fb6f773195a
Merge: a55c1919 daa37ae5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sat Jul 14 12:20:58 2018 -0500

    Merge branch 'YaLTeR/librsvg-filters-to-rust-9'
    
    With this, all the C nodes are ported to Rust!!!!!

commit a55c1919d2ab0872b4af56769971c0e20ac43169
Merge: 93c0fb64 8215d7f1
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Fri Jul 13 05:24:07 2018 +0000

    Merge branch 'add-debuginfo-to-release' into 'master'
    
    Include Rust debuginfo in release builds
    
    Closes #312
    
    See merge request GNOME/librsvg!95

commit daa37ae5a6c03672a152ac247c4f26befe3d8c77
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jul 13 00:42:21 2018 +0200

    Remove RsvgCNodeImpl

 Makefile.am                 |  1 -
 librsvg/rsvg-private.h      | 15 --------
 rsvg_internals/src/cnode.rs | 92 ---------------------------------------------
 rsvg_internals/src/lib.rs   |  3 --
 rsvg_internals/src/node.rs  | 12 ------
 rsvg_internals/src/util.rs  |  8 ----
 6 files changed, 131 deletions(-)

commit 3fd812c8b165f537221e3ffc1e9e01a61184ace8
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 12 23:11:19 2018 +0200

    Fix BackgroundImage

 rsvg_internals/src/filters/context.rs              |   5 +-
 .../svg1.1/filters-background-01-f-ref.png         | Bin 0 -> 18990 bytes
 .../reftests/svg1.1/filters-background-01-f.svg    | 159 +++++++++++++++++++++
 3 files changed, 163 insertions(+), 1 deletion(-)

commit 9090007b8dab4586074e7948a3a2eef7e0a947c2
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 12 15:46:25 2018 +0200

    Get rid of more filter FFI leftovers

 Cargo.lock                                         |  16 +++
 Makefile.am                                        |   1 -
 rsvg_internals/Cargo.toml                          |   1 +
 rsvg_internals/src/drawing_ctx.rs                  |   4 +-
 rsvg_internals/src/filters/blend.rs                |   9 +-
 rsvg_internals/src/filters/color_matrix.rs         |   9 +-
 rsvg_internals/src/filters/component_transfer.rs   |   9 +-
 rsvg_internals/src/filters/composite.rs            |   9 +-
 rsvg_internals/src/filters/convolve_matrix.rs      |   9 +-
 rsvg_internals/src/filters/displacement_map.rs     |   9 +-
 rsvg_internals/src/filters/ffi.rs                  | 120 -----------------
 rsvg_internals/src/filters/flood.rs                |   9 +-
 rsvg_internals/src/filters/gaussian_blur.rs        |   9 +-
 rsvg_internals/src/filters/image.rs                |   9 +-
 .../src/filters/light/diffuse_lighting.rs          |   9 +-
 .../src/filters/light/specular_lighting.rs         |   9 +-
 rsvg_internals/src/filters/merge.rs                |   9 +-
 rsvg_internals/src/filters/mod.rs                  | 145 +++++++++++++++++----
 rsvg_internals/src/filters/morphology.rs           |   9 +-
 rsvg_internals/src/filters/offset.rs               |   9 +-
 rsvg_internals/src/filters/tile.rs                 |   9 +-
 rsvg_internals/src/filters/turbulence.rs           |   9 +-
 rsvg_internals/src/lib.rs                          |   1 +
 23 files changed, 175 insertions(+), 257 deletions(-)

commit adb439791bef80b61fcb5d5205b08a4870a96495
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 12 14:53:44 2018 +0200

    Fix kernelUnitLength handling

 rsvg_internals/src/filters/convolve_matrix.rs      |  25 ++++++++------
 .../src/filters/light/diffuse_lighting.rs          |  36 ++++++++++++++-------
 rsvg_internals/src/filters/light/light_source.rs   |  22 +++----------
 .../src/filters/light/specular_lighting.rs         |  36 ++++++++++++++-------
 rsvg_internals/src/surface_utils/shared_surface.rs |   8 ++---
 .../reftests/filter-kernel-unit-length-ref.png     | Bin 0 -> 3808 bytes
 .../reftests/filter-kernel-unit-length.svg         |  30 +++++++++++++++++
 7 files changed, 104 insertions(+), 53 deletions(-)

commit e507a2a962cd98491c48442aa00a6d2a05c40b5f
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Wed Jul 11 10:56:53 2018 +0200

    parsers: remove unused function

 librsvg/rsvg-css.h            | 14 -------
 rsvg_internals/src/lib.rs     |  2 +-
 rsvg_internals/src/parsers.rs | 91 ++-----------------------------------------
 3 files changed, 4 insertions(+), 103 deletions(-)

commit 8215d7f1f581f0aaa317cccc3e974c61d1a6ad84
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 12 16:06:35 2018 +0200

    Include Rust debuginfo in release builds

 Cargo.toml | 1 +
 1 file changed, 1 insertion(+)

commit 25bc1bbb7c3cb3ef90c9c208d2fa5ee24c532c90
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jul 11 23:04:27 2018 +0200

    Pass large struct by reference in Turbulence
    
    Significantly improves perf. I was sure Rust would do this optimization
    automatically but looks like it doesn't.

 rsvg_internals/src/filters/turbulence.rs | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit aa825a02299bc5f866c447dbedba86b6791683dd
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jul 11 21:38:56 2018 +0200

    Use stack arrays in filters::light::normal()
    
    Improves performance by avoiding stack allocations (which are there even
    in release builds).

 rsvg_internals/src/filters/light/mod.rs | 149 ++++++++++++++++----------------
 1 file changed, 75 insertions(+), 74 deletions(-)

commit 915abe95cfa1ad0f5f76272b0bb38d4d320114a2
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jul 11 13:23:03 2018 +0200

    Clean up some C filter leftovers

 librsvg/rsvg-filter.h                 |  70 ------------
 librsvg/rsvg-load.c                   |   1 -
 rsvg_internals/src/drawing_ctx.rs     |   8 +-
 rsvg_internals/src/filters/context.rs | 201 +---------------------------------
 rsvg_internals/src/filters/ffi.rs     |  52 +--------
 rsvg_internals/src/filters/mod.rs     |   2 +-
 rsvg_internals/src/lib.rs             |  12 --
 7 files changed, 7 insertions(+), 339 deletions(-)

commit 884a643251dd9953ac84fe7c7035db545525871b
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Wed Jul 11 10:42:02 2018 +0200

    load: move the set_atts logic to rust

 librsvg/rsvg-load.c         | 26 ++++++--------------------
 librsvg/rsvg-private.h      |  4 ----
 rsvg_internals/src/lib.rs   |  5 +----
 rsvg_internals/src/load.rs  | 28 ++++++++++++++++++++++++++++
 rsvg_internals/src/node.rs  | 24 ------------------------
 rsvg_internals/src/state.rs | 16 ----------------
 6 files changed, 35 insertions(+), 68 deletions(-)

commit 293e69d4307a211ce5bc576384fbba7bde4b0ef0
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jul 11 12:57:29 2018 +0200

    Refactor/fix some transformations in filters

 rsvg_internals/src/filters/convolve_matrix.rs       |  13 +++++--------
 rsvg_internals/src/filters/displacement_map.rs      |   6 ++----
 rsvg_internals/src/filters/gaussian_blur.rs         |   5 ++---
 .../src/filters/light/diffuse_lighting.rs           |  13 +++++--------
 .../src/filters/light/specular_lighting.rs          |  13 +++++--------
 rsvg_internals/src/filters/morphology.rs            |   6 ++----
 rsvg_internals/src/filters/offset.rs                |   6 ++----
 .../bugs/634324-blur-negative-transform-ref.png     | Bin 29848 -> 25021 bytes
 8 files changed, 23 insertions(+), 39 deletions(-)

commit 91e4d291072e381183cd9db9de4ae4705c9c2879
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jul 11 11:55:19 2018 +0200

    Port feTile
    
    The last filter is now in Rust! 🎉

 Makefile.am                                        |   4 +-
 librsvg/filters/common.c                           | 660 ---------------------
 librsvg/filters/common.h                           | 181 ------
 librsvg/filters/tile.c                             | 163 -----
 rsvg_internals/src/drawing_ctx.rs                  |  60 +-
 rsvg_internals/src/filters/context.rs              |  10 +-
 rsvg_internals/src/filters/ffi.rs                  |  64 +-
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/filters/tile.rs                 | 123 ++++
 rsvg_internals/src/load.rs                         |  48 +-
 .../reftests/svg1.1/filters-tile-01-b-ref.png      | Bin 0 -> 6146 bytes
 .../fixtures/reftests/svg1.1/filters-tile-01-b.svg |  80 +++
 12 files changed, 260 insertions(+), 1134 deletions(-)

commit 6b53b1b92a0d52d13767b678c3bf10e02a74b39e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jul 11 11:07:39 2018 +0200

    Port lighting filters

 Makefile.am                                        |   8 +-
 librsvg/filters/diffuse_lighting.c                 | 220 ----------
 librsvg/filters/light_source.c                     | 474 ---------------------
 librsvg/filters/light_source.h                     |  89 ----
 librsvg/filters/specular_lighting.c                | 222 ----------
 rsvg_internals/src/filters/context.rs              |   7 +
 rsvg_internals/src/filters/error.rs                |   3 +
 rsvg_internals/src/filters/ffi.rs                  |   2 +
 .../src/filters/light/diffuse_lighting.rs          | 219 ++++++++++
 rsvg_internals/src/filters/light/light_source.rs   | 264 ++++++++++++
 rsvg_internals/src/filters/light/mod.rs            | 191 +++++++++
 .../src/filters/light/specular_lighting.rs         | 241 +++++++++++
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/load.rs                         |  84 ++--
 .../reftests/svg1.1/filters-diffuse-01-f-ref.png   | Bin 0 -> 18606 bytes
 .../reftests/svg1.1/filters-diffuse-01-f.svg       | 152 +++++++
 .../reftests/svg1.1/filters-light-01-f-ref.png     | Bin 0 -> 30163 bytes
 .../reftests/svg1.1/filters-light-01-f.svg         | 187 ++++++++
 .../reftests/svg1.1/filters-light-02-f-ref.png     | Bin 0 -> 11093 bytes
 .../reftests/svg1.1/filters-light-02-f.svg         |  97 +++++
 .../reftests/svg1.1/filters-light-03-f-ref.png     | Bin 0 -> 11991 bytes
 .../reftests/svg1.1/filters-light-03-f.svg         | 124 ++++++
 .../reftests/svg1.1/filters-light-04-f-ref.png     | Bin 0 -> 10935 bytes
 .../reftests/svg1.1/filters-light-04-f.svg         | 136 ++++++
 .../reftests/svg1.1/filters-light-05-f-ref.png     | Bin 0 -> 26037 bytes
 .../reftests/svg1.1/filters-light-05-f.svg         | 252 +++++++++++
 .../reftests/svg1.1/filters-specular-01-f-ref.png  | Bin 0 -> 26606 bytes
 .../reftests/svg1.1/filters-specular-01-f.svg      | 195 +++++++++
 tests/fixtures/reftests/svg1.1/images/bumpMap2.png | Bin 0 -> 657 bytes
 tests/fixtures/reftests/svg1.1/images/bumpMap3.png | Bin 0 -> 433 bytes
 30 files changed, 2122 insertions(+), 1046 deletions(-)

commit 93c0fb64d6cdab0e1ed3f67f5c90f74ef226bfb4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jul 10 16:13:41 2018 +0200

    Ignore filters-example-01-b.svg
    
    This is failing on i386 as well, because of text rendering differences.

 .../svg1.1/{filters-example-01-b.svg => ignore-filters-example-01-b.svg}  | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit f8ebbfd06e3f35e6c30205ddc7cdaac0865ace08
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jul 10 15:36:18 2018 +0200

    Ignore filter-composite-color-interpolation-filters.svg due to 32-bit failures
    
    That test is failing on i386; it looks like coordinate rounding is
    different.  Also, it is *different* again if you build with
    optimizations / in release mode.
    
    We'll have to make a decision on what do do for tests in 32-bit boxes
    in general.

 ...ilters.svg => ignore-filter-composite-color-interpolation-filters.svg} | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 5c6fab8b9e5227f33a74b44e3c0d08dd8a2cb047
Merge: 9d2f41f7 d9c2af77
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jul 10 14:18:31 2018 +0200

    Merge branch 'YaLTeR/librsvg-filters-to-rust-8'

commit d9c2af7776bbe2a6dbfb665d360d902eca04ac14
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jul 10 09:59:24 2018 +0200

    Port feTurbulence

 Makefile.am                                        |   2 +-
 librsvg/filters/turbulence.c                       | 437 -------------------
 rsvg_internals/src/filters/ffi.rs                  |   3 +-
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/filters/turbulence.rs           | 466 +++++++++++++++++++++
 rsvg_internals/src/load.rs                         |  14 +-
 .../reftests/bugs/241-light-source-type-ref.png    | Bin 4044 -> 4029 bytes
 .../reftests/svg1.1/filters-turb-01-f-ref.png      | Bin 0 -> 140912 bytes
 .../fixtures/reftests/svg1.1/filters-turb-01-f.svg | 102 +++++
 .../reftests/svg1.1/filters-turb-02-f-ref.png      | Bin 0 -> 18261 bytes
 .../fixtures/reftests/svg1.1/filters-turb-02-f.svg | 148 +++++++
 11 files changed, 727 insertions(+), 446 deletions(-)

commit 1d2ba588372614c1a50864fb638c059be07e60c9
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jul 9 16:21:08 2018 +0200

    Fix filters being applied to masks

 rsvg_internals/src/drawing_ctx.rs                  |   8 +-
 .../reftests/svg1.1/masking-filter-01-f-ref.png    | Bin 0 -> 6174 bytes
 .../reftests/svg1.1/masking-filter-01-f.svg        |  81 +++++++++++++++++++++
 3 files changed, 88 insertions(+), 1 deletion(-)

commit fb41ad2d8946bff2289ac34fa8288f14b6d4b4d1
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jul 9 16:09:53 2018 +0200

    Fix empty and non-existing filter rendering

 rsvg_internals/src/drawing_ctx.rs                  |  19 ++++-
 rsvg_internals/src/filters/context.rs              |  30 +++----
 rsvg_internals/src/filters/ffi.rs                  |  10 ++-
 tests/fixtures/reftests/nonexisting-filter-ref.png | Bin 93 -> 89 bytes
 .../reftests/svg1.1/filters-felem-01-b-ref.png     | Bin 0 -> 11066 bytes
 .../reftests/svg1.1/filters-felem-01-b.svg         |  90 +++++++++++++++++++++
 6 files changed, 131 insertions(+), 18 deletions(-)

commit 4f1bb8549d19916495b7ab0d2737b72a9f129f43
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jul 9 15:42:57 2018 +0200

    Add some missing filter tests

 .../reftests/svg1.1/filters-comptran-01-b-ref.png  | Bin 0 -> 16093 bytes
 .../reftests/svg1.1/filters-comptran-01-b.svg      | 126 ++++++++++++++++++++
 .../reftests/svg1.1/filters-example-01-b-ref.png   | Bin 0 -> 22681 bytes
 .../reftests/svg1.1/filters-example-01-b.svg       |  93 +++++++++++++++
 .../reftests/svg1.1/filters-felem-02-f-ref.png     | Bin 0 -> 13219 bytes
 .../reftests/svg1.1/filters-felem-02-f.svg         | 127 +++++++++++++++++++++
 6 files changed, 346 insertions(+)

commit 50a21851797df25ac413d999c0c12923b60368d2
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jul 9 14:55:50 2018 +0200

    Fix circle dashed stroke rendering

 rsvg_internals/src/shapes.rs                       |  20 +--
 .../reftests/svg1.1/filters-overview-01-b-ref.png  | Bin 0 -> 34241 bytes
 .../reftests/svg1.1/filters-overview-01-b.svg      | 165 +++++++++++++++++++
 .../reftests/svg1.1/filters-overview-02-b-ref.png  | Bin 0 -> 41760 bytes
 .../reftests/svg1.1/filters-overview-02-b.svg      | 178 +++++++++++++++++++++
 .../reftests/svg1.1/filters-overview-03-b-ref.png  | Bin 0 -> 41934 bytes
 .../reftests/svg1.1/filters-overview-03-b.svg      | 166 +++++++++++++++++++
 .../reftests/svg1.1/struct-use-04-b-ref.png        | Bin 19669 -> 19666 bytes
 8 files changed, 519 insertions(+), 10 deletions(-)

commit 33b76b41d093549dfee252874318874ef4a481a3
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jul 9 12:25:35 2018 +0200

    Port feGaussianBlur

 Makefile.am                                        |   2 +-
 librsvg/filters/gaussian_blur.c                    | 704 ---------------------
 rsvg_internals/src/filters/ffi.rs                  |   1 +
 rsvg_internals/src/filters/gaussian_blur.rs        | 313 +++++++++
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/load.rs                         |  14 +-
 .../fixtures/reftests/bugs/282-drop-shadow-ref.png | Bin 1726 -> 1733 bytes
 .../bugs/634324-blur-negative-transform-ref.png    | Bin 14003 -> 29848 bytes
 .../reftests/svg1.1/filters-gauss-01-b-ref.png     | Bin 0 -> 20705 bytes
 .../reftests/svg1.1/filters-gauss-01-b.svg         |  93 +++
 .../reftests/svg1.1/filters-gauss-02-f-ref.png     | Bin 0 -> 6675 bytes
 .../reftests/svg1.1/filters-gauss-02-f.svg         |  85 +++
 .../reftests/svg1.1/filters-gauss-03-f-ref.png     | Bin 0 -> 4347 bytes
 .../reftests/svg1.1/filters-gauss-03-f.svg         |  65 ++
 14 files changed, 566 insertions(+), 712 deletions(-)

commit 1e3eaec84540c9e8da70b1d02dffb486bf87ffd0
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jul 9 12:24:54 2018 +0200

    Add SharedImageSurface::convolve()

 rsvg_internals/src/surface_utils/shared_surface.rs | 78 +++++++++++++++++++++-
 1 file changed, 77 insertions(+), 1 deletion(-)

commit 9d2f41f7cee3939aafbde30329800786f7493438
Merge: 6b730799 bf2f8689
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Mon Jul 9 10:05:37 2018 +0000

    Merge branch 'fontSize' into 'master'
    
    Fix #310 - correct font-size of non-standard dpi
    
    Closes #310
    
    See merge request GNOME/librsvg!92

commit bf2f86892ebc864e658b86c35a8566e9426074f9
Author: Mike Marcacci <mike.marcacci@gmail.com>
Date:   Mon Jul 9 00:52:21 2018 -0600

    (#310): Respect dpi in font-size

 rsvg_internals/src/text.rs                         |   3 +-
 .../reftests/bugs/310-font-size-at-48dpi-ref.png   | Bin 0 -> 5818 bytes
 .../reftests/bugs/310-font-size-at-48dpi.svg       |  62 +++++++++++++++++++++
 tests/rsvg-test.c                                  |   5 +-
 4 files changed, 67 insertions(+), 3 deletions(-)

commit 2cc36ceba304c19a2b0e97942843b3946edc18a8
Author: Mike Marcacci <mike.marcacci@gmail.com>
Date:   Sun Jul 8 18:51:33 2018 -0600

    Fix a small typo in CONTRIBUTING.md

 CONTRIBUTING.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit aff1d6f504094239b354ee7db7eb33b3b2451f32
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 5 19:24:42 2018 +0200

    Port feDisplacementMap

 Makefile.am                                        |   2 +-
 librsvg/filters/displacement_map.c                 | 248 ---------------------
 rsvg_internals/src/filters/displacement_map.rs     | 186 ++++++++++++++++
 rsvg_internals/src/filters/ffi.rs                  |   1 +
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/load.rs                         |  14 +-
 .../reftests/svg1.1/filters-displace-01-f-ref.png  | Bin 0 -> 50115 bytes
 .../reftests/svg1.1/filters-displace-01-f.svg      | 141 ++++++++++++
 .../reftests/svg1.1/filters-displace-02-f-ref.png  | Bin 0 -> 7304 bytes
 .../reftests/svg1.1/filters-displace-02-f.svg      |  90 ++++++++
 tests/fixtures/reftests/svg1.1/images/rotate20.png | Bin 0 -> 1434 bytes
 tests/fixtures/reftests/svg1.1/images/sphere.png   | Bin 0 -> 5923 bytes
 12 files changed, 427 insertions(+), 256 deletions(-)

commit 320eb91b6c0bd84c97ba53aca079744a15730a44
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 5 19:23:38 2018 +0200

    Make convolve_matrix use surface.unpremultiply()

 rsvg_internals/src/filters/convolve_matrix.rs | 36 +++------------------------
 1 file changed, 4 insertions(+), 32 deletions(-)

commit cd6f32c667199590a81610ad53f98f82de60413c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 5 19:22:16 2018 +0200

    Add SharedImageSurface::unpremultiply()

 rsvg_internals/src/surface_utils/shared_surface.rs | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

commit 1fac6a216ebed8ecd4e5f1a07324af50440be5a9
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 5 19:22:02 2018 +0200

    Add Pixel::{un,}premultiply()

 rsvg_internals/src/surface_utils/mod.rs | 34 +++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)

commit db4259bd4420dce9df0f0715e56126bcd583fb30
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jul 5 17:12:46 2018 +0200

    Port feMorphology

 Makefile.am                                        |   2 +-
 librsvg/filters/erode.c                            | 197 ---------------------
 librsvg/rsvg-private.h                             |   2 +-
 rsvg_internals/src/filters/ffi.rs                  |   1 +
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/filters/morphology.rs           | 184 +++++++++++++++++++
 rsvg_internals/src/load.rs                         |  14 +-
 rsvg_internals/src/node.rs                         |   2 +-
 .../filter-morphology-from-reference-page-ref.png  | Bin 0 -> 3598 bytes
 .../filter-morphology-from-reference-page.svg      |  37 ++++
 .../reftests/svg1.1/filters-morph-01-f-ref.png     | Bin 0 -> 32566 bytes
 .../reftests/svg1.1/filters-morph-01-f.svg         | 103 +++++++++++
 12 files changed, 336 insertions(+), 207 deletions(-)

commit 6b73079960abcff3d2030e5d39054a4cf8544f93
Merge: e31247c5 5794f0ac
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Wed Jul 4 08:13:39 2018 +0000

    Merge branch 'wip/ignatenko/cssparser-0.24' into 'master'
    
    deps: update cssparser to 0.24
    
    See merge request GNOME/librsvg!91

commit 5794f0ac4ac8748ddfa0b16339ece2c97f7b48d3
Author: Igor Gnatenko <ignatenko@src.gnome.org>
Date:   Sun Jul 1 12:06:04 2018 +0100

    deps: update cssparser to 0.24
    
    Signed-off-by: Igor Gnatenko <ignatenko@src.gnome.org>

 Cargo.lock                | 42 +++++++++++++++++++++---------------------
 rsvg_internals/Cargo.toml |  2 +-
 2 files changed, 22 insertions(+), 22 deletions(-)

commit e31247c5519f131dd5303e06e62796aa9b528a15
Merge: 44bf347b e72f1097
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sun Jul 1 21:25:06 2018 -0500

    Merge branch 'YaLTeR/librsvg-filters-to-rust-7'

commit 44bf347b084ec916b5148ddf24e0ad19d7003cce
Author: Jordan Petridis <jordanpetridis@protonmail.com>
Date:   Sun Jul 1 10:36:31 2018 +0000

    CI: drop ubuntu builds since rustc package is outdated.

 .gitlab-ci.yml | 12 ------------
 1 file changed, 12 deletions(-)

commit e72f10979e0f7a69ec245514cca1d642aa531582
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 30 13:05:44 2018 +0300

    Refactor FilterError and FilterContext::get_input()

 rsvg_internals/src/filters/blend.rs                |  11 +-
 rsvg_internals/src/filters/color_matrix.rs         |   9 +-
 rsvg_internals/src/filters/component_transfer.rs   |   9 +-
 rsvg_internals/src/filters/composite.rs            |  13 +-
 rsvg_internals/src/filters/context.rs              | 139 +++++++++++----------
 rsvg_internals/src/filters/convolve_matrix.rs      |  19 +--
 rsvg_internals/src/filters/error.rs                |  22 ++--
 rsvg_internals/src/filters/ffi.rs                  |   7 +-
 rsvg_internals/src/filters/flood.rs                |   5 +-
 rsvg_internals/src/filters/image.rs                |   9 +-
 rsvg_internals/src/filters/merge.rs                |  17 +--
 rsvg_internals/src/filters/mod.rs                  |  14 +--
 rsvg_internals/src/filters/offset.rs               |   9 +-
 rsvg_internals/src/surface_utils/shared_surface.rs |  25 +++-
 14 files changed, 178 insertions(+), 130 deletions(-)

commit 0e343e8e297522776bd65949d49717ab7c1094b6
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 30 12:02:08 2018 +0300

    Remove unused line from image.rs

 rsvg_internals/src/image.rs | 1 -
 1 file changed, 1 deletion(-)

commit ed37e893b093a261e8ac6d0a4e2adc9375920e45
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 30 12:01:19 2018 +0300

    Rename affine to _affine in FilterContext
    
    Silence the unused warning for the time being. Not removing because it
    has a good comment and because it might be useful for filterRes
    eventually.

 rsvg_internals/src/filters/context.rs | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 3408974d7afd0e0645203b31eacbdd41f711e8e0
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 30 11:40:21 2018 +0300

    Refactor convolve_matrix to use the scale method

 rsvg_internals/src/filters/convolve_matrix.rs | 86 ++++++++-------------------
 1 file changed, 24 insertions(+), 62 deletions(-)

commit ac22549a1438d01ec58c611a4c335dc3c539bb48
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 30 11:39:38 2018 +0300

    Add SharedImageSurface::scale{,_to}()

 rsvg_internals/src/surface_utils/shared_surface.rs | 48 ++++++++++++++++++++++
 1 file changed, 48 insertions(+)

commit 9d5de12dfd8acb853dfa27de9d625338bad8bd85
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 30 11:39:04 2018 +0300

    Add IRect::scale()

 rsvg_internals/src/filters/context.rs | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit ca83a910739261e7407c377100ab09872e0ae123
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 30 11:16:59 2018 +0300

    Change assert! to assert_eq!

 rsvg_internals/src/filters/color_matrix.rs | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit fe08bb3e840636742003ffe68fda710086346c55
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 29 22:55:43 2018 +0300

    Fix alpha zero check in color_matrix

 rsvg_internals/src/filters/color_matrix.rs | 18 +++++++++++-------
 1 file changed, 11 insertions(+), 7 deletions(-)

commit f34c011cb8f82fb7c09d8ca5502dfa605f1b981d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 29 22:51:25 2018 +0300

    Fix error message in convolve_matrix

 rsvg_internals/src/filters/convolve_matrix.rs | 41 +++++++++++++++------------
 1 file changed, 23 insertions(+), 18 deletions(-)

commit f8d0308dc9b2e259c7b280ede42b87177dad7c30
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 28 23:04:03 2018 +0300

    Add unit tests for integer parsers

 rsvg_internals/src/parsers.rs | 38 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 38 insertions(+)

commit c3e9bb6289d125d64980aded1145857559ee2729
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 28 20:43:35 2018 +0300

    Port feConvolveMatrix

 Makefile.am                                        |   2 +-
 librsvg/filters/convolve_matrix.c                  | 372 -----------------
 rsvg_internals/src/filters/convolve_matrix.rs      | 442 +++++++++++++++++++++
 rsvg_internals/src/filters/ffi.rs                  |   1 +
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/load.rs                         |  14 +-
 tests/fixtures/reftests/filter-conv-bounds-ref.png | Bin 0 -> 937 bytes
 tests/fixtures/reftests/filter-conv-bounds.svg     |  36 ++
 .../reftests/svg1.1/filters-conv-01-f-ref.png      | Bin 0 -> 49867 bytes
 .../fixtures/reftests/svg1.1/filters-conv-01-f.svg | 112 ++++++
 .../reftests/svg1.1/filters-conv-02-f-ref.png      | Bin 0 -> 32837 bytes
 .../fixtures/reftests/svg1.1/filters-conv-02-f.svg |  77 ++++
 .../reftests/svg1.1/filters-conv-03-f-ref.png      | Bin 0 -> 27292 bytes
 .../fixtures/reftests/svg1.1/filters-conv-03-f.svg | 104 +++++
 .../reftests/svg1.1/filters-conv-04-f-ref.png      | Bin 0 -> 75850 bytes
 .../fixtures/reftests/svg1.1/filters-conv-04-f.svg | 163 ++++++++
 .../reftests/svg1.1/filters-conv-05-f-ref.png      | Bin 0 -> 9265 bytes
 .../fixtures/reftests/svg1.1/filters-conv-05-f.svg |  83 ++++
 .../reftests/svg1.1/images/DisplaceChecker.png     | Bin 0 -> 2470 bytes
 .../images/filters-conv-01-f.includeimage.png      | Bin 0 -> 9281 bytes
 .../reftests/svg1.1/images/purplesquidj.png        | Bin 0 -> 48672 bytes
 .../svg1.1/images/stefan_252_tRNS_opti.png         | Bin 0 -> 12777 bytes
 .../fixtures/reftests/svg1.1/images/townsville.jpg | Bin 0 -> 52480 bytes
 23 files changed, 1027 insertions(+), 380 deletions(-)

commit 5dc0cda524c2ca881c8d42cb6097f3df293b7086
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 28 20:42:52 2018 +0300

    Add the PixelRectangle iterator to surface_utils

 rsvg_internals/src/surface_utils/iterators.rs | 138 +++++++++++++++++++++++++-
 rsvg_internals/src/surface_utils/mod.rs       |  13 +++
 2 files changed, 150 insertions(+), 1 deletion(-)

commit cc367edd37b1a50f3fab4aa0ce8fa900dcad2282
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 28 20:42:05 2018 +0300

    Add parsers::integer{,-optional-integer}()

 rsvg_internals/src/parsers.rs | 37 +++++++++++++++++++++++++++++++++++++
 1 file changed, 37 insertions(+)

commit e0a853812fd14d1e2d721e9474f515ae725e6365
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 28 20:41:21 2018 +0300

    Fix <image> bbox once again

 rsvg_internals/src/image.rs | 19 +++++++++++--------
 1 file changed, 11 insertions(+), 8 deletions(-)

commit 0826dba5a270676dc8c6c3b15b497bc8227dc431
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 25 19:26:32 2018 +0300

    Port feColorMatrix

 Cargo.lock                                         |  56 ++++
 Makefile.am                                        |   2 +-
 librsvg/filters/color_matrix.c                     | 300 ---------------------
 rsvg_internals/Cargo.toml                          |   1 +
 rsvg_internals/src/filters/color_matrix.rs         | 263 ++++++++++++++++++
 rsvg_internals/src/filters/ffi.rs                  |   1 +
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/lib.rs                          |   3 +
 rsvg_internals/src/load.rs                         |  14 +-
 .../reftests/svg1.1/filters-color-01-b-ref.png     | Bin 0 -> 23085 bytes
 .../reftests/svg1.1/filters-color-01-b.svg         | 112 ++++++++
 11 files changed, 445 insertions(+), 308 deletions(-)

commit ab720bfeb73c0728faf7d6594f8201bf7890dc23
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 29 16:54:17 2018 -0500

    Use Rc::ptr_eq() instead of our own rc_node_ptr_eq()
    
    This is available since Rust 1.17.

 rsvg_internals/src/drawing_ctx.rs |  9 +++++----
 rsvg_internals/src/node.rs        | 21 ++++++---------------
 rsvg_internals/src/structure.rs   |  4 +++-
 3 files changed, 14 insertions(+), 20 deletions(-)

commit 04860e49038ac6a7f35a6b430d77122b1dee8a23
Merge: c3356745 18add6d1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 28 08:27:39 2018 -0500

    Merge branch 'pborelli/librsvg-font-size'

commit 18add6d1ff221a900d1eb34aeb3f4df0af126bc1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 28 08:27:10 2018 -0500

    rustfmt

 rsvg_internals/src/length.rs | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit d4bf550cd23349b8071bbfc03ec95e599ebc6e68
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Tue Jun 26 23:37:46 2018 +0200

    state: rework font size property
    
    Introduce a FontSizeSpec enum and remove special cases for fonts
    from RsvgLength

 rsvg_internals/src/length.rs | 246 ++++++++++++++++++++-----------------------
 rsvg_internals/src/state.rs  |  29 ++---
 2 files changed, 125 insertions(+), 150 deletions(-)

commit c335674596ed4629f38613887b2540a2e4326cc0
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 27 11:00:40 2018 -0500

    Require Rust 1.26

 .gitlab-ci.yml | 16 ----------------
 COMPILING.md   |  2 +-
 configure.ac   |  2 +-
 3 files changed, 2 insertions(+), 18 deletions(-)

commit 25cf1d8bd0ae9a8bb34fdd5b49d89c3a3f92cf6f
Merge: 88c8e6ca a0a36146
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Tue Jun 26 02:02:32 2018 +0000

    Merge branch 'draw' into 'master'
    
    move code to drawing ctx
    
    See merge request GNOME/librsvg!88

commit a0a361465094f7fa6e7020ad0655376816a572f6
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon Jun 25 23:11:44 2018 +0200

    shapes: move drawing of path builder here
    
    This gets rid of draw.rs

 Makefile.am                  |  1 -
 rsvg_internals/src/draw.rs   | 28 ----------------------------
 rsvg_internals/src/lib.rs    |  1 -
 rsvg_internals/src/shapes.rs | 14 ++++++++++++--
 4 files changed, 12 insertions(+), 32 deletions(-)

commit a4ffab2fa8ddc7165f44be768fb6ecb1be4a2890
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon Jun 25 23:05:55 2018 +0200

    drawing-ctx: move stroke_and_fill method to drawing ctx

 rsvg_internals/src/draw.rs        | 203 +-------------------------------------
 rsvg_internals/src/drawing_ctx.rs | 200 ++++++++++++++++++++++++++++++++++++-
 2 files changed, 199 insertions(+), 204 deletions(-)

commit 6e6ff754aeaf72a0ccc4320e9b2b6e21db6735b1
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon Jun 25 22:57:18 2018 +0200

    drawing-ctx: move draw_pango_layout to the drawing ctx

 rsvg_internals/src/draw.rs        | 161 +------------------------------------
 rsvg_internals/src/drawing_ctx.rs | 163 +++++++++++++++++++++++++++++++++++++-
 rsvg_internals/src/text.rs        |   5 +-
 3 files changed, 164 insertions(+), 165 deletions(-)

commit 79bf3349ab1e8faa8e558f70e153915b49933477
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat Jun 23 11:14:53 2018 +0200

    image: inline draw_surface
    
    This is the only caller and inlining makes things shorter since
    we can reuse the surface width etc

 rsvg_internals/src/draw.rs  | 70 ---------------------------------------------
 rsvg_internals/src/image.rs | 63 ++++++++++++++++++++++++++++++++++------
 2 files changed, 54 insertions(+), 79 deletions(-)

commit 981e2e20c6cf4965695e342fd708eade7b8a0b2b
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat Jun 23 11:01:38 2018 +0200

    drawing-ctx: move clip() method to the draw ctx
    
    Also move the set_affine_on_cr helper, for now it is public since
    other functions need it

 rsvg_internals/src/draw.rs        | 37 +++----------------------------------
 rsvg_internals/src/drawing_ctx.rs | 25 +++++++++++++++++++++++++
 rsvg_internals/src/image.rs       |  4 ++--
 rsvg_internals/src/marker.rs      |  5 ++---
 rsvg_internals/src/mask.rs        |  6 ++----
 rsvg_internals/src/viewport.rs    |  5 ++---
 6 files changed, 36 insertions(+), 46 deletions(-)

commit 88c8e6cab32f5f8d29332d57d93c33ab263e2edd
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 25 08:53:45 2018 -0500

    Cargo update

 Cargo.lock | 258 ++++++++++++++++++++++++++-----------------------------------
 1 file changed, 108 insertions(+), 150 deletions(-)

commit a5f49ae266a90b9cf97c64904e790f5873c341ba
Merge: 60f8afdf ac574324
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Mon Jun 25 13:29:44 2018 +0000

    Merge branch 'ignatenko/fix-build' into 'master'
    
    fix casting in filter_related()
    
    Closes #302
    
    See merge request GNOME/librsvg!87

commit ac5743244bd889c7596f53f0513cf645a682dcaa
Author: Igor Gnatenko <ignatenko@src.gnome.org>
Date:   Sun Jun 24 18:03:34 2018 +0200

    fix casting in filter_related()
    
    Fixes: https://gitlab.gnome.org/GNOME/librsvg/issues/302
    Signed-off-by: Igor Gnatenko <ignatenko@src.gnome.org>

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 rsvg_internals/src/filters/ffi.rs | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 60f8afdfe6c5b667c015b2124cd46fd1d5bb07ee
Author: Igor Gnatenko <i.gnatenko.brain@gmail.com>
Date:   Sun Jun 24 11:31:13 2018 +0000

    deps: bump regex to 1

 rsvg_internals/Cargo.toml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a55e422104fe60b3b33cee0dec59327e44ada962
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 21:23:49 2018 -0500

    .gitlab-ci.yml: Add rustc 1.26

 .gitlab-ci.yml | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 9c0af468078e1e230679751b03641c76b15b5218
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 20:13:30 2018 -0500

    Remove RsvgViewBox; return an additional gboolean from rsvg_node_svg_get_view_box()
    
    The only purpose of the "active" field in
    
        typedef struct {
            cairo_rectangle_t rect;
            gboolean active;
        } RsvgViewBox;
    
    was for rsvg_node_svg_get_view_box() to return whether the <svg>
    element actually had a viewBox attribute.  If not, the .rect was
    set to all-zeros.
    
    We get rid of this struct, and return a cairo_rectangle_t directly
    from that function plus an extra boolean.

 librsvg/rsvg-handle.c           | 21 ++++++++++++++++-----
 librsvg/rsvg-private.h          |  6 ------
 librsvg/rsvg-structure.h        |  8 ++++----
 rsvg_internals/src/lib.rs       |  2 --
 rsvg_internals/src/structure.rs | 30 ++++++++++++++++++++++++++++--
 rsvg_internals/src/viewbox.rs   | 33 ---------------------------------
 6 files changed, 48 insertions(+), 52 deletions(-)

commit c41384f3680c768990d681695ec590fee123bc0a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 15:03:35 2018 -0500

    configure.ac: Post-release version bump

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2c822d08197b06d24f869dab8f04f65f3aa38bd0
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 14:53:32 2018 -0500

    Update NEWS

 NEWS | 6 ++++++
 1 file changed, 6 insertions(+)

commit 2a03a221b03265c42db1d55f53dce5c92b00e2e3
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 14:29:37 2018 -0500

    rsvg-test.c: Don't leak the cwd

 tests/rsvg-test.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 2cccd100d1ebdd7b16dd4ec043fa6af7a4ea70de
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 14:17:54 2018 -0500

    sax_processing_instruction_cb(): Don't leak the pbag iterator

 librsvg/rsvg-load.c | 2 ++
 1 file changed, 2 insertions(+)

commit dca2e4f034be83f8ac293fb579cd936681307d2a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 13:49:00 2018 -0500

    draw_node_from_stack(): Ahem, make this work in the original way.
    
    What was I thinking?

 rsvg_internals/src/drawing_ctx.rs | 19 +++++++++++--------
 1 file changed, 11 insertions(+), 8 deletions(-)

commit b4283ff083e0105b5fc8a8bee5290e0d8ec2eb37
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 13:18:52 2018 -0500

    is_cairo_context_nested(): Oops, the condition was backwards.

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a9ebc8c77c35811d77a252bda50dce9461e1cad8
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 13:13:07 2018 -0500

    drawing_ctx.rs: Restore the original behavior of the cr_stack

 rsvg_internals/src/drawing_ctx.rs | 10 +++-------
 1 file changed, 3 insertions(+), 7 deletions(-)

commit d35aa27992593e8074af3db5aea503784a6d96ce
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 12:39:21 2018 -0500

    rsvg_drawing_ctx_new() - fix the type of the cr argument

 rsvg_internals/src/drawing_ctx.rs | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 347c83afdec06fb00fcf3516258e16d7e7b6ff47
Merge: b982ccc4 e915da09
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 22 12:33:54 2018 -0500

    Merge branch 'master' into drawing-ctx-wip
    
    Basically, this adds a draw_ctx argument to all the filter functions,
    instead of keeping it in FilterContext.

commit e915da0935c8351d28a479520621561e49924662
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 22 13:40:31 2018 +0300

    Remove {un,}linearization boilerplate

 rsvg_internals/src/filters/blend.rs                |  57 ++++--------------
 rsvg_internals/src/filters/bounds.rs               |  20 ++-----
 rsvg_internals/src/filters/component_transfer.rs   |  29 ++-------
 rsvg_internals/src/filters/composite.rs            |  62 +++++---------------
 rsvg_internals/src/filters/context.rs              |  61 ++++++++++++++++++-
 rsvg_internals/src/filters/ffi.rs                  |  65 +++++++++++++++++----
 rsvg_internals/src/filters/flood.rs                |   5 ++
 rsvg_internals/src/filters/image.rs                |   5 ++
 rsvg_internals/src/filters/merge.rs                |  59 +++++++------------
 rsvg_internals/src/filters/mod.rs                  |  15 +++--
 rsvg_internals/src/filters/offset.rs               |   5 ++
 rsvg_internals/src/surface_utils/shared_surface.rs |  22 +++++++
 ...r-composite-color-interpolation-filters-ref.png | Bin 7951 -> 7948 bytes
 .../reftests/svg1.1/filters-composite-02-b-ref.png | Bin 15918 -> 15917 bytes
 .../reftests/svg1.1/filters-image-04-f-ref.png     | Bin 12642 -> 12582 bytes
 15 files changed, 220 insertions(+), 185 deletions(-)

commit 2391a7444c19372c470ff12bb89f2e7dce92459b
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 22 00:31:46 2018 +0300

    Implement color-interpolation-filters

 librsvg/rsvg-attributes.h                          |   1 +
 rsvg_internals/build.rs                            |   1 +
 rsvg_internals/src/filters/blend.rs                |  53 +++++++++++++----
 rsvg_internals/src/filters/component_transfer.rs   |  24 ++++++--
 rsvg_internals/src/filters/composite.rs            |  58 ++++++++++++------
 rsvg_internals/src/filters/merge.rs                |  37 +++++++++---
 rsvg_internals/src/state.rs                        |  21 +++++++
 .../reftests/bugs/241-light-source-type-ref.png    | Bin 3983 -> 4044 bytes
 .../fixtures/reftests/bugs/282-drop-shadow-ref.png | Bin 1699 -> 1726 bytes
 ...r-composite-color-interpolation-filters-ref.png | Bin 0 -> 7951 bytes
 ...ilter-composite-color-interpolation-filters.svg |  65 +++++++++++++++++++++
 .../reftests/svg1.1/filters-composite-04-f-ref.png | Bin 114677 -> 114495 bytes
 .../reftests/svg1.1/filters-composite-05-f-ref.png | Bin 33559 -> 29869 bytes
 13 files changed, 216 insertions(+), 44 deletions(-)

commit 438abbef4cca5c6cfde930d92e6029e072f56d3c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 21 19:33:30 2018 +0300

    Remove an extra inline(always)

 rsvg_internals/src/surface_utils/shared_surface.rs | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit 7af338291d9ca1d364e040296bf36fc79f47bf33
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 21 17:27:28 2018 +0300

    Enable LTO in benchmarks

 Cargo.toml | 3 +++
 1 file changed, 3 insertions(+)

commit 6707da825b12b82ebce3072fbe60c2f4c100812c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 21 17:15:16 2018 +0300

    Add a comment on channelmap

 rsvg_internals/src/filters/context.rs | 1 +
 1 file changed, 1 insertion(+)

commit c84014cba2b3c13f0c505d45841c2a819600feba
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 21 16:56:31 2018 +0300

    Change ImageSurfaceDataShared to a safe version

 Makefile.am                                        | 124 ++++-----
 librsvg/filters/color_matrix.c                     |   1 -
 librsvg/filters/convolve_matrix.c                  |   1 -
 librsvg/filters/diffuse_lighting.c                 |   1 -
 librsvg/filters/displacement_map.c                 |   1 -
 librsvg/filters/erode.c                            |   1 -
 librsvg/filters/gaussian_blur.c                    |   1 -
 librsvg/filters/specular_lighting.c                |   1 -
 librsvg/filters/tile.c                             |   1 -
 librsvg/filters/turbulence.c                       |   1 -
 rsvg_internals/benches/pixel_iterators.rs          |  10 +-
 rsvg_internals/src/filters/blend.rs                |  30 ++-
 rsvg_internals/src/filters/component_transfer.rs   |  21 +-
 rsvg_internals/src/filters/composite.rs            |  28 +-
 rsvg_internals/src/filters/context.rs              |  79 +++---
 rsvg_internals/src/filters/ffi.rs                  |  19 +-
 rsvg_internals/src/filters/flood.rs                |   7 +-
 rsvg_internals/src/filters/image.rs                |  19 +-
 rsvg_internals/src/filters/iterators.rs            | 288 ---------------------
 rsvg_internals/src/filters/merge.rs                |   8 +-
 rsvg_internals/src/filters/mod.rs                  |   1 -
 rsvg_internals/src/filters/offset.rs               |  31 ++-
 rsvg_internals/src/lib.rs                          |   1 +
 rsvg_internals/src/srgb.rs                         |  26 +-
 rsvg_internals/src/surface_utils/iterators.rs      | 142 ++++++++++
 rsvg_internals/src/surface_utils/mod.rs            |  33 +++
 rsvg_internals/src/surface_utils/shared_surface.rs | 139 ++++++++++
 27 files changed, 532 insertions(+), 483 deletions(-)

commit b982ccc4b5cd7912b3d06767e61f345242760b3b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 19:22:40 2018 -0500

    draw_node_from_stack(): Don't use an anonymous function helper

 rsvg_internals/src/drawing_ctx.rs | 19 ++++++++++---------
 1 file changed, 10 insertions(+), 9 deletions(-)

commit 8b464fb9cae3cd797ad0feb46958522d79700d2e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 19:18:37 2018 -0500

    impl Drop for AcquiredNode: Fix mutability

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1e101c79b3a33bece95e08256c031b8fe3c851c7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 19:17:42 2018 -0500

    add_node_and_ancestors_to_stack(): Fix mutability

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3e99ac5ad690a091121d6d40a82dac98ca36d884
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 19:15:51 2018 -0500

    link.rs: Remove the with_tag() convenience function; use the primitives
    
    This is to avoid funky closure and borrows.

 rsvg_internals/src/link.rs | 22 +++++-----------------
 1 file changed, 5 insertions(+), 17 deletions(-)

commit 1fe859986c0224ae36ac3f6db7686fad77e73842
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 19:10:53 2018 -0500

    Don't keep a &DrawingCtx in FilterContext; pass it around to filter render functions
    
    This changes a lot of code, because all filter rendering functions now
    take a &mut DrawingCtx as an argument.  This not only makes them
    consistent with the normal node rendering functions, but it lets us
    avoid double mutable borrows if the draw_ctx needed to be kept in the
    FilterContext.

 librsvg/filters/color_matrix.c                   |   9 +-
 librsvg/filters/common.c                         |  60 --------
 librsvg/filters/common.h                         |  42 ++----
 librsvg/filters/convolve_matrix.c                |   9 +-
 librsvg/filters/diffuse_lighting.c               |  15 +-
 librsvg/filters/displacement_map.c               |  12 +-
 librsvg/filters/erode.c                          |  10 +-
 librsvg/filters/gaussian_blur.c                  |  10 +-
 librsvg/filters/specular_lighting.c              |  15 +-
 librsvg/filters/tile.c                           |  10 +-
 librsvg/filters/turbulence.c                     |  10 +-
 rsvg_internals/src/drawing_ctx.rs                |  13 +-
 rsvg_internals/src/filters/blend.rs              |  14 +-
 rsvg_internals/src/filters/bounds.rs             |  15 +-
 rsvg_internals/src/filters/component_transfer.rs |  16 +-
 rsvg_internals/src/filters/composite.rs          |  14 +-
 rsvg_internals/src/filters/context.rs            | 178 +++++++----------------
 rsvg_internals/src/filters/ffi.rs                |   7 +-
 rsvg_internals/src/filters/flood.rs              |  10 +-
 rsvg_internals/src/filters/image.rs              |  30 ++--
 rsvg_internals/src/filters/merge.rs              |  22 ++-
 rsvg_internals/src/filters/mod.rs                |  12 +-
 rsvg_internals/src/filters/offset.rs             |  16 +-
 rsvg_internals/src/lib.rs                        |   6 -
 rsvg_internals/src/structure.rs                  |   6 +-
 25 files changed, 248 insertions(+), 313 deletions(-)

commit 90b3682b7bcde2bff774df1096dedd62536cf14b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 17:38:13 2018 -0500

    DrawingCtx.get_cr_stack() doesn't need a mutable ctx

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ffabcab24af831da4dd2b856105094c51010e221
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 17:37:29 2018 -0500

    DrawCtx is always mutable in the filter context

 rsvg_internals/src/filters/context.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 62872747f027bd52622b8c150fa1e52f4f0023d9
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 17:35:12 2018 -0500

    Clone a bbox to avoid causing a borrow

 rsvg_internals/src/filters/context.rs | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 8b37a31140a21c9104e2357b87deb1c16125adae
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 17:27:47 2018 -0500

    Use a RefCell for the vector of acquired nodes
    
    get_acquired_node() is essentially a "give me a reference to a node",
    with some runtime checking underneath.  Having AcquiredNode hold a
    mutable reference to its parent DrawingCtx is highly inconvenient.
    This calls for some interior mutability in DrawingCtx just for the
    vector of acquired_nodes, so we use a RefCell.
    
    Also, have AcquiredNode store a pointer to that RefCell, so that it
    doesn't cause a borrow on the whole DrawingCtx.  This is unsafe, so
    "impl Drop for AcquiredNode" has a little unsafe code.  Let's see if
    we can refactor this in the future.

 rsvg_internals/src/drawing_ctx.rs | 24 ++++++++++++++----------
 rsvg_internals/src/gradient.rs    |  2 +-
 2 files changed, 15 insertions(+), 11 deletions(-)

commit ffc59ceeeda38f0057b0e34f76b75ad619189bbc
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 17:21:16 2018 -0500

    Store RsvgNode in draw_ctx.acquired_nodes, not pointers to RsvgNode
    
    They are Rc<Node> anyway; we can just have extra refs there.

 rsvg_internals/src/drawing_ctx.rs | 19 +++++++++++--------
 1 file changed, 11 insertions(+), 8 deletions(-)

commit 10f51674c59d76590483fe9bedf638039f345a36
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 17:07:34 2018 -0500

    Compute effects region in a way to not cause a double mutable borrow

 rsvg_internals/src/filters/context.rs | 18 ++++++++++--------
 1 file changed, 10 insertions(+), 8 deletions(-)

commit 3156161bee3706496d387eaecd17940816487e9a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 17:05:12 2018 -0500

    Clone the draw_ctx's bbox so the ctx doesn't get borrowed

 rsvg_internals/src/filters/context.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f662bd13d00a2caadd8a9fa10b45768490bd90fc
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 08:51:36 2018 -0500

    CONTRIBUTING.md: Note on formatting commit messages

 CONTRIBUTING.md | 28 ++++++++++++++++++++++++++++
 1 file changed, 28 insertions(+)

commit 17f9a16736d5d4c4a40f2d4d47963c45b38be44e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 21 08:42:19 2018 -0500

    (#292): Don't panic if we try to clip with an empty bounding box
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/292

 rsvg_internals/src/clip_path.rs                      |  6 ++++++
 tests/fixtures/render-crash/292-clip-empty-group.svg | 11 +++++++++++
 2 files changed, 17 insertions(+)

commit 603b29f2ae110dcc9f3c02bc77aa58b0044236cf
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Wed Jun 20 22:50:12 2018 +0200

    drawing_ctx: pass the context to the draw callback

 rsvg_internals/src/drawing_ctx.rs | 15 ++++++---------
 rsvg_internals/src/image.rs       |  6 +++---
 rsvg_internals/src/link.rs        |  8 ++++----
 rsvg_internals/src/marker.rs      |  4 ++--
 rsvg_internals/src/mask.rs        |  4 ++--
 rsvg_internals/src/pattern.rs     |  4 ++--
 rsvg_internals/src/shapes.rs      |  4 ++--
 rsvg_internals/src/structure.rs   | 20 ++++++++++----------
 rsvg_internals/src/text.rs        |  4 ++--
 rsvg_internals/src/viewport.rs    | 22 +++++++++++-----------
 10 files changed, 44 insertions(+), 47 deletions(-)

commit b054df6f56da80fcdd23754ca5b0f9ec2d8f8745
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Tue Jun 19 00:31:37 2018 +0200

    bbox: remove the C export

 librsvg/rsvg-private.h     | 25 -------------
 rsvg_internals/src/bbox.rs | 90 ----------------------------------------------
 rsvg_internals/src/lib.rs  | 10 ------
 3 files changed, 125 deletions(-)

commit 0ccc1d872537c56cdca5815954b71099784c83e2
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat Jun 16 13:16:13 2018 +0200

    wip: try to port drawing_ctx to rust

 Makefile.am                           |   2 -
 doc/Makefile.am                       |   2 -
 librsvg/filters/color_matrix.c        |   1 -
 librsvg/filters/common.c              |   1 -
 librsvg/filters/convolve_matrix.c     |   1 -
 librsvg/filters/diffuse_lighting.c    |   1 -
 librsvg/filters/displacement_map.c    |   1 -
 librsvg/filters/erode.c               |   1 -
 librsvg/filters/gaussian_blur.c       |   1 -
 librsvg/filters/light_source.c        |   1 -
 librsvg/filters/specular_lighting.c   |   1 -
 librsvg/filters/tile.c                |   1 -
 librsvg/filters/turbulence.c          |   1 -
 librsvg/rsvg-drawing-ctx.c            | 405 ---------------
 librsvg/rsvg-drawing-ctx.h            | 170 -------
 librsvg/rsvg-handle.c                 |   1 -
 librsvg/rsvg-private.h                |  32 ++
 rsvg_internals/src/clip_path.rs       |  12 +-
 rsvg_internals/src/draw.rs            |  38 +-
 rsvg_internals/src/drawing_ctx.rs     | 917 +++++++++++++++-------------------
 rsvg_internals/src/filters/bounds.rs  |   2 +-
 rsvg_internals/src/filters/context.rs |  64 ++-
 rsvg_internals/src/filters/ffi.rs     |   7 +-
 rsvg_internals/src/filters/image.rs   |  23 +-
 rsvg_internals/src/gradient.rs        |  30 +-
 rsvg_internals/src/image.rs           |   6 +-
 rsvg_internals/src/length.rs          |  16 +-
 rsvg_internals/src/lib.rs             |   3 +-
 rsvg_internals/src/link.rs            |   8 +-
 rsvg_internals/src/marker.rs          |  23 +-
 rsvg_internals/src/mask.rs            |  40 +-
 rsvg_internals/src/node.rs            |  20 +-
 rsvg_internals/src/paint_server.rs    |  23 +-
 rsvg_internals/src/pattern.rs         |  33 +-
 rsvg_internals/src/shapes.rs          |  20 +-
 rsvg_internals/src/structure.rs       |  33 +-
 rsvg_internals/src/text.rs            |  53 +-
 rsvg_internals/src/viewport.rs        |  19 +-
 38 files changed, 680 insertions(+), 1333 deletions(-)

commit d8db0bc69a24da0c1b29e7ba112071571003d49a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 20 17:14:27 2018 -0500

    Update NEWS

 NEWS | 1 +
 1 file changed, 1 insertion(+)

commit 2305c86ce450f39b1b137d1ffc52ad29bb24aeed
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 20 17:12:17 2018 -0500

    (#259): Make test fonts work for installed tests
    
    Don't hardcode the font locations based on the SRCDIR; actually
    compute their locations with g_test_build_filename().
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/259

 librsvg/rsvg-base.c | 16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

commit 70cba3fd95b07f96249f8a1991fd2ed281791dec
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Wed Jun 20 22:56:18 2018 +0200

    image: remove unneeded cairo_save/restore
    
    draw_surface already does it

 rsvg_internals/src/image.rs | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

commit 3541e1dcfaf4e31195a75cdea8183c68d0354fd0
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 20 16:53:42 2018 -0500

    Update NEWS

 NEWS | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

commit bba52cb0da052b0fc8c7ecb4ae6f0b10075be52d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 19:09:24 2018 -0500

    with_discrete_layer(): Use IRI::get() on the IRI fields for less verbosity

 rsvg_internals/src/drawing_ctx.rs | 65 +++++++++++++++------------------------
 1 file changed, 24 insertions(+), 41 deletions(-)

commit dde7ab49e95195de0f149fe28c4f0c89f9dbccd5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 19:04:58 2018 -0500

    IRI::get() - new method

 rsvg_internals/src/iri.rs | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 0c882eb6b9cf497a5a69fc4d2c52aa5546728a3a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 18:59:04 2018 -0500

    with_discrete_layer(): No need to restore the original_cr's matrix
    
    Since we are doing save()/restore() on that original_cr.

 rsvg_internals/src/drawing_ctx.rs | 2 --
 1 file changed, 2 deletions(-)

commit af2ccff4b903fe6ba0371e7ca7bba5567f342157
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 18:57:55 2018 -0500

    with_discrete_layer(): We know that we can go back to the original_cr; don't re-fetch it

 rsvg_internals/src/drawing_ctx.rs | 16 +++++++---------
 1 file changed, 7 insertions(+), 9 deletions(-)

commit 2eb7a75f8b9e90846f04bed73c26aab9f146d6e7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 18:52:51 2018 -0500

    with_discrete_layer(): Replace a chain of "else" with .or()

 rsvg_internals/src/drawing_ctx.rs | 79 ++++++++++++++++++++-------------------
 1 file changed, 41 insertions(+), 38 deletions(-)

commit cc4f961e4d6c9477a3e2be50262926ed58130572
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 18:26:59 2018 -0500

    with_discrete_layer(): Better identify the intermediate surface and its cr

 rsvg_internals/src/drawing_ctx.rs | 72 +++++++++++++++++++++------------------
 1 file changed, 38 insertions(+), 34 deletions(-)

commit 28f70e671a4552f0ace70ff1156fe497fc2ec169
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 18:14:17 2018 -0500

    with_discrete_layer(): Factor out the needs_temporary_surface computation

 rsvg_internals/src/drawing_ctx.rs | 15 +++++----------
 1 file changed, 5 insertions(+), 10 deletions(-)

commit 4b85731c814d658202de03c5a9c265030a55b56f
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 17:59:51 2018 -0500

    with_discrete_layer(): Refactor obtaining the clip node and clip units

 rsvg_internals/src/drawing_ctx.rs | 39 ++++++++++++++++++++-------------------
 1 file changed, 20 insertions(+), 19 deletions(-)

commit 8d7030936c3d00030c7887839e56b6142f8e7d85
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 17:36:17 2018 -0500

    with_discrete_layer(): Don't acquire the clip_node more than once

 rsvg_internals/src/drawing_ctx.rs | 50 +++++++++++++--------------------------
 1 file changed, 16 insertions(+), 34 deletions(-)

commit 4e243cc78494eb83b01402de49e9d7935537d5fb
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 17:27:42 2018 -0500

    with_discrete_layer(): Rename clip_uri variable

 rsvg_internals/src/drawing_ctx.rs | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 2c0b979a18502ab9c30e78efe584897d6c9331bb
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 16:26:10 2018 -0500

    with_discrete_layer(): Don't bind the same variables twice

 rsvg_internals/src/drawing_ctx.rs | 21 ---------------------
 1 file changed, 21 deletions(-)

commit 578fda3b1d8ffe29608ee2f48b32a7b6f25a45c0
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 16:23:33 2018 -0500

    with_discrete_layer(): Reduce the number of times we re-get the original cr

 rsvg_internals/src/drawing_ctx.rs | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit 5e2b5b09813afde7a501132ca79e195ea68a42a4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 16:19:25 2018 -0500

    with_discrete_layer(): Don't have two huge if's, just a single one

 rsvg_internals/src/drawing_ctx.rs | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit ea97d13c26c172ca7422c0c8b892183e941eb708
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 16:04:25 2018 -0500

    push/pop_render_stack(): Removed; inlined them in with_discrete_layer()
    
    Now we can begin to clean up this mess.

 rsvg_internals/src/drawing_ctx.rs | 435 +++++++++++++++++++-------------------
 1 file changed, 215 insertions(+), 220 deletions(-)

commit d6537fd609426d3fc452f5f2cb878a420d0d7be4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 15:51:29 2018 -0500

    pop_render_stack(): Get the child_cr closer to where it is used

 rsvg_internals/src/drawing_ctx.rs | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 15b166da577288f71d0193f1f3a78e2a50c5eef6
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 15:47:07 2018 -0500

    push/pop_discrete_layer(): Removed - inline them in with_discrete_layer()

 rsvg_internals/src/drawing_ctx.rs | 17 ++---------------
 1 file changed, 2 insertions(+), 15 deletions(-)

commit 85382b299a1a2ba07992da6503022ef4c6902b19
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 15:46:02 2018 -0500

    pattern.rs: Use with_discrete_layer()

 rsvg_internals/src/pattern.rs | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 016778ab616ef46d42e21ed148732654e8b8d8ec
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 15:43:40 2018 -0500

    viewport.rs: use with_discrete_layer()

 rsvg_internals/src/structure.rs |  4 +--
 rsvg_internals/src/viewport.rs  | 63 ++++++++++++++++++++---------------------
 2 files changed, 33 insertions(+), 34 deletions(-)

commit 132fa2ee2147f619acf4db52f58e96c690a2cc0f
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 15:41:54 2018 -0500

    draw_in_viewport(): Take a draw_fn: &mut FnMut, similar to with_discrete_layer()

 rsvg_internals/src/structure.rs | 4 ++--
 rsvg_internals/src/viewport.rs  | 8 +++-----
 2 files changed, 5 insertions(+), 7 deletions(-)

commit 81b118e915d319fbf1c5fe1b2b4a1b1dace8beb9
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 15:38:19 2018 -0500

    viewport.rs: Inline everything into draw_in_viewport(); remove the tests (!)
    
    The trait we used for mocking the RsvgDrawingCtx in the tests was
    playing badly with the efforts to replace push/pop_discrete_layer()
    with a single with_discrete_layer() function.
    
    In the end I want to move to a model where RsvgDrawingCtx isn't
    essentially a globally mutable mess, and intead functions pass around
    a current Viewport that knows how to expose a cairo::Context and
    things like the viewport size.
    
    The tests here are removed, but they were essentially testing that we
    call preserve_aspect_ratio() with the correct values.  I hope to have
    more fine-grained tests in the future.

 rsvg_internals/src/viewport.rs | 266 ++---------------------------------------
 1 file changed, 11 insertions(+), 255 deletions(-)

commit 857e65773a7516eb7c539dba754d9ddad8f117e7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 15:31:30 2018 -0500

    viewport.rs: Simplify setting the clip rectangle for ClipToViewport

 rsvg_internals/src/viewport.rs | 13 +++++--------
 1 file changed, 5 insertions(+), 8 deletions(-)

commit 9a7ee576e2078d131d5b210f38f49d9c3df293a6
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 19 11:56:13 2018 -0500

    with_discrete_layer(): take a &mut FnMut
    
    Thanks to Ivan Molodetskikh for the tip!

 rsvg_internals/src/drawing_ctx.rs | 8 +++-----
 rsvg_internals/src/image.rs       | 2 +-
 rsvg_internals/src/link.rs        | 2 +-
 rsvg_internals/src/marker.rs      | 2 +-
 rsvg_internals/src/mask.rs        | 2 +-
 rsvg_internals/src/shapes.rs      | 2 +-
 rsvg_internals/src/structure.rs   | 6 +++---
 rsvg_internals/src/text.rs        | 2 +-
 8 files changed, 12 insertions(+), 14 deletions(-)

commit 4176bd7e99b46bbe6e067cc88e33b41df87f4b41
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Tue Jun 19 00:19:40 2018 +0200

    drawing_ctx: add ink_rect getter
    
    This removes the last use of RsvgBbox outside drawing_ctx

 librsvg/rsvg-drawing-ctx.h        |  4 ++++
 librsvg/rsvg-handle.c             |  8 ++------
 rsvg_internals/src/drawing_ctx.rs | 17 +++++++++++++++++
 rsvg_internals/src/lib.rs         |  1 +
 4 files changed, 24 insertions(+), 6 deletions(-)

commit 01d789e6000a4dcde0d918607e34998d11367672
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon Jun 18 23:21:05 2018 +0200

    bbox: add with_extents method
    
    Similar to with_rect and removes the only place (from a quick look)
    where we assign bbox rect/ink_rect from outside

 rsvg_internals/src/bbox.rs | 19 +++++++++++++++++++
 rsvg_internals/src/draw.rs | 30 ++++--------------------------
 2 files changed, 23 insertions(+), 26 deletions(-)

commit d03a084b11f561c6fc038f73da2bad5f93876cdd
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 18 18:11:06 2018 -0500

    mask.rs: Use with_discrete_layer()

 rsvg_internals/src/mask.rs | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 6673b9060b2da6189b574d2c7ca1b6f3b519c58d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 18 18:08:05 2018 -0500

    link.rs: Use with_discrete_layer()

 rsvg_internals/src/link.rs | 36 +++++++++++++++++-------------------
 1 file changed, 17 insertions(+), 19 deletions(-)

commit 74e36e9e155028dd97a44debd3319fed6a19b558
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 18 18:06:08 2018 -0500

    text.rs: Use with_discrete_layer() - now it needs an FnMut

 rsvg_internals/src/drawing_ctx.rs |  4 ++--
 rsvg_internals/src/text.rs        | 12 +++++-------
 2 files changed, 7 insertions(+), 9 deletions(-)

commit 6ffef4b511041a93a95672f8aa28d58c56a40803
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 18 16:12:16 2018 -0500

    marker.rs: Use with_discrete_layer()

 rsvg_internals/src/marker.rs | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 7698863412f4f78fb0442c7c8177695697075810
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 18 09:34:02 2018 -0500

    structure.rs: Use with_discrete_layer()

 rsvg_internals/src/structure.rs | 46 +++++++++++++++++++----------------------
 1 file changed, 21 insertions(+), 25 deletions(-)

commit ef85b04dadcb938fa4aea40068850ff7ae63beec
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 18 09:30:14 2018 -0500

    shapes.rs: Use with_discrete_layer()

 rsvg_internals/src/shapes.rs | 8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit fd3258f9c757e66ea5ed691e162b69f9a6e1b717
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 18 09:23:34 2018 -0500

    drawing_ctx::with_discrete_layer() - New function, will replace push/pop
    
    We will move to a model where instead of push/pop actions for
    different kinds of things, we have either do_something_with(lambda function),
    or a scope-based object.

 rsvg_internals/src/drawing_ctx.rs | 16 ++++++++++++++++
 rsvg_internals/src/image.rs       | 37 +++++++++++++++++--------------------
 2 files changed, 33 insertions(+), 20 deletions(-)

commit 162a702aa7fc9d2d96be388927404cab1388db88
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 21:36:36 2018 -0500

    draw_children(): Remove the node argument; it's unused now

 rsvg_internals/src/clip_path.rs | 2 +-
 rsvg_internals/src/link.rs      | 4 ++--
 rsvg_internals/src/marker.rs    | 2 +-
 rsvg_internals/src/mask.rs      | 2 +-
 rsvg_internals/src/node.rs      | 1 -
 rsvg_internals/src/pattern.rs   | 2 +-
 rsvg_internals/src/structure.rs | 5 ++---
 7 files changed, 8 insertions(+), 10 deletions(-)

commit a4c81cf76c88e8fa73a2a175d7f22917119d4d7e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 21:33:37 2018 -0500

    Remove the with_layer argument throughout
    
    Specifically, this was used in draw_children to decide whether to
    push/pop a layer or not.
    
    It was true everywhere, except in the two callers to
    draw_in_viewport(), as that function already pushes a layer by itself.
    
    So, to remove this exception and the with_layer argument, we now
    explicitly push a layer wherever we need it.

 rsvg_internals/src/clip_path.rs   |  3 ++-
 rsvg_internals/src/drawing_ctx.rs |  2 +-
 rsvg_internals/src/image.rs       |  1 -
 rsvg_internals/src/link.rs        | 24 +++++++++---------------
 rsvg_internals/src/marker.rs      |  4 +++-
 rsvg_internals/src/mask.rs        |  4 +++-
 rsvg_internals/src/node.rs        | 16 +---------------
 rsvg_internals/src/pattern.rs     |  6 +++++-
 rsvg_internals/src/shapes.rs      |  6 ------
 rsvg_internals/src/structure.rs   | 15 ++++++++-------
 rsvg_internals/src/text.rs        |  1 -
 11 files changed, 32 insertions(+), 50 deletions(-)

commit f2670e226df2ab967fab85f101e79dc3828efc14
Merge: 5adc2b80 5eea1087
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Mon Jun 18 13:27:49 2018 +0000

    Merge branch 'drawing-ctx' into 'master'
    
    drawing_ctx: move add_node_and_ancestors to rust
    
    See merge request GNOME/librsvg!83

commit 5eea10873969149857afed6bf27d5aeba2717f88
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat Jun 16 14:41:12 2018 +0200

    drawing_ctx: move add_node_and_ancestors to rust
    
    This might seem a little bit odd, since it adds more code than
    it removes, but I want to try to push toward the goals of having
    drawing ctx C functions called only by drawing_ctx.rs.
    Beside iterating the ancestors in rust is not as trivial as it
    sounds...

 librsvg/rsvg-drawing-ctx.c        | 11 ++---------
 librsvg/rsvg-drawing-ctx.h        |  7 ++++++-
 librsvg/rsvg-handle.c             |  4 +++-
 rsvg_internals/src/drawing_ctx.rs | 25 +++++++++++++++++++++++++
 rsvg_internals/src/lib.rs         |  1 +
 5 files changed, 37 insertions(+), 11 deletions(-)

commit 5adc2b80d6ef2358e20ea7c6ff57d3b56b1f38a2
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 18 15:52:10 2018 +0300

    Don't truncate offsets in feOffset

 rsvg_internals/src/filters/offset.rs | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 109ec2a99fac34e9cff9b7ab47562f8e5faba64c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 18 15:49:16 2018 +0300

    Remove two obsolete functions

 rsvg_internals/src/lib.rs   |  2 --
 rsvg_internals/src/state.rs | 19 -------------------
 2 files changed, 21 deletions(-)

commit e0dbe0ce0d1a6bca0f2a46f618ef6a33cac2bb1f
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 16 15:45:20 2018 +0300

    Port feComponentTransfer to Rust

 Makefile.am                                        |   2 +-
 librsvg/filters/component_transfer.c               | 416 ---------------------
 rsvg_internals/src/filters/component_transfer.rs   | 397 ++++++++++++++++++++
 rsvg_internals/src/filters/ffi.rs                  |   1 +
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/load.rs                         |  48 ++-
 ...-component-transfer-from-reference-page-ref.png | Bin 0 -> 6956 bytes
 ...lter-component-transfer-from-reference-page.svg |  63 ++++
 .../reftests/svg1.1/filters-color-02-b-ref.png     | Bin 6047 -> 6455 bytes
 9 files changed, 494 insertions(+), 434 deletions(-)

commit eb08f4eb44a9ca64a4b003263f66f2bc42ad4de6
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 16 15:44:43 2018 +0300

    Add unbounded list size to parsers::number_list()

 rsvg_internals/src/parsers.rs | 48 +++++++++++++++++++++++++++++++++++--------
 1 file changed, 39 insertions(+), 9 deletions(-)

commit b0b8035fa64986b8528e4c849d9ee7e1b4a5aa68
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 16 15:44:26 2018 +0300

    Derive Clone on node::Children

 rsvg_internals/src/node.rs | 1 +
 1 file changed, 1 insertion(+)

commit cb37d0d4085375ee75023e19e39aca47112946f9
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 15 12:51:26 2018 +0300

    Port feBlend to Rust

 Makefile.am                                        |   2 +-
 librsvg/filters/blend.c                            | 285 ---------------------
 rsvg_internals/src/filters/blend.rs                | 146 +++++++++++
 rsvg_internals/src/filters/ffi.rs                  |   5 +-
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/load.rs                         |  10 +-
 .../reftests/svg1.1/filters-blend-01-b-ref.png     | Bin 0 -> 15246 bytes
 .../reftests/svg1.1/filters-blend-01-b.svg         | 108 ++++++++
 8 files changed, 262 insertions(+), 295 deletions(-)

commit 8ea9cdb53dfed57c0db93ef77e00b4535eddab1c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 15 12:35:42 2018 +0300

    Fix extends in draw_surface()

 rsvg_internals/src/draw.rs                         |  20 ++++++++++++++++++--
 .../reftests/svg1.1/filters-composite-04-f-ref.png | Bin 114631 -> 114677 bytes
 2 files changed, 18 insertions(+), 2 deletions(-)

commit 6ca08494520fc6387d9e4d22c37987fc6aaa251d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 19:57:52 2018 +0300

    Remake feOffset in terms of cairo

 rsvg_internals/src/filters/offset.rs | 47 ++++++++++++++++--------------------
 1 file changed, 21 insertions(+), 26 deletions(-)

commit 890ddedbe55731cec3528a2f359071aa47477d85
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 16:57:24 2018 +0300

    Refactor srgb::

 rsvg_internals/src/srgb.rs | 141 ++++++++++++++-------------------------------
 1 file changed, 42 insertions(+), 99 deletions(-)

commit 74240bc0b763a0dd5f29f16092cb78e683b33b4c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 16:56:46 2018 +0300

    Return cairo::Status error from ImgSurfDataShared

 rsvg_internals/src/filters/composite.rs | 10 ++++++++--
 rsvg_internals/src/filters/iterators.rs |  9 ++++-----
 rsvg_internals/src/filters/offset.rs    |  5 ++++-
 3 files changed, 16 insertions(+), 8 deletions(-)

commit 47e97965b185dfe414173cf390c0f98d9dacf59e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 16:41:50 2018 +0300

    ImageSurfaceDataShared::new => new_unchecked

 rsvg_internals/src/filters/composite.rs |  4 +--
 rsvg_internals/src/filters/context.rs   |  6 ++---
 rsvg_internals/src/filters/iterators.rs | 48 ++++++++++++++++++++++++++++++---
 rsvg_internals/src/filters/offset.rs    |  2 +-
 4 files changed, 51 insertions(+), 9 deletions(-)

commit ee69f9180d259be3b192ce00b0009e2a10c58251
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 16:04:46 2018 +0300

    Remove leftover rsvg_filter_render definition

 librsvg/rsvg-filter.h | 27 ---------------------------
 1 file changed, 27 deletions(-)

commit 3375aec2d6a4607246e9982afefcc336b190927c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 16:01:45 2018 +0300

    Port feFlood

 Makefile.am                         |   2 +-
 librsvg/filters/flood.c             | 127 ------------------------------------
 librsvg/rsvg-filter.h               |   2 -
 rsvg_internals/src/filters/ffi.rs   |   1 +
 rsvg_internals/src/filters/flood.rs |  89 +++++++++++++++++++++++++
 rsvg_internals/src/filters/mod.rs   |   1 +
 rsvg_internals/src/load.rs          |  10 +--
 7 files changed, 95 insertions(+), 137 deletions(-)

commit 291fab0d5e8096f46ee88fbf452183fc86e95e1e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 12:17:14 2018 +0300

    Make {get,set}_pixel() conformant to cairo specs

 rsvg_internals/src/filters/iterators.rs            |  23 +++---
 .../reftests/svg1.1/filters-composite-03-f-ref.png | Bin 0 -> 4325 bytes
 .../reftests/svg1.1/filters-composite-03-f.svg     |  91 +++++++++++++++++++++
 3 files changed, 103 insertions(+), 11 deletions(-)

commit 10151cbb80d7a71732f35969bfb98ec9f3632dfa
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 11:37:05 2018 +0300

    Implement FillPaint and StrokePaint

 rsvg_internals/src/filters/context.rs | 49 ++++++++++++++++++++++++++++++++---
 1 file changed, 46 insertions(+), 3 deletions(-)

commit 863d00439e57ae8052532ed8a7b83dc5b7c819a5
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat Jun 16 14:36:27 2018 +0200

    handle: factor out function

 librsvg/rsvg-handle.c | 42 ++++++++++++++++++++----------------------
 1 file changed, 20 insertions(+), 22 deletions(-)

commit a6a4b5d84d2caf45c8e595d8d137fc606bb5bc24
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat Jun 16 10:44:23 2018 +0200

    load: fix compiler warning

 librsvg/rsvg-load.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 953cd157c1af54d553276fef52253257e18f38cf
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 20:41:54 2018 -0500

    NodeUse: draw_in_viewport() already pushes a layer; no need to push another one

 rsvg_internals/src/structure.rs | 2 --
 1 file changed, 2 deletions(-)

commit 3aded2c4aa217657a50a6d16d4f176b996789e69
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 20:23:57 2018 -0500

    draw_node_from_stack(): Remove the with_layer argument; it was true in all callers.

 rsvg_internals/src/drawing_ctx.rs | 5 ++---
 rsvg_internals/src/node.rs        | 1 -
 rsvg_internals/src/structure.rs   | 2 --
 3 files changed, 2 insertions(+), 6 deletions(-)

commit bd1e1886503ccac47c692fe0480dc104d5124c17
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 20:17:28 2018 -0500

    Remove unused prototype

 librsvg/rsvg-private.h | 4 ----
 1 file changed, 4 deletions(-)

commit fd636d14b7864567dd5a1c9d8e84f42d33322e2c
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 20:15:25 2018 -0500

    marker.rs: Don't use a secondary cr; the layer is not pushed here yet

 rsvg_internals/src/marker.rs | 7 +------
 1 file changed, 1 insertion(+), 6 deletions(-)

commit 2bdabe3075e25be6bcc33f8ed73db9f9fcbc38e4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 20:13:25 2018 -0500

    marker.rs: Let our call to node.draw_children() push a layer itself

 rsvg_internals/src/marker.rs | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

commit 4afbf889884d263b1c3a9a878ffdf613ce5183f8
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 20:09:42 2018 -0500

    clip_path.rs: Let our call do draw_children push a layer - it will be a no-op because we are clipping

 rsvg_internals/src/clip_path.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 921b6fef9592bf13cabe3b38db40711b46830b97
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 20:07:11 2018 -0500

    pattern.rs: Let our call pattern_node.draw_children() push the layer; don't do it ourselves

 rsvg_internals/src/pattern.rs | 7 +------
 1 file changed, 1 insertion(+), 6 deletions(-)

commit 89df567bd3a2f5f08589168e4629390bd4e7c96d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 19:36:19 2018 -0500

    get_acquired_node_of_type() - take an Option<&str> to simplify some callers
    
    Some callers keep a node_id: Option<String>, which they later verify
    and acquire with something like
    
        if let Some(id) = node_id {
            if let Some(acquired) = get_acquired_node_of_type(..., id, ...) {
                ...
            }
        }
    
    Taking an Option<&str> lets us do this instead:
    
        if let Some(acquired) = get_acquired_node_of_type(..., node_id.map(String::as_ref)) {
            ....
        }

 rsvg_internals/src/drawing_ctx.rs | 91 ++++++++++++++++++++-------------------
 rsvg_internals/src/marker.rs      |  3 +-
 rsvg_internals/src/pattern.rs     | 27 +++++-------
 3 files changed, 60 insertions(+), 61 deletions(-)

commit abe58904ab153ff4e60d2f0df192291acaa4012a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 15 18:44:25 2018 -0500

    rsvg_drawing_ctx_pop_bounding_box(): Don't leak the old bbox

 librsvg/rsvg-drawing-ctx.c | 2 ++
 1 file changed, 2 insertions(+)

commit ac01a2e834506f2407ab0a8858da95507953f7ff
Merge: dea83940 5a59ebe9
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Fri Jun 15 02:35:45 2018 +0000

    Merge branch 'draw-ctx-rs' into 'master'
    
    Small draw ctx cleanup/rustification
    
    See merge request GNOME/librsvg!81

commit 5a59ebe9a3a795e71b508eb81fb573dc5693bda6
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Thu Jun 14 21:47:37 2018 +0200

    drawing_ctx: move get/remove_acquired_node to rust

 librsvg/rsvg-drawing-ctx.c        | 64 +++------------------------------------
 librsvg/rsvg-drawing-ctx.h        |  8 +++--
 rsvg_internals/src/defs.rs        | 12 ++++++++
 rsvg_internals/src/drawing_ctx.rs | 39 ++++++++++++++++++------
 4 files changed, 51 insertions(+), 72 deletions(-)

commit 1b9f3c9d56ad935ccdc6bb93727941196eb42dc1
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Thu Jun 14 21:04:22 2018 +0200

    drawing_ctx: refactor functions to manipulate list of acquired node

 librsvg/rsvg-drawing-ctx.c | 29 +++++++++++++++++++++++------
 1 file changed, 23 insertions(+), 6 deletions(-)

commit dea839408c4ba1dab7b9684c6460504425cf9a3d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 14 21:04:07 2018 -0500

    tests/Makefile.am: Also distribute svg1.1/images/*

 tests/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 7689c4fbdbad2dd5d2616a0db7987e4938aeb4be
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 14 11:26:43 2018 -0500

    Update NEWS

 NEWS | 6 ++++++
 1 file changed, 6 insertions(+)

commit 8d1cc37d3d046e7bca7f3c545563548a7da4f90a
Merge: 148070ab 76d5fdf5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu Jun 14 11:19:33 2018 -0500

    Merge branch 'YaLTeR/librsvg-filters-to-rust-4'

commit 76d5fdf50fe6f3d79be39114b1ac7249b845583a
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 14 09:51:27 2018 +0300

    Ensure width and height are >=0 in filters

 rsvg_internals/src/filters/mod.rs  | 12 +++++++-----
 rsvg_internals/src/filters/node.rs | 12 +++++++-----
 2 files changed, 14 insertions(+), 10 deletions(-)

commit 148070abe57d850a2afbda694db8dc9020234d73
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 20:06:34 2018 -0500

    Trait method Parse::parse() takes a cssparser now, not a &str
    
    We add a Parse::parse_str() default implementation, and use that
    where parse() was used previously.
    
    Removed make_property's newtype_from_str since I couldn't make it work
    by slicing a cssparser::Parser; instead, implement Parse for the inner
    type of the properties that were done that way, and use newtype_parse.

 rsvg_internals/src/aspect_ratio.rs      | 73 ++++++++++++++++-----------------
 rsvg_internals/src/color.rs             | 18 +++-----
 rsvg_internals/src/coord_units.rs       | 21 +++++-----
 rsvg_internals/src/filters/composite.rs |  6 +--
 rsvg_internals/src/filters/node.rs      |  8 ++--
 rsvg_internals/src/filters/offset.rs    |  4 +-
 rsvg_internals/src/gradient.rs          | 31 +++++++-------
 rsvg_internals/src/iri.rs               | 25 ++++++-----
 rsvg_internals/src/length.rs            | 58 ++++++++++++--------------
 rsvg_internals/src/marker.rs            | 44 ++++++++++----------
 rsvg_internals/src/mask.rs              |  4 +-
 rsvg_internals/src/node.rs              |  2 +-
 rsvg_internals/src/paint_server.rs      | 33 +++++++--------
 rsvg_internals/src/parsers.rs           | 42 ++++++++++++++++++-
 rsvg_internals/src/property_macros.rs   | 72 ++++----------------------------
 rsvg_internals/src/state.rs             | 66 +++++++++++++++--------------
 rsvg_internals/src/structure.rs         | 12 +++---
 rsvg_internals/src/transform.rs         | 11 ++---
 rsvg_internals/src/unitinterval.rs      | 32 +++++++--------
 rsvg_internals/src/viewbox.rs           | 23 +++++------
 rsvg_internals/src/viewport.rs          |  4 +-
 21 files changed, 272 insertions(+), 317 deletions(-)

commit 8c15c47d7368cb69c69b0d69191eb628b63a5486
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 18:57:26 2018 -0500

    cond.rs: Expose from_attribute() creators, not Parse implementations
    
    The conditional processing attributes are... attributes, not
    style properties.  So, don't implement the Parse trait for them, but
    expose them in another way instead.

 rsvg_internals/src/cond.rs | 57 +++++++++++++++++++---------------------------
 rsvg_internals/src/node.rs |  7 +++---
 2 files changed, 28 insertions(+), 36 deletions(-)

commit 24ce1f9dd5b33f2147d864aad4109e635c3dcab6
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 18:48:27 2018 -0500

    Test the full parser of Dasharray, not just the inner parser

 rsvg_internals/src/length.rs | 35 +++++++++++++++++++----------------
 1 file changed, 19 insertions(+), 16 deletions(-)

commit 07750841f627cd71f3b618fa5d001d036ca75047
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 18:43:05 2018 -0500

    parse_dash_array(): Take a cssparser, not a &str
    
    And make DashArray::parse() use cssparser as well.

 rsvg_internals/src/length.rs | 22 +++++++++++++---------
 1 file changed, 13 insertions(+), 9 deletions(-)

commit 5b7fcfcb8664db39b6e7bbd2d443fc7be064ad88
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 18:38:56 2018 -0500

    parse_dash_array(): Use cssparser

 rsvg_internals/src/length.rs | 86 +++++++++++++++++---------------------------
 1 file changed, 33 insertions(+), 53 deletions(-)

commit e9eb899a98d404e9ec5bc00246bb17d8d1119889
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 15:17:34 2018 -0500

    TextDecoration: parse using cssparser

 rsvg_internals/src/state.rs | 83 ++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 79 insertions(+), 4 deletions(-)

commit 900b5ac1d82fbcfff24bb94a829bc7b09c6bd3f7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 15:01:28 2018 -0500

    BaselineShift: parse with cssparser

 rsvg_internals/src/length.rs |  5 ++++-
 rsvg_internals/src/state.rs  | 38 ++++++++++++++++++++++++++++++++------
 2 files changed, 36 insertions(+), 7 deletions(-)

commit f211316bece39cd8de41fa79ba1aaa3ecd42f8a7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 13:54:15 2018 -0500

    filters::Input::parse() - implement as a standalone method, not a trait impl
    
    We are parsing the "in" or "in2" attribute of filter primitive
    elements, not a property.  So, don't impl Parse for Input.  This lets
    us parse simply without cssparser.

 rsvg_internals/src/filters/composite.rs |  2 +-
 rsvg_internals/src/filters/input.rs     | 18 ++++++++++--------
 rsvg_internals/src/filters/merge.rs     |  3 +--
 rsvg_internals/src/filters/mod.rs       |  2 +-
 4 files changed, 13 insertions(+), 12 deletions(-)

commit 77c605fe55e57528911ef5b611cce19fb6ae60e4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 13:24:43 2018 -0500

    marker.rs: parse MarkerOrient completely with cssparser; don't parse bits of the string by hand

 rsvg_internals/src/marker.rs | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit e228176ec46a0a2861bbd74fa4d4387ce76acebd
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 13:16:53 2018 -0500

    parsers::angle_degrees() - Take a cssparser, not a &str

 rsvg_internals/src/marker.rs  |  5 ++++-
 rsvg_internals/src/parsers.rs | 30 +++++++++++++++++-------------
 2 files changed, 21 insertions(+), 14 deletions(-)

commit 135db45682db232a42248c8b1a766f27de93f790
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 09:44:41 2018 -0500

    filters/composite.rs: Use a cssparser

 rsvg_internals/src/filters/composite.rs | 30 +++++++++++++++++++++---------
 1 file changed, 21 insertions(+), 9 deletions(-)

commit e0a8e83d21bfc3961f2569b3e8cf7387362f4379
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 09:20:00 2018 -0500

    make_property!() - Use a cssparser

 rsvg_internals/src/property_macros.rs | 26 +++++++++++++++++++++-----
 1 file changed, 21 insertions(+), 5 deletions(-)

commit 7d6441d04a7b1d782d09e5a1d6c28cc9085b5f0a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 09:13:50 2018 -0500

    parsers::number_list() - Take a Parser instead of a &str

 rsvg_internals/src/parsers.rs | 54 +++++++++++++++++++++++++------------------
 rsvg_internals/src/viewbox.rs |  6 ++++-
 2 files changed, 37 insertions(+), 23 deletions(-)

commit 700eda7c0df25f8a310f5dd62481731d2885d53d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 08:53:02 2018 -0500

    gradient.rs: Use a cssparser

 rsvg_internals/src/gradient.rs | 29 ++++++++++++++++++++---------
 1 file changed, 20 insertions(+), 9 deletions(-)

commit 5f7e03a89d3f6cbc73ac0b106288f0e931cff801
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 08:46:55 2018 -0500

    transform.rs: Use a cssparser from the toplevel impl Parse

 rsvg_internals/src/transform.rs | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 8f55b50f5cf7e419e92fb782581110e57361118c
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 08:43:55 2018 -0500

    color.rs: Don't inline the creation of a cssparser

 rsvg_internals/src/color.rs | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 853d040bf99b15c4c70d680602d20d177904afe8
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 12 18:48:22 2018 -0500

    MarkerUnits: use a cssparser

 rsvg_internals/src/marker.rs | 28 +++++++++++++++++++++-------
 1 file changed, 21 insertions(+), 7 deletions(-)

commit a5ce7ee25c00f65d17b23458b755dcf4e8b716af
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 12 18:39:41 2018 -0500

    AspectRatio: don't inline the creation of the Parser

 rsvg_internals/src/aspect_ratio.rs | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit ee38b6c6b3e8e49e21dd9befbe5e346f2c4e9877
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 12 18:12:20 2018 -0500

    CoordUnits: use a cssparser
    
    We'll refactor the Parse trait later.

 rsvg_internals/src/coord_units.rs | 29 ++++++++++++++++++++++-------
 1 file changed, 22 insertions(+), 7 deletions(-)

commit 4871bed5cbe6dd217db5eadbed6ca6ba95ec7b8c
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 22:18:45 2018 +0300

    Replace normalize_ignoring_units with get_unitless

 rsvg_internals/src/filters/context.rs | 20 ++++++--------------
 rsvg_internals/src/length.rs          | 23 +++++------------------
 2 files changed, 11 insertions(+), 32 deletions(-)

commit 7a5f661f8ab1a3ae79cf65eb46624c43f36dc548
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 22:13:38 2018 +0300

    Validate units in filter primitive attributes

 rsvg_internals/src/filters/mod.rs                  |  71 +++++++++++++++++----
 .../reftests/filter-effects-region-ref.png         | Bin 1640 -> 1659 bytes
 tests/fixtures/reftests/filter-effects-region.svg  |  11 ++++
 3 files changed, 68 insertions(+), 14 deletions(-)

commit 2f033a9be9534550817e8d61eda1b41aca9f9fac
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 21:54:34 2018 +0300

    Validate units in <filter> attributes

 rsvg_internals/src/filters/node.rs                 |  60 +++++++++++++++++----
 .../reftests/filter-effects-region-ref.png         | Bin 1636 -> 1640 bytes
 tests/fixtures/reftests/filter-effects-region.svg  |  14 ++++-
 3 files changed, 62 insertions(+), 12 deletions(-)

commit 66d4fd4283b6d605b0d84e2621cc96dd6d3b2c1e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 21:53:52 2018 +0300

    Refactor parse to parse{,_and_validate}

 rsvg_internals/src/clip_path.rs         |  4 +--
 rsvg_internals/src/filters/composite.rs |  4 +--
 rsvg_internals/src/filters/image.rs     |  3 +-
 rsvg_internals/src/filters/merge.rs     |  2 +-
 rsvg_internals/src/filters/mod.rs       | 14 +++-----
 rsvg_internals/src/filters/node.rs      | 25 ++++++--------
 rsvg_internals/src/gradient.rs          | 26 +++++++--------
 rsvg_internals/src/image.rs             | 17 +++++-----
 rsvg_internals/src/marker.rs            | 28 +++++++---------
 rsvg_internals/src/mask.rs              | 18 +++++-----
 rsvg_internals/src/parsers.rs           | 28 +++++++++++-----
 rsvg_internals/src/pattern.rs           | 24 +++++++-------
 rsvg_internals/src/shapes.rs            | 58 ++++++++++++++-------------------
 rsvg_internals/src/stop.rs              |  5 +--
 rsvg_internals/src/structure.rs         | 34 +++++++++----------
 rsvg_internals/src/text.rs              | 20 +++++-------
 16 files changed, 145 insertions(+), 165 deletions(-)

commit 36279792cb34f91cebbc862d3c50ec365a493116
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 21:50:54 2018 +0300

    Don't render filters if they are in error

 rsvg_internals/src/drawing_ctx.rs | 20 ++++++++++++--------
 rsvg_internals/src/filters/ffi.rs |  1 +
 2 files changed, 13 insertions(+), 8 deletions(-)

commit 48d6009876dd1e0871f372ce4f204103cdb4a9bc
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed Jun 13 11:07:49 2018 -0500

    rustfmt

 rsvg_internals/src/node.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f59801c24d44457c10b49262eec1b16bb52d967b
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 12:55:03 2018 +0300

    Remove leftover debug comment

 rsvg_internals/src/filters/bounds.rs | 2 --
 1 file changed, 2 deletions(-)

commit b28dc716c5359a1b3edb15af7356cb706b2924d8
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 12:21:36 2018 +0300

    Revert composite linearization fix

 rsvg_internals/src/filters/composite.rs            |  10 ++-
 .../reftests/bugs/241-light-source-type-ref.png    | Bin 4226 -> 3983 bytes
 .../reftests/svg1.1/filters-composite-04-f-ref.png | Bin 0 -> 114631 bytes
 .../reftests/svg1.1/filters-composite-04-f.svg     |  78 +++++++++++++++++++++
 .../reftests/svg1.1/filters-composite-05-f-ref.png | Bin 0 -> 33559 bytes
 .../reftests/svg1.1/filters-composite-05-f.svg     |  67 ++++++++++++++++++
 .../svg1.1/resources/stefan_252_tRNS_opti.png      | Bin 0 -> 12777 bytes
 tests/fixtures/reftests/svg1.1/resources/tree.jpg  | Bin 0 -> 66460 bytes
 8 files changed, 152 insertions(+), 3 deletions(-)

commit 89b3aad0f6a1db084e908fad78666aaa64278053
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 12:20:18 2018 +0300

    Fix bbox computation in draw_surface()

 rsvg_internals/src/draw.rs | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 1b524843dd559e00e132e8f524ec43c27e25a619
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 11:19:20 2018 +0300

    Rename new tests

 ...effects-region-ref.png => filter-effects-region-ref.png} | Bin
 ...-filter-effects-region.svg => filter-effects-region.svg} |   0
 ...age-ref.png => filter-image-from-reference-page-ref.png} | Bin
 ...erence-page.svg => filter-image-from-reference-page.svg} |   0
 .../{test-filter-offset-ref.png => filter-offset-ref.png}   | Bin
 .../reftests/{test-filter-offset.svg => filter-offset.svg}  |   0
 6 files changed, 0 insertions(+), 0 deletions(-)

commit 0a370f5a6d4d2390fbb500362a6dc2ab326a7939
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 11:14:43 2018 +0300

    Use correct CSS values in with_primitive_units()

 rsvg_internals/src/filters/context.rs                 |   5 ++---
 .../reftests/test-filter-effects-region-ref.png       | Bin 1624 -> 1636 bytes
 .../fixtures/reftests/test-filter-effects-region.svg  |  14 ++++++++++----
 3 files changed, 12 insertions(+), 7 deletions(-)

commit 62de56f91a43bad1f8e79169709aae373b294f72
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 11:06:44 2018 +0300

    Use correct CSS values in compute_effects_region()

 rsvg_internals/src/filters/context.rs                 |   7 ++++---
 .../reftests/test-filter-effects-region-ref.png       | Bin 1598 -> 1624 bytes
 .../fixtures/reftests/test-filter-effects-region.svg  |  14 ++++++++++++++
 3 files changed, 18 insertions(+), 3 deletions(-)

commit affd9d5966a33b7dd71ea649a1fd8cf68c2cd21d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 10:40:20 2018 +0300

    Add comments into feMerge

 rsvg_internals/src/filters/merge.rs | 2 ++
 1 file changed, 2 insertions(+)

commit 90377faeaf11fcf5e3339a9304dbe96e99d123a8
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 10:38:59 2018 +0300

    Change feOffset attributes to be numbers
    
    Since they are simple numbers, not lengths.

 rsvg_internals/src/filters/offset.rs | 32 +++++++++++++-------------------
 1 file changed, 13 insertions(+), 19 deletions(-)

commit 004203427d45fd600461d486748d5a88e0ce09dc
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 10:34:44 2018 +0300

    Use a better name for test-bbox

 ...test-bbox-ref.png => test-filter-effects-region-ref.png} | Bin
 .../{test-bbox.svg => test-filter-effects-region.svg}       |   0
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 31960dfc9724d17924ca148bd97704bd79f32a38
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 10:32:59 2018 +0300

    Compute the filter effects region only once

 rsvg_internals/src/filters/bounds.rs  |   4 +-
 rsvg_internals/src/filters/context.rs | 182 ++++++++++++++++++----------------
 2 files changed, 101 insertions(+), 85 deletions(-)

commit 461009dd51d515d1e72b708976f0f25185117c0b
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Wed Jun 13 10:17:33 2018 +0300

    Add a missing dot

 rsvg_internals/src/filters/context.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9ac0692f8d4b5d572722cba31e21b3e524eebfd0
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Tue Jun 12 23:24:14 2018 +0200

    node: simplify code that deals with state
    
    Do not expose a get_state and instead expose get_specified_values;
    this is a step toward just having SpecifiedValues as an
    immutable field of node.

 rsvg_internals/src/node.rs      | 29 +++++++++++++++--------------
 rsvg_internals/src/state.rs     | 22 +++++++++++-----------
 rsvg_internals/src/structure.rs |  3 ++-
 3 files changed, 28 insertions(+), 26 deletions(-)

commit 294e01f5070000f02f03fe23177c16edb3c8d96c
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Tue Jun 12 23:03:20 2018 +0200

    state: remove unused method

 rsvg_internals/src/state.rs | 8 --------
 1 file changed, 8 deletions(-)

commit 464b2d4f68728608f25a96c48c5807cbc4faf3a2
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon Jun 11 23:30:59 2018 +0200

    node: move cond to the node itself
    
    There is no reason to have it in State since it is not related
    to styling

 rsvg_internals/src/node.rs      | 52 ++++++++++++++++++++++++++++++++++++++++-
 rsvg_internals/src/state.rs     | 47 -------------------------------------
 rsvg_internals/src/structure.rs |  2 +-
 3 files changed, 52 insertions(+), 49 deletions(-)

commit ecc02857b97733df97ea6b11da0a9248a569af9d
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon Jun 11 22:33:42 2018 +0200

    Fix typo (overriden -> overridden)

 librsvg/rsvg-load.c          |  2 +-
 librsvg/rsvg-private.h       |  2 +-
 rsvg_internals/src/lib.rs    |  2 +-
 rsvg_internals/src/marker.rs |  2 +-
 rsvg_internals/src/node.rs   | 10 +++++-----
 5 files changed, 9 insertions(+), 9 deletions(-)

commit b856dc6062795290eef1b9fda7323fe6a6b68e3e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 12 21:53:40 2018 +0300

    Add notice about attributes into feOffset

 rsvg_internals/src/filters/offset.rs               |   5 +++++
 tests/fixtures/reftests/test-filter-offset-ref.png | Bin 0 -> 1040 bytes
 tests/fixtures/reftests/test-filter-offset.svg     |  14 ++++++++++++++
 3 files changed, 19 insertions(+)

commit e8c32d9d1653fcdce17118a703de9bf993f73668
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 12 21:33:10 2018 +0300

    Fix missing linearization in composite arithmetic
    
    I accidentally removed it earlier

 rsvg_internals/src/filters/composite.rs               |   5 +++--
 .../reftests/bugs/241-light-source-type-ref.png       | Bin 3983 -> 4226 bytes
 2 files changed, 3 insertions(+), 2 deletions(-)

commit b42de450d3446902992c272f0c8922b63baaad2d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 12 21:29:24 2018 +0300

    Big filter bounds computation refactor
    
    Now we have two extra pixels in composite-02 ¯\_(ツ)_/¯

 Makefile.am                                        |   1 +
 rsvg_internals/src/bbox.rs                         |   2 +-
 rsvg_internals/src/filters/bounds.rs               | 151 ++++++++++++
 rsvg_internals/src/filters/composite.rs            |  21 +-
 rsvg_internals/src/filters/context.rs              | 268 ++++++++++++++-------
 rsvg_internals/src/filters/image.rs                |  21 +-
 rsvg_internals/src/filters/merge.rs                |  16 +-
 rsvg_internals/src/filters/mod.rs                  |  22 +-
 rsvg_internals/src/filters/offset.rs               |   8 +-
 rsvg_internals/src/length.rs                       |  20 ++
 .../reftests/svg1.1/filters-composite-02-b-ref.png | Bin 15917 -> 15918 bytes
 .../reftests/svg1.1/filters-image-03-f-ref.png     | Bin 0 -> 10815 bytes
 .../reftests/svg1.1/filters-image-03-f.svg         | 179 ++++++++++++++
 .../reftests/svg1.1/filters-image-04-f-ref.png     | Bin 0 -> 12642 bytes
 .../reftests/svg1.1/filters-image-04-f.svg         | 119 +++++++++
 tests/fixtures/reftests/test-bbox-ref.png          | Bin 0 -> 1598 bytes
 tests/fixtures/reftests/test-bbox.svg              |  40 +++
 .../test-filter-image-from-reference-page-ref.png  | Bin 0 -> 16648 bytes
 .../test-filter-image-from-reference-page.svg      |  35 +++
 19 files changed, 783 insertions(+), 120 deletions(-)

commit 06e8ef2d449fe714bc9554ce1928a54cdd38b9e7
Author: Jordan Petridis <jordanpetridis@protonmail.com>
Date:   Tue Jun 12 18:28:52 2018 +0000

    CI: remove some rustc jobs.
    
    6dd00f4f bumped the minimum rustc version to 1.24

 .gitlab-ci.yml | 21 ---------------------
 1 file changed, 21 deletions(-)

commit 6dd00f4fa4ae30e3cde66af5db611e6052a35159
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 12 13:19:02 2018 -0500

    Require Rust 1.24 or later, for RefCell::replace()

 .gitlab-ci.yml | 3 ---
 COMPILING.md   | 2 +-
 configure.ac   | 3 ++-
 3 files changed, 3 insertions(+), 5 deletions(-)

commit 13fe6ccb9e1a146ad49586fa5c9a4bbc81a70d9e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 12 13:17:40 2018 -0500

    Post-release version bump to 2.43.1

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9f8d34b5fd06a40a3630f3affcfbb2f7e7fbda85
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sun Jun 10 10:34:48 2018 +0300

    Don't render filter if bbox rect is empty
    
    Fixes #277.

 rsvg_internals/src/drawing_ctx.rs                  |  25 +-
 .../render-crash/277-filter-on-empty-group.svg     | 312 +++++++++++++++++++++
 2 files changed, 328 insertions(+), 9 deletions(-)

commit 404d5dcc764d99aa3155ea8fcc807ddc02ec2dd0
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 7 15:15:33 2018 +0300

    Port (more or less) the rest of feImage

 librsvg/filters/image.c             | 274 ------------------------------------
 rsvg_internals/src/filters/image.rs | 144 +++++++++++++------
 2 files changed, 104 insertions(+), 314 deletions(-)

commit 99f09ed9aec9bb3a73af047ef9e337be3d6b726b
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 7 15:14:35 2018 +0300

    Make FilterContext::drawing_context() return *mut

 rsvg_internals/src/filters/context.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 91ea6f3342f48f6e5ab59e95c2e4762182941878
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 7 15:14:06 2018 +0300

    Add drawing_ctx::draw_node_on_surface()

 rsvg_internals/src/drawing_ctx.rs | 29 +++++++++++++++++++++++++++++
 1 file changed, 29 insertions(+)

commit 18bc1cd17a7b3cd13f499493d0a49776b03e2d7f
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu Jun 7 12:28:54 2018 +0300

    WIP: partially port Image to Rust

 Makefile.am                                        |   2 +-
 librsvg/filters/image.c                            |   1 +
 librsvg/rsvg-filter.h                              |   2 -
 rsvg_internals/src/filters/ffi.rs                  |   1 +
 rsvg_internals/src/filters/image.rs                | 166 ++++++++++++++++++
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/load.rs                         |  10 +-
 .../reftests/svg1.1/filters-image-01-b-ref.png     | Bin 0 -> 91306 bytes
 .../reftests/svg1.1/filters-image-01-b.svg         |  59 +++++++
 .../reftests/svg1.1/filters-image-02-b-ref.png     | Bin 0 -> 24267 bytes
 .../reftests/svg1.1/filters-image-02-b.svg         |  83 +++++++++
 .../reftests/svg1.1/filters-image-05-f-ref.png     | Bin 0 -> 18840 bytes
 .../reftests/svg1.1/filters-image-05-f.svg         | 195 +++++++++++++++++++++
 tests/fixtures/reftests/svg1.1/images/image1.jpg   | Bin 0 -> 34183 bytes
 .../fixtures/reftests/svg1.1/images/pinksquidj.png | Bin 0 -> 31090 bytes
 tests/fixtures/reftests/svg1.1/images/smiley.png   | Bin 0 -> 2856 bytes
 16 files changed, 510 insertions(+), 10 deletions(-)

commit 2ff918b28f974b5436a7257a70b1ea04f2d632a2
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 11 19:54:21 2018 -0500

    Update NEWS for 2.43.0

 NEWS | 74 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 72 insertions(+), 2 deletions(-)

commit 8921e76f779df3dea02d40fb589c79fe39de0863
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 11 19:13:04 2018 -0500

    rustfmt

 rsvg_internals/src/defs.rs  |  6 +-----
 rsvg_internals/src/image.rs |  1 -
 rsvg_internals/src/lib.rs   | 11 ++---------
 rsvg_internals/src/load.rs  | 15 +++++++++++----
 rsvg_internals/src/node.rs  |  5 +----
 rsvg_internals/src/stop.rs  |  1 -
 6 files changed, 15 insertions(+), 24 deletions(-)

commit b31df6aab1dbcf82b94aa87936668333ceb7063b
Author: GuillaumeGomez <guillaume1.gomez@gmail.com>
Date:   Mon Jun 11 23:36:05 2018 +0200

    Fix build errors

 rsvg_internals/src/load.rs | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 9b4a9e9c05d6ee7b81c18b23e7a32c392bcc817f
Author: Guillaume Gomez <guillaume1.gomez@gmail.com>
Date:   Sat Feb 10 00:00:44 2018 +0100

    Add windows tests

 .gitignore   |  1 +
 appveyor.yml | 23 +++++++++++++++++++++++
 2 files changed, 24 insertions(+)

commit 3e09cd30ebe5fb1820d2521cfccb27baccbf6a9b
Merge: b313708e f13405b8
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 11 09:40:56 2018 -0500

    Merge branch 'pborelli/librsvg-load'

commit b313708e567f9f87eb8f011ab85a31d12fd45486
Author: Jehan <jehan@girinstud.io>
Date:   Sat Jun 9 21:17:14 2018 +0200

    tests: fix also VPATH build for unit tests.

 tests/Makefile.am | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 8722ae31dee6d1da047485a4763c4764bc0e06d1
Author: Jehan <jehan@girinstud.io>
Date:   Sat Jun 9 19:04:51 2018 +0200

    Makefile: fix VPATH (out-of-tree) builds.
    
    In `librsvg/rsvg.h`, the include is "librsvg-enum-types.h", which is a
    generated file and is therefore inside $(top_builddir)/librsvg/.

 Makefile.am                   | 6 ++++--
 gdk-pixbuf-loader/Makefile.am | 3 ++-
 tools/Makefile.am             | 1 +
 3 files changed, 7 insertions(+), 3 deletions(-)

commit 7ae7af7f8cbfd83fe422ae229a0c9378d6620d8e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 11 09:02:06 2018 -0500

    Oops, regenerate the last test file with linearization/unlinearization

 .../reftests/bugs/241-light-source-type-ref.png       | Bin 4036 -> 3983 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit f13405b838b9805c6b4dc9396bb00aaa2f3ff5f6
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 10 16:05:39 2018 +0200

    defs: move node registration to rust

 Makefile.am                |  1 +
 librsvg/rsvg-load.c        | 28 +---------------------------
 rsvg_internals/src/defs.rs | 25 +++++++++++++++++++++++++
 rsvg_internals/src/lib.rs  |  2 ++
 rsvg_internals/src/node.rs | 20 ++++++++++++++++++++
 5 files changed, 49 insertions(+), 27 deletions(-)

commit de9951f70bb094d74938fd52357cc03a61ecca4a
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat Jun 9 17:02:50 2018 +0200

    load: rework handling of class attribute
    
    Now also the class is stored in the node, in a way similar to id.

 librsvg/filters/blend.c              |  3 +-
 librsvg/filters/color_matrix.c       |  3 +-
 librsvg/filters/component_transfer.c |  6 ++--
 librsvg/filters/convolve_matrix.c    |  3 +-
 librsvg/filters/diffuse_lighting.c   |  3 +-
 librsvg/filters/displacement_map.c   |  3 +-
 librsvg/filters/erode.c              |  3 +-
 librsvg/filters/flood.c              |  3 +-
 librsvg/filters/gaussian_blur.c      |  3 +-
 librsvg/filters/image.c              |  3 +-
 librsvg/filters/light_source.c       |  3 +-
 librsvg/filters/specular_lighting.c  |  3 +-
 librsvg/filters/tile.c               |  3 +-
 librsvg/filters/turbulence.c         |  3 +-
 librsvg/rsvg-filter.h                | 34 +++++++++---------
 librsvg/rsvg-load.c                  | 42 +++++-----------------
 librsvg/rsvg-private.h               |  1 +
 librsvg/rsvg-styles.h                |  2 +-
 rsvg_internals/src/cnode.rs          |  2 ++
 rsvg_internals/src/load.rs           | 68 +++++++++++++++++++++++++++---------
 rsvg_internals/src/node.rs           | 22 ++++++++++++
 rsvg_internals/src/state.rs          | 11 ++----
 rsvg_internals/src/structure.rs      | 12 +------
 rsvg_internals/src/text.rs           |  1 +
 rsvg_internals/src/viewport.rs       |  1 +
 25 files changed, 140 insertions(+), 101 deletions(-)

commit 15ad587f879100df1058ff8f1cfec08168a266de
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 10 15:28:00 2018 +0200

    node: add and use get_id method

 librsvg/rsvg-load.c             |  9 +++++----
 librsvg/rsvg-styles.h           |  4 ++--
 rsvg_internals/src/node.rs      |  4 ++++
 rsvg_internals/src/state.rs     | 11 ++++-------
 rsvg_internals/src/structure.rs |  6 +-----
 5 files changed, 16 insertions(+), 18 deletions(-)

commit f11e589fbe7cea994875de8992aedd4369aa5aee
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 10 13:03:28 2018 +0200

    load: macroify node creation functions

 rsvg_internals/src/load.rs | 657 +++++++++++----------------------------------
 1 file changed, 163 insertions(+), 494 deletions(-)

commit 9d84918bac42d065989556961dbffb901a357eb4
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 10 10:43:33 2018 +0200

    load: move all node creation function in load.rs
    
    For now they are moved verbatim, but at least they are not exported
    to C anymore

 librsvg/rsvg-filter.h                   |  12 -
 librsvg/rsvg-load.c                     |   4 +
 librsvg/rsvg-structure.h                | 104 --------
 rsvg_internals/src/clip_path.rs         |  20 +-
 rsvg_internals/src/filters/composite.rs |  25 +-
 rsvg_internals/src/filters/merge.rs     |  44 +---
 rsvg_internals/src/filters/node.rs      |  21 +-
 rsvg_internals/src/filters/offset.rs    |  25 +-
 rsvg_internals/src/gradient.rs          |  37 +--
 rsvg_internals/src/image.rs             |  18 +-
 rsvg_internals/src/lib.rs               |  41 ---
 rsvg_internals/src/link.rs              |  20 +-
 rsvg_internals/src/load.rs              | 447 +++++++++++++++++++++++++++++---
 rsvg_internals/src/marker.rs            |  22 +-
 rsvg_internals/src/mask.rs              |  20 +-
 rsvg_internals/src/pattern.rs           |  26 +-
 rsvg_internals/src/shapes.rs            | 141 ++--------
 rsvg_internals/src/stop.rs              |  18 +-
 rsvg_internals/src/structure.rs         | 118 +--------
 rsvg_internals/src/text.rs              |  57 +---
 20 files changed, 495 insertions(+), 725 deletions(-)

commit ac6f7bcf03289589435cbb603b17e9ed43676e6b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 8 11:47:17 2018 -0500

    Add test for the light source type

 .../reftests/bugs/241-light-source-type-ref.png         | Bin 0 -> 4036 bytes
 tests/fixtures/reftests/bugs/241-light-source-type.svg  |  16 ++++++++++++++++
 2 files changed, 16 insertions(+)

commit b9b29ae5a88f0bab981f23f58efa953f582a312b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 8 11:43:14 2018 -0500

    (#241) rsvg_new_node_light_source() - Fix cut&paste error between feDistantLight and feSpotLight
    
    Sigh, I broke this and never caught it because there weren't tests for
    filters with light sources.
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/241

 librsvg/filters/light_source.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 01101c5d96cd7edcc72023d6f9993cd8beede221
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 8 08:06:11 2018 -0500

    Add tests for (#282), copied/regenerated from librsvg-2.42
    
    (#282) - Don't reuse the input surface for painting feComposite's output
    
    feComposite tried to take a shortcut if one of its inputs is an
    existing surface, by painting its output to that same surface.
    However, the overall filter may want to reuse the original surface
    unchanged.  This was causing drop shadows, done like Inkscape's, to be
    mis-painted.
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/282

 tests/fixtures/reftests/bugs/282-drop-shadow-ref.png | Bin 0 -> 1699 bytes
 tests/fixtures/reftests/bugs/282-drop-shadow.svg     |  12 ++++++++++++
 2 files changed, 12 insertions(+)

commit d2cf5f4441c0a6925f96c55a27db3f250ac2eecb
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 5 17:44:13 2018 -0500

    rustfmt

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 85d88d887e3f845755575453cf9632e5f1f0fd36
Merge: a4ccc04a b0c74b91
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 5 17:43:38 2018 -0500

    Merge branch 'pborelli/librsvg-draw-ctx'

commit a4ccc04a238d8ba2f660a9c79921cc845d871e48
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 5 17:36:30 2018 -0500

    rustfmt

 .rustfmt.toml                       | 1 -
 rsvg_internals/src/filters/merge.rs | 5 +++--
 2 files changed, 3 insertions(+), 3 deletions(-)

commit b0c74b919fd55e5ea8a7da21665f0c6abab9bab4
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 3 18:51:48 2018 +0200

    structure: avoid C roundtrip

 rsvg_internals/src/state.rs     |  2 +-
 rsvg_internals/src/structure.rs | 29 ++---------------------------
 2 files changed, 3 insertions(+), 28 deletions(-)

commit 823a22576e52fb52e786aaf981e802a174396cc9
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 3 20:54:51 2018 +0200

    drawing_ctx: move useful comment to rust

 librsvg/rsvg-drawing-ctx.c        | 18 ------------------
 rsvg_internals/src/drawing_ctx.rs |  5 +++++
 2 files changed, 5 insertions(+), 18 deletions(-)

commit 4e7c2b6cd7a7c97d5508315ca16ac7743ba4b6a1
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 3 20:08:25 2018 +0200

    drawing_ctx: remove unused field

 librsvg/rsvg-drawing-ctx.h | 1 -
 1 file changed, 1 deletion(-)

commit d048320a1e275133da8d678f7f7f130af87bb640
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 3 19:53:11 2018 +0200

    drawing_ctx: move get_acquired_node_of_type to rust

 librsvg/rsvg-drawing-ctx.c        | 38 --------------------------------------
 rsvg_internals/src/drawing_ctx.rs | 30 ++++++++++++++++--------------
 2 files changed, 16 insertions(+), 52 deletions(-)

commit 0b728c8f9e810c6235015289c7504cc2788e8a96
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 3 19:14:15 2018 +0200

    drawing_ctx: do not pass in the handle
    
    It is a bit more verbose, but reduces coupling.
    rsvg_drawing_ctx_new now cannot fail.

 librsvg/rsvg-drawing-ctx.c | 32 +++++++++++++------------
 librsvg/rsvg-drawing-ctx.h | 10 +++++++-
 librsvg/rsvg-handle.c      | 58 ++++++++++++++++++++++++++++------------------
 3 files changed, 62 insertions(+), 38 deletions(-)

commit 7ee0bb1fb9c66b8e19b416dfd28a1a3c8be2977b
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun Jun 3 18:57:37 2018 +0200

    handle: cleanup get_position_sub
    
    No need to use the DimensionData struct, since just the width
    and height fields are used.

 librsvg/rsvg-handle.c | 18 ++++++++----------
 1 file changed, 8 insertions(+), 10 deletions(-)

commit f345d614a1d4c1922eda2487e9a4aacd2f40ffa5
Merge: 5a2dd2a8 0d6e1b81
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 5 12:53:14 2018 -0500

    Merge branch 'YaLTeR/librsvg-filters-to-rust-3'

commit 5a2dd2a8c5bb05992fcaf87fea110e6d39ebf16d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 5 08:52:16 2018 -0500

    (#273) - Pass the node being filtered down to the filter rendering functions
    
    feImage wants to render the node it is referencing via href, but with
    a cascade from the node to which the filter is being applied - similar
    to the <use> element.  This requires that we are able to obtain the
    node, to which the filter is being applied, from the filter rendering
    function.
    
    This commit introduces FilterContext::get_node_being_filtered().
    
    pop_discrete_layer() also takes a node - this is so that it can create
    the FilterContext with the node that is being filtered.
    
    Also, Node::draw_children() now takes a node argument, so it can pass
    it to pop_discrete_layer().
    
    This makes filters-composite-02-b.svg render almost exactly like the
    SVG 1.1 official reference image, except for the Arithmetic column;
    the lower-right item has an extra row of pixels on top...
    
    We regenerate filters-composite-02-b-ref.png for now.
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/273

 librsvg/filters/common.h                           |   3 ++
 librsvg/filters/image.c                            |   7 +++-
 rsvg_internals/src/clip_path.rs                    |   2 +-
 rsvg_internals/src/drawing_ctx.rs                  |  14 +++++--
 rsvg_internals/src/filters/context.rs              |  21 +++++++++-
 rsvg_internals/src/filters/ffi.rs                  |   9 ++++-
 rsvg_internals/src/image.rs                        |   4 +-
 rsvg_internals/src/lib.rs                          |   1 +
 rsvg_internals/src/link.rs                         |   2 +
 rsvg_internals/src/marker.rs                       |   4 +-
 rsvg_internals/src/mask.rs                         |   2 +-
 rsvg_internals/src/node.rs                         |   3 +-
 rsvg_internals/src/pattern.rs                      |   4 +-
 rsvg_internals/src/shapes.rs                       |  30 +++++++-------
 rsvg_internals/src/structure.rs                    |  13 ++++---
 rsvg_internals/src/text.rs                         |   2 +-
 rsvg_internals/src/viewport.rs                     |  43 ++++++++++++++++++---
 .../reftests/svg1.1/filters-composite-02-b-ref.png | Bin 16055 -> 15917 bytes
 18 files changed, 123 insertions(+), 41 deletions(-)

commit 778e0b932df9458ebe685fcea80a3a4ea1f08a65
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 5 07:34:21 2018 -0500

    rsvg_drawing_ctx_draw_node_on_surface() - Take an optional node to cascade from

 librsvg/filters/image.c    | 1 +
 librsvg/rsvg-drawing-ctx.c | 3 ++-
 librsvg/rsvg-drawing-ctx.h | 1 +
 3 files changed, 4 insertions(+), 1 deletion(-)

commit 0d6e1b81789c3829b7d2b878a9ab1302c215f136
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 16:20:57 2018 +0300

    Port feMerge to Rust

 Makefile.am                                        |   2 +-
 librsvg/filters/merge.c                            | 192 ---------------------
 rsvg_internals/src/filters/ffi.rs                  |   4 +-
 rsvg_internals/src/filters/merge.rs                | 169 ++++++++++++++++++
 rsvg_internals/src/filters/mod.rs                  |   1 +
 rsvg_internals/src/lib.rs                          |   1 +
 .../reftests/svg1.1/filters-offset-01-b-ref.png    | Bin 10560 -> 10654 bytes
 7 files changed, 175 insertions(+), 194 deletions(-)

commit 3ebdaf9af2b4e2a6b9674482d3ddd9457ab2fdc5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue Jun 5 07:24:39 2018 -0500

    rsvg_drawing_ctx_draw_node_from_stack() - Pass an optional node to cascade from
    
    According to the spec, elements referenced from feImage are suposed to
    cascade like the <use> element.  The spec is not very clear on this,
    but filters-composite-02-b.svg indicates that the referenced element
    cascades from the original element that has the filter applied to it.
    For example,
    
       <defs>
         <path id="foo" .../>
    
         <filter id="bar">
           <feImage ... xlink:href="#foo"/>
         </filter>
       <defs>
    
       <path id="baz" ... filter="url(#bar)"/>
    
    Here, baz has a filter applied to it, and the feImage in the filter
    references foo.  However, foo should inherit its CSS properties from
    baz, not from bar.
    
    This commit lets us give rsvg_drawing_ctx_draw_node_from_stack() a
    second, optional node to cascade from.  If it is NULL, then the node
    to draw will use its own default cascade.

 librsvg/rsvg-drawing-ctx.c        |  2 +-
 librsvg/rsvg-drawing-ctx.h        |  1 +
 librsvg/rsvg-handle.c             |  6 +++---
 rsvg_internals/src/drawing_ctx.rs | 18 +++++++++++++++++-
 4 files changed, 22 insertions(+), 5 deletions(-)

commit 7c92faeaad990af6540b61f86c43d74b4c60c24d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 14:59:44 2018 +0300

    Impl set_pixel() for cairo::ImageSurfaceData

 rsvg_internals/src/filters/composite.rs | 28 ++++++++++++----------------
 rsvg_internals/src/filters/iterators.rs | 17 +++++++++++++++++
 rsvg_internals/src/filters/offset.rs    |  9 ++-------
 3 files changed, 31 insertions(+), 23 deletions(-)

commit a03bc942243b581bd2af2f71199f365d656e185e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 14:33:49 2018 +0300

    Port rsvg_filter_get_{in,result} to Rust

 librsvg/filters/common.c              | 118 ++++++++++++++++------------------
 librsvg/filters/common.h              |  16 ++++-
 rsvg_internals/src/filters/context.rs |  55 +++++++++++++++-
 rsvg_internals/src/lib.rs             |   2 +
 4 files changed, 124 insertions(+), 67 deletions(-)

commit 962437250f42f56c318a28bc50bdde83ca22ddca
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 14:12:47 2018 +0300

    Silence two warnings

 rsvg_internals/src/cond.rs        | 2 +-
 rsvg_internals/src/drawing_ctx.rs | 1 +
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 949858c7af988ec2812b031f4989e77de1bd9e5e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 14:11:34 2018 +0300

    Implement BackgroundImage and BackgroundAlpha

 librsvg/filters/common.c              | 60 +++++++++++++--------------
 librsvg/rsvg-drawing-ctx.c            |  6 +++
 librsvg/rsvg-drawing-ctx.h            |  3 ++
 rsvg_internals/src/drawing_ctx.rs     | 45 +++++++++++++++++++++
 rsvg_internals/src/filters/context.rs | 76 ++++++++++++++++++++++++++++++++---
 5 files changed, 155 insertions(+), 35 deletions(-)

commit 4ca90fa90de9caa701833a514168f903efd3bfec
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 11:59:18 2018 +0300

    Fix find_light_source_in_children()

 librsvg/filters/light_source.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bb4a9d4df81e57ed67c02618e0e1d839de6558dc
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 11:37:12 2018 +0300

    Stub out FillPaint and StrokePaint

 rsvg_internals/src/filters/context.rs | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 3103ac64bf52adc2cd1c25abba7a97e7d0a04eb3
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 11:36:08 2018 +0300

    Implement SourceAlpha in get_input()

 rsvg_internals/src/filters/context.rs | 101 +++++++++++++++++++++++++++++++++-
 1 file changed, 100 insertions(+), 1 deletion(-)

commit 7cc179c6436e00c0cc1bbb41bee4f0552a91fde7
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 11:04:14 2018 +0300

    Return correct bounds from get_input()

 rsvg_internals/src/filters/context.rs | 16 ++--------------
 1 file changed, 2 insertions(+), 14 deletions(-)

commit 7669a121fbac1ca0fcf4d86b54ccc7be16fdc65d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Tue Jun 5 11:03:55 2018 +0300

    Remove extra FilterContext::compute_bounds() arg

 rsvg_internals/src/filters/context.rs | 19 ++++++-------------
 rsvg_internals/src/filters/mod.rs     |  5 -----
 2 files changed, 6 insertions(+), 18 deletions(-)

commit c5bfd649ac393e685fb76df2f760b2d353d22af2
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 18:21:57 2018 -0500

    Node: store the element's id, or None.
    
    We pass it everywhere to the construction functions now.
    
    We'll use this for several things:  debugging, CSS cascading, etc.

 librsvg/filters/blend.c                 |  3 +-
 librsvg/filters/color_matrix.c          |  3 +-
 librsvg/filters/component_transfer.c    |  6 ++--
 librsvg/filters/convolve_matrix.c       |  3 +-
 librsvg/filters/diffuse_lighting.c      |  3 +-
 librsvg/filters/displacement_map.c      |  3 +-
 librsvg/filters/erode.c                 |  3 +-
 librsvg/filters/flood.c                 |  3 +-
 librsvg/filters/gaussian_blur.c         |  3 +-
 librsvg/filters/image.c                 |  3 +-
 librsvg/filters/light_source.c          |  3 +-
 librsvg/filters/merge.c                 |  6 ++--
 librsvg/filters/specular_lighting.c     |  3 +-
 librsvg/filters/tile.c                  |  3 +-
 librsvg/filters/turbulence.c            |  3 +-
 librsvg/rsvg-filter.h                   | 38 ++++++++++++------------
 librsvg/rsvg-load.c                     | 52 ++++++++++++++++++++++-----------
 librsvg/rsvg-private.h                  |  1 +
 librsvg/rsvg-structure.h                | 52 ++++++++++++++++-----------------
 rsvg_internals/src/clip_path.rs         |  3 ++
 rsvg_internals/src/cnode.rs             |  9 ++++--
 rsvg_internals/src/filters/composite.rs | 12 ++++++--
 rsvg_internals/src/filters/node.rs      |  9 +++++-
 rsvg_internals/src/filters/offset.rs    | 12 ++++++--
 rsvg_internals/src/gradient.rs          |  4 +++
 rsvg_internals/src/image.rs             |  9 +++++-
 rsvg_internals/src/link.rs              |  9 +++++-
 rsvg_internals/src/load.rs              | 37 ++++++++++++++++++++---
 rsvg_internals/src/marker.rs            |  9 +++++-
 rsvg_internals/src/mask.rs              |  9 +++++-
 rsvg_internals/src/node.rs              | 18 ++++++++++++
 rsvg_internals/src/pattern.rs           |  9 +++++-
 rsvg_internals/src/shapes.rs            | 45 ++++++++++++++++++++++++----
 rsvg_internals/src/stop.rs              |  9 +++++-
 rsvg_internals/src/structure.rs         | 49 +++++++++++++++++++++++++++----
 rsvg_internals/src/text.rs              | 32 +++++++++++++++++---
 36 files changed, 365 insertions(+), 113 deletions(-)

commit a9f76253a5940a54b2f9be91cc78a156c433ddce
Merge: 072e1c11 8cee3df6
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 17:27:58 2018 -0500

    Merge branch 'YaLTeR/librsvg-filters-to-rust-2'

commit 8cee3df678be149e4bb525e081ca30d0082d234d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 23:57:48 2018 +0300

    Use camelCase filterUnits and primitiveUnits

 rsvg_internals/src/filters/node.rs | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 072e1c11ecb39987aaf9c027dd4d3395d69989ad
Merge: b11261f7 b855f33e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 12:19:39 2018 -0500

    Merge branch 'saurvs/librsvg-load_rust'

commit b855f33e08b1a962bcb7cc629eef94814026a2f5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 12:15:25 2018 -0500

    rustfmt

 rsvg_internals/src/load.rs | 104 ++++++++++++++++++++++++++++++++++-----------
 1 file changed, 79 insertions(+), 25 deletions(-)

commit f6742ae32b5a23f66cb4519f7052a05e1dc5d1da
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 12:14:28 2018 -0500

    Tell rustfmt to skip the list of node creators

 rsvg_internals/src/load.rs | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 53dca862404f08578d280061ac0e057fc300441b
Author: Saurav Sachidanand <sauravsachidanand@gmail.com>
Date:   Sat Jun 2 20:57:15 2018 +0530

    Move node creation to Rust

 Makefile.am                |   1 +
 librsvg/rsvg-load.c        | 150 ++-------------------------------------------
 librsvg/rsvg-structure.h   |   4 ++
 rsvg_internals/src/lib.rs  |   3 +
 rsvg_internals/src/load.rs | 150 +++++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 163 insertions(+), 145 deletions(-)

commit b11261f77193bfbde8fda1fbaa5493c540d36831
Merge: 7598fed7 d11d958a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 12:00:29 2018 -0500

    Merge branch 'ffontaine/librsvg-master'

commit d11d958ad578704f977abe3ecd174e761202faec
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 12:00:03 2018 -0500

    COMPILING.md: Update to mention the RUST_TARGET environment variable

 COMPILING.md | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit 7598fed70bde71f01dca9866cfa468b5cb3e35ce
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon Jun 4 11:35:23 2018 -0500

    Punctuation fix.

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 11b37c9967d0e210ab0a6ff5524b7e61dff987f0
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 15:05:14 2018 +0300

    Add some missing attributes

 rsvg_internals/src/filters/context.rs | 4 +++-
 rsvg_internals/src/filters/mod.rs     | 3 +++
 rsvg_internals/src/filters/node.rs    | 3 +++
 3 files changed, 9 insertions(+), 1 deletion(-)

commit fbf3fc05d7ba511ec1b583d98ffef69f12554a19
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 14:36:01 2018 +0300

    Regenerate (TEMPORARY) test results
    
    Need to be regenerated when half-pixel shift is fixed.

 .../reftests/svg1.1/filters-composite-02-b-ref.png  | Bin 16062 -> 16055 bytes
 .../reftests/svg1.1/filters-offset-01-b-ref.png     | Bin 10442 -> 10560 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 619d9cb104e1eaebb2888b5d472f000f36084865
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 14:35:28 2018 +0300

    Port the filter node to Rust

 Makefile.am                           |   2 +-
 librsvg/filters/common.c              | 134 +++++++++++++++++-----------------
 librsvg/filters/common.h              |  29 ++++----
 librsvg/rsvg-filter.c                 |  58 ---------------
 librsvg/rsvg-filter.h                 |  16 ++--
 rsvg_internals/src/filters/context.rs |  56 ++++----------
 rsvg_internals/src/filters/ffi.rs     |  10 +--
 rsvg_internals/src/filters/mod.rs     |   1 +
 rsvg_internals/src/filters/node.rs    |  76 +++++++++++++++++++
 rsvg_internals/src/lib.rs             |   3 +-
 10 files changed, 187 insertions(+), 198 deletions(-)

commit 4a9399045ae0ade14b90400b646ea2c79c839181
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 14:34:45 2018 +0300

    Add Node::get_impl()

 rsvg_internals/src/node.rs | 4 ++++
 1 file changed, 4 insertions(+)

commit ec03a245afaf4a32d0ccade12ff9f3beb1ec2d87
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 12:03:03 2018 +0300

    Refactor feComposite to use the new iterator

 rsvg_internals/src/filters/composite.rs | 106 ++++++++++++--------------------
 1 file changed, 41 insertions(+), 65 deletions(-)

commit 75918ae291cbdbdb973481ba27979e1f3cf07944
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 11:31:43 2018 +0300

    Refactor feOffset to use the new iterator

 rsvg_internals/src/filters/offset.rs | 72 +++++++++++++++---------------------
 1 file changed, 30 insertions(+), 42 deletions(-)

commit dbd4a7fad476653e4b47b66b95418ae96c40fb50
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 11:07:52 2018 +0300

    Fix invalid assert conditions in srgb

 rsvg_internals/src/srgb.rs | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 45145a0363397b5b8fe12d8d5c7d896a23479a32
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Mon Jun 4 10:57:58 2018 +0300

    Remove unneeded pub from ImageSurfaceDataShared

 rsvg_internals/src/filters/iterators.rs | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3bb5f0e81584c40876739fdae054e07c0b328120
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 2 22:17:52 2018 +0300

    Add some pixel iteration benchmarks

 rsvg_internals/benches/pixel_iterators.rs | 100 ++++++++++++++++++++++++++++++
 rsvg_internals/src/lib.rs                 |   2 +-
 2 files changed, 101 insertions(+), 1 deletion(-)

commit 6d30736521641d6431dc30942fd2e0fef1dc0118
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 2 22:17:23 2018 +0300

    Add crate-type lib to Cargo.toml

 rsvg_internals/Cargo.toml             | 2 +-
 rsvg_internals/src/property_macros.rs | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 019953f2b591197eaf4288df6a3d085ce7fc0ed5
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 2 22:15:34 2018 +0300

    Add filters::iterators

 Makefile.am                             |   1 +
 rsvg_internals/src/filters/iterators.rs | 229 ++++++++++++++++++++++++++++++++
 rsvg_internals/src/filters/mod.rs       |   2 +
 3 files changed, 232 insertions(+)

commit 7284685ee8fdb635efa91a7f855bf61134d8c623
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat Jun 2 10:47:37 2018 +0300

    Make filters::input a private mod

 rsvg_internals/src/filters/mod.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f0b76ab6f003b8e05d4caab2b6d844e97b97796f
Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
Date:   Sat Jun 2 09:46:59 2018 +0200

    Add RUST_TARGET variable
    
    Add RUST_TARGET environment variable through AC_ARG_VAR to allow the
    user to override the rust target name. Indeed, using $host when
    cross-compiling is not always the good option especially when vendor
    part of target is not set to unknown but to another value such as
    buildroot.
    Indeed, in this case aarch64-buildroot-linux-gnu won't be recognised as
    a valid target by rust/cargo.
    
    Signed-off-by: Fabrice Fontaine <fontaine.fabrice@gmail.com>

 Makefile.am  | 2 +-
 configure.ac | 7 ++++++-
 2 files changed, 7 insertions(+), 2 deletions(-)

commit 978a87b3f3d4d89f63a42701deb1fea318b54b26
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 1 19:33:31 2018 -0500

    Remind people that github will delete their pull requests

 README.md | 4 ++++
 1 file changed, 4 insertions(+)

commit 5050dcf06dc6a0dd7948baddf104e236b49909a1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 1 13:36:22 2018 -0500

    (#266) - Don't ignore the results of filters with errors in attributes
    
    The only remaining C nodes are filters.  The NodeTrait implementation
    of CNode::set_atts() was returning Ok(()) always, even if the C code
    had called rsvg_node_set_attribute_parse_error().  Instead, actually
    return that error result so the rest of the code will know about it.
    
    Additionally, don't render filter primitives that are in error.
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/266

 rsvg_internals/src/cnode.rs                        |   2 +-
 .../266-filters-with-error-attributes.svg          | 187 +++++++++++++++++++++
 2 files changed, 188 insertions(+), 1 deletion(-)

commit 43510c118287eb1e160073e0805a03086b74bfb2
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 1 21:06:25 2018 +0300

    Get rid of some boilerplate with filter get_input

 rsvg_internals/src/filters/composite.rs | 12 +++---------
 rsvg_internals/src/filters/mod.rs       | 10 ++++++++++
 rsvg_internals/src/filters/offset.rs    |  7 ++-----
 3 files changed, 15 insertions(+), 14 deletions(-)

commit 607c28d07e022aee2dba38c26a2fd215dbd72845
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 1 12:00:20 2018 -0500

    CONTRIBUTING.md: Note on how to install/update rustfmt

 CONTRIBUTING.md | 24 ++++++++++++++++++++----
 1 file changed, 20 insertions(+), 4 deletions(-)

commit 7fa9ebb12f628e06484a2330a2ecdd919ad1d51f
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 1 10:52:14 2018 -0500

    rustfmt

 rsvg_internals/src/property_macros.rs |  2 +-
 rsvg_internals/src/shapes.rs          | 28 ++++++++++++++++------------
 rsvg_internals/src/structure.rs       | 28 ++++++++++++++++------------
 rsvg_internals/src/unitinterval.rs    |  8 +++++---
 4 files changed, 38 insertions(+), 28 deletions(-)

commit 2d8ecd19288d2c6b728f3d91baf04493490fbe9c
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 1 10:13:58 2018 -0500

    (#276) - Guard against getting a cairo_t in an error state at the toplevel API
    
    The cairo-dock program was passing a cairo_t in an error state to
    rsvg_handle_render_cairo(), and so we failed deep in the innards of
    librsvg when cairo-rs validates the cairo::Context's status.
    
    Cairo-dock was doing something like
    
      surf = cairo_image_surface_create (... an invalid size ...);
      cr = cairo_create (surf);
    
      rsvg_handle_render_cairo (handle, cr);    // we now catch the error right here
    
    We catch invalid cr's, emit a warning, and return FALSE from
    rsvg_handle_render_cairo*().
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/276

 librsvg/rsvg-handle.c | 11 +++++++++++
 tests/api.c           | 27 +++++++++++++++++++++++++++
 2 files changed, 38 insertions(+)

commit aa9e0ba1ec2fcdb258f5bb4c8b3fb9b49dfe32a7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri Jun 1 08:43:57 2018 -0500

    COMPILING.md: Note on how to run `make distcheck` so it will work

 COMPILING.md | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit 39a354893486ca157004a0ab93503ec6ab6edd81
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 1 11:35:53 2018 +0300

    Change InputSurfaceDataAccess error to assert

 rsvg_internals/src/filters/composite.rs | 8 ++------
 rsvg_internals/src/filters/error.rs     | 3 ---
 rsvg_internals/src/filters/offset.rs    | 4 +---
 3 files changed, 3 insertions(+), 12 deletions(-)

commit 341700000fc4b0e524267bc08bd56af5e03593f8
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Fri Jun 1 10:20:41 2018 +0300

    Fix srgb::{linearize,unlinearize}_surface()
    
    Make the transformations take place on unpremultiplied colors.

 rsvg_internals/src/srgb.rs | 44 +++++++++++++++++++++++++++++---------------
 1 file changed, 29 insertions(+), 15 deletions(-)

commit 62f252aa6dd4571631b52e5aec050a077ca53efe
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 31 21:12:38 2018 -0500

    rsvg_filter_render() - rename to filter_render(); don't export it
    
    And make it take/produce Rust types.
    
    We still have unsafe bits for the channelmap, which we should remove,
    anyway.
    
    Also, some unsafe for calling the render functions.

 rsvg_internals/src/drawing_ctx.rs | 22 +++++++---------
 rsvg_internals/src/filters/ffi.rs | 55 ++++++++++++++++-----------------------
 rsvg_internals/src/filters/mod.rs |  2 +-
 rsvg_internals/src/lib.rs         |  2 --
 4 files changed, 32 insertions(+), 49 deletions(-)

commit 04e708f3c0914266ad802c3c830e120a53c04a45
Merge: 1ac367ce 99e47a50
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 31 20:58:45 2018 -0500

    Merge branch 'YaLTeR/librsvg-composite-to-rust'

commit 99e47a509acc1669717d8efbce874e23f0afacf5
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 22:11:46 2018 +0300

    Use linear sRGB for feComposite

 rsvg_internals/src/filters/composite.rs | 109 ++++++++++++++++++--------------
 1 file changed, 62 insertions(+), 47 deletions(-)

commit a0c204c355ddc95c4175291888243bcee0b3841b
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 22:11:15 2018 +0300

    Add a Rust sRGB utility module

 Makefile.am                |   1 +
 rsvg_internals/src/lib.rs  |   1 +
 rsvg_internals/src/srgb.rs | 148 +++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 150 insertions(+)

commit 1ac367cef3c819bf1987dd1c80e7386dfd39d4b3
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 31 11:53:13 2018 -0500

    shapes::render_path_builder() - Remove duplicated checks for clipping
    
    push/pop_discrete_layer() already do those checks; there's no need to
    do them here.

 rsvg_internals/src/shapes.rs | 8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

commit e1b8b43ef4f16beba8de207a87434a76bd68c2ea
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 31 11:52:20 2018 -0500

    Remove superfluous cast

 rsvg_internals/src/node.rs | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5693aee06b32bf191443d3f001802efdb75fe586
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 31 11:49:51 2018 -0500

    viewport.rs: push a discrete layer in a single place

 rsvg_internals/src/viewport.rs | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 86a40d002169843962dcf48067dfde403caf81af
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 31 11:47:02 2018 -0500

    NodeMarker::render() - push a discrete layer in a single place

 rsvg_internals/src/marker.rs | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 0dbcc8ae386fa40cdf0a8b3b76a94bb055a4ee56
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 31 11:43:39 2018 -0500

    shapes::render_path_builder() - push/pop a layer here, not in the drawing function
    
    Let's try to keep the innermost drawing functions free from layers
    nonsense; they should basically just be thin wrappers over the Cairo
    machinery.
    
    This should also help abstract out push/pop_discrete_layer() into a
    separate object.

 rsvg_internals/src/draw.rs   |  6 ------
 rsvg_internals/src/shapes.rs | 10 +++++++++-
 2 files changed, 9 insertions(+), 7 deletions(-)

commit 3555313f7d0967895e8e10350e62fd25d1ada6ac
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 15:57:45 2018 +0300

    Port the composite filter effect

 Makefile.am                             |   2 +-
 librsvg/filters/composite.c             | 277 --------------------------------
 librsvg/rsvg-filter.h                   |   5 +-
 rsvg_internals/src/filters/composite.rs | 258 +++++++++++++++++++++++++++++
 rsvg_internals/src/filters/ffi.rs       |   2 +-
 rsvg_internals/src/filters/mod.rs       |   1 +
 rsvg_internals/src/lib.rs               |   1 +
 7 files changed, 265 insertions(+), 281 deletions(-)

commit 0deb6ef71f2bc6eeaf5abc76971d433748573faa
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 15:56:30 2018 +0300

    Move path_bulder::clamp() to util

 rsvg_internals/src/path_builder.rs | 11 +----------
 rsvg_internals/src/util.rs         | 10 ++++++++++
 2 files changed, 11 insertions(+), 10 deletions(-)

commit 270aaffcccdd7bd64398cc93356f4e643531695d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 15:56:00 2018 +0300

    Add parsers::number()

 rsvg_internals/src/parsers.rs | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 7ef3b7d66490bfef3bc6c118b04bcd6410cf1582
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 13:04:58 2018 +0300

    Move PrimitiveWithInput::get_input() to context

 rsvg_internals/src/filters/context.rs | 44 ++++++++++++++++++++++++++++++++++-
 rsvg_internals/src/filters/mod.rs     | 38 +-----------------------------
 2 files changed, 44 insertions(+), 38 deletions(-)

commit e9a0bf130512cd057d2d5070c7d0eb5bbef92ab5
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 12:48:14 2018 +0300

    Move filters::IRect to filters::context::IRect

 rsvg_internals/src/filters/context.rs | 16 ++++++++++++++--
 rsvg_internals/src/filters/mod.rs     | 12 +-----------
 2 files changed, 15 insertions(+), 13 deletions(-)

commit 2983c5ab6f379a4c4ec4508091fa7343b238678e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 12:43:55 2018 +0300

    Move filter_context.rs to filters/context.rs

 Makefile.am                                                  |  2 +-
 rsvg_internals/src/{filter_context.rs => filters/context.rs} |  0
 rsvg_internals/src/filters/ffi.rs                            |  2 +-
 rsvg_internals/src/filters/mod.rs                            | 10 ++++++----
 rsvg_internals/src/filters/offset.rs                         |  2 +-
 rsvg_internals/src/lib.rs                                    |  3 +--
 6 files changed, 10 insertions(+), 9 deletions(-)

commit 2132bc4ab22f6128f07efa366f35ab9fd0990e7d
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 31 12:37:03 2018 +0300

    Separate filters::Input into its own file

 Makefile.am                         |  1 +
 rsvg_internals/src/filters/input.rs | 31 +++++++++++++++++++++++++++++++
 rsvg_internals/src/filters/mod.rs   | 35 ++++-------------------------------
 3 files changed, 36 insertions(+), 31 deletions(-)

commit 1e51070987c073c9ebad7d979da2b426a9700106
Author: Jordan Petridis <jordanpetridis@protonmail.com>
Date:   Thu May 31 11:31:43 2018 +0300

    CI: Run rustc tests before cross-distro tests.
    
    Rustc compatibility tends to break more often than
    cross-distro/cross-arch test. Also if there's a cross
    reggression rustc breakage tends to sneak in since that CI stage
    can't be run till cross-distro/arch reggression is fixed.

 .gitlab-ci.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7f4a0ee7b9030d52d08f87caf5895d982631f9a3
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat May 26 20:15:23 2018 +0300

    Change Filter::render() to return a Result<>

 rsvg_internals/src/filter_context.rs | 55 ++++++++++++++++++++++--------------
 rsvg_internals/src/filters/ffi.rs    | 23 +++++++++------
 rsvg_internals/src/filters/mod.rs    | 21 ++++++++------
 rsvg_internals/src/filters/offset.rs | 28 +++++++++---------
 4 files changed, 74 insertions(+), 53 deletions(-)

commit b5e61e632970cc560e4e7378f54bea202e692a26
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat May 26 20:15:18 2018 +0300

    Add FilterError

 Makefile.am                         |  1 +
 rsvg_internals/src/filters/error.rs | 48 +++++++++++++++++++++++++++++++++++++
 2 files changed, 49 insertions(+)

commit 414185d5fee0d84df6dd59519e1221f4d06ed21e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat May 26 20:08:48 2018 +0300

    Extend Node::with_impl() to support return types

 rsvg_internals/src/node.rs | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 3982896528fe44d0b0bc8ad859d1dfc55ad3a1fd
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 19:09:00 2018 -0500

    Add back pservers-grad-18-b.svg - it passes again
    
    Now that stop-color and stop-opacity are done cleanly and without
    hacks to account for properties that do not inherit
    automatically... this is fucking great!

 .../svg1.1/{ignore-pservers-grad-18-b.svg => pservers-grad-18-b.svg}      | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 4019cd14c464ebc6ec71db768934587a4a09488a
Merge: d68723d7 baa4f0da
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 18:57:53 2018 -0500

    Merge branch 'property-inheritance' - MEGA REFACTORING
    
    This branch changes the way we do CSS cascading, which has many
    implications.
    
    After the SVG tree of nodes/elements has been loaded, we traverse the
    tree and do a CSS cascade.  Each Node has a ComputedValues inside it,
    which contains the result of its cascade.
    
    The State struct is just a small remnant now: it only holds each
    node's SpecifiedValues (e.g. as specified in the SVG file), and some
    information which should really go in the Node, not in the State -
    important_styles and the results of cond evaluation.
    
    The drawing_ctx no longer has a State!  This used to carry around the
    current cascade, and that state.affine had the current affine.  At the
    very bottom of the drawing process, we would cr.set_matrix(that_affine)
    and draw.
    
    But now, the drawing_ctx->cr has the running affine.  The code has to
    be careful to maintain it accurate.  This is a bit horrible right now,
    but we will refactor it gradually to make this foolproof.
    
    Normally a node would be able to use its own node.values (the
    ComputedValues) to get the cascade it needs... except the <use>
    element causes the referenced element to use the <use>'s own cascade,
    not the referenced element's original cascade.  So, we introduce
    CascadedValues, an enum that can resolve itself to a node's normal
    cascade or the derived one from <use>, as needed.
    
    All calls to make_property!() have been audited so that ther
    inherits_automatically is correct as per the spec.
    
    There's a new, ignored test - ignore-masking-path-07-b.svg.  It fails
    if run; that's because we don't handle clip paths with unions.  We
    will have to do another big refactor to solve this.

commit baa4f0da3d9610694630ff402f191985a725cae7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 18:52:32 2018 -0500

    Rename test to ignore-masking-path-07-b.svg - it fails; will file a bug
    
    We don't handle nested clips with unions:
    
      <clipPath id="foo" clip-path="uri(#other-clip)">   // intersection
        <path ... clip-path="uri(#some-clip)"/>          // start union
        <path ... clip-path="uri(#some-other-clip"/>     // next in union
      </clipPath>
    
      <path ... clip-path="uri(#foo)"/>  // ends up with the wrong clip
    
    This is because Cairo can only shrink the clip region via
    cairo_clip().
    
    I think we'll have to deal with SVG clip paths as masks, so that we
    can union them as needed.  Sigh, another big refactor upcoming.

 .../svg1.1/{masking-path-07-b.svg => ignore-masking-path-07-b.svg}        | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 27f4bb9dce35c4bdc96af9f80382bb80f7a64dac
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 18:47:15 2018 -0500

    Preserve the cr's affine for clipping and masking before setting it to the identity matrix
    
    We need the identity matrix to cr.paint() in the end.  However, the
    clipping and masking procedures need to know the original matrix that
    the cr was carrying.
    
    This fixes 761175-recursive-masks.svg and 91-nonzero-translation.svg - FINALLY!

 rsvg_internals/src/clip_path.rs   | 22 +++++++++++-----------
 rsvg_internals/src/drawing_ctx.rs | 12 +++++++++---
 rsvg_internals/src/mask.rs        |  9 +++++++--
 3 files changed, 27 insertions(+), 16 deletions(-)

commit 34f07a839c9493f34db5d958e394896476d3ae34
Merge: 14a90e96 d68723d7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 14:22:19 2018 -0500

    Merge remote-tracking branch 'origin/master' into property-inheritance

commit d68723d7dc108b9cf5fffece86e090d180817f5e
Merge: 8248acf7 dbbbb606
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 14:07:12 2018 -0500

    Merge branch 'saurvs/librsvg-test'

commit 14a90e9662a1037b542737f45d6e6a490f78b9b9
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 13:35:59 2018 -0500

    masking-path-07-b.svg - Add test; this fails right now
    
    (The reference image is not according to librsvg's text rendering;
    I'll regenerate it by hand when the actual clipping is correct)

 .../reftests/svg1.1/masking-path-07-b-ref.png      | Bin 0 -> 13226 bytes
 .../fixtures/reftests/svg1.1/masking-path-07-b.svg | 147 +++++++++++++++++++++
 2 files changed, 147 insertions(+)

commit dbbbb606e54ea854ed676987b3963bdac958a687
Author: Saurav Sachidanand <sauravsachidanand@gmail.com>
Date:   Wed May 30 23:41:51 2018 +0530

    Write test artifacts to tests/output

 .gitlab-ci.yml    |  6 +-----
 tests/Makefile.am |  3 +++
 tests/README.md   | 15 ++++++++-------
 tests/rsvg-test.c | 14 +++++++++++++-
 4 files changed, 25 insertions(+), 13 deletions(-)

commit 17ccfc73c341a75b65f3bf8e7a3bec2639f5bb9b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 13:05:25 2018 -0500

    Use default implementations of NodeTrait::{draw, get_c_impl}
    
    Instead of littering all the code with an empty "fn draw" and the same
    code for "fn get_c_impl".

 rsvg_internals/src/clip_path.rs      | 18 +----------------
 rsvg_internals/src/cnode.rs          | 12 ------------
 rsvg_internals/src/filters/mod.rs    | 13 +-----------
 rsvg_internals/src/filters/offset.rs | 16 +--------------
 rsvg_internals/src/gradient.rs       |  8 --------
 rsvg_internals/src/image.rs          |  4 ----
 rsvg_internals/src/link.rs           |  4 ----
 rsvg_internals/src/marker.rs         |  8 --------
 rsvg_internals/src/mask.rs           | 18 +----------------
 rsvg_internals/src/node.rs           | 26 +++++++++++-------------
 rsvg_internals/src/pattern.rs        |  8 --------
 rsvg_internals/src/shapes.rs         | 24 -----------------------
 rsvg_internals/src/stop.rs           |  9 ---------
 rsvg_internals/src/structure.rs      | 32 ------------------------------
 rsvg_internals/src/text.rs           | 38 +-----------------------------------
 15 files changed, 16 insertions(+), 222 deletions(-)

commit 835c92e46ef834664ead63cce59addeb9108f097
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 12:47:59 2018 -0500

    Replace "dominate" argument with "with_layer: bool"
    
    We only had these:
    
    dominate=-1 -> with_layer=false
    dominate=0 -> with_layer=true
    dominate=1 -> with_layer=true
    
    The 0/1 values were remnants from when we didn't do cascading with
    CascadedValues.

 rsvg_internals/src/clip_path.rs      |  4 ++--
 rsvg_internals/src/cnode.rs          |  2 +-
 rsvg_internals/src/drawing_ctx.rs    |  6 +++---
 rsvg_internals/src/filters/mod.rs    |  4 ++--
 rsvg_internals/src/filters/offset.rs |  2 +-
 rsvg_internals/src/gradient.rs       |  2 +-
 rsvg_internals/src/image.rs          |  2 +-
 rsvg_internals/src/link.rs           |  6 +++---
 rsvg_internals/src/marker.rs         |  4 ++--
 rsvg_internals/src/mask.rs           |  4 ++--
 rsvg_internals/src/node.rs           | 17 +++++++++--------
 rsvg_internals/src/pattern.rs        |  4 ++--
 rsvg_internals/src/shapes.rs         | 12 ++++++------
 rsvg_internals/src/stop.rs           |  2 +-
 rsvg_internals/src/structure.rs      | 22 +++++++++++-----------
 rsvg_internals/src/text.rs           |  8 ++++----
 16 files changed, 51 insertions(+), 50 deletions(-)

commit d4eb2f3dff4c12c64e0171829f8019856ccc8523
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 12:14:24 2018 -0500

    rsvg_drawing_ctx_draw_node_from_stack(): Don't take a dominate argument; it was always passed as 0
    
    We'll remove the dominate argument gradually.  The C callers were
    always passing 0, so don't make them pass this and instead pass that
    value from the Rust implementation of that function.

 librsvg/rsvg-drawing-ctx.c        | 2 +-
 librsvg/rsvg-drawing-ctx.h        | 1 -
 librsvg/rsvg-handle.c             | 6 +++---
 rsvg_internals/src/drawing_ctx.rs | 9 +--------
 4 files changed, 5 insertions(+), 13 deletions(-)

commit fbc5f05426c67c4d286d2b947d1e9f13d7930e1b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 11:17:53 2018 -0500

    NodeUse: don't save/restore the context for non-symbol references
    
    This was clearing the cr's fill_rule on shapes being drawn in the context
    of clip paths, thus canceling the effects of a clip-rule property.

 rsvg_internals/src/structure.rs | 3 ---
 1 file changed, 3 deletions(-)

commit 8248acf710e7d204f4255466095e7b022f8b27fa
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat May 26 11:42:16 2018 +0300

    Clean up unsafe in FilterContext::compute_bounds()

 rsvg_internals/src/filter_context.rs | 17 +++++++++--------
 1 file changed, 9 insertions(+), 8 deletions(-)

commit 3a46343abb84cac62e8a191263842ded88069326
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Sat May 26 11:41:55 2018 +0300

    Fix rounding in FilterContext::compute_bounds()

 rsvg_internals/src/filter_context.rs                |   8 ++++----
 .../reftests/svg1.1/filters-composite-02-b-ref.png  | Bin 15845 -> 15874 bytes
 2 files changed, 4 insertions(+), 4 deletions(-)

commit 7dd72cbcb73536be085a9415bfe5290e2ad8a798
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 08:40:17 2018 -0500

    For all properties, add comments linking to their spec definitions

 rsvg_internals/src/state.rs | 58 ++++++++++++++++++++++++++++++++++++++-------
 1 file changed, 50 insertions(+), 8 deletions(-)

commit eab10da85902b8d5fb306da1ba2141a587b1b850
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 08:37:21 2018 -0500

    The 'unicode-bidi' property shouldn't inherit by default, per the spec

 rsvg_internals/src/state.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0b6929b17cf2aa75c38a37511ded634e3605f783
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 08:35:54 2018 -0500

    The 'text-decoration' property shouldn't inherit by default, per the spec

 rsvg_internals/src/state.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 355753b8e3aa803160400f4dd700617467226051
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 08:30:59 2018 -0500

    The "overflow" property shouldn't inherit automatically, per the spec

 rsvg_internals/src/state.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d8c014355b3adef1346e3bf3cdfacea3626e6d33
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 08:13:58 2018 -0500

    The "display" property shouldn't inherit by default, per the spec

 rsvg_internals/src/state.rs | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 1b2a09b1e9bbb6a159255d1a5e447dc405bb0669
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 30 07:57:44 2018 -0500

    State.affine - removed field; it's unused now

 rsvg_internals/src/state.rs | 12 ------------
 1 file changed, 12 deletions(-)

commit 1366ae0faaa78b63807a8e99e11830cba5dfda51
Merge: 9c413a90 6ce0c0ec
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Wed May 30 12:29:46 2018 +0000

    Merge branch 'property-inheritance' into 'property-inheritance'
    
    Some cleanup for property-inheritance
    
    See merge request federico/librsvg!2

commit 6ce0c0ecf0dfbb7ba84e94474f561fe9b4baef9a
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Wed May 30 09:03:52 2018 +0200

    node: avoid use of get_state_mut when overriding properties

 rsvg_internals/src/marker.rs | 5 ++---
 rsvg_internals/src/node.rs   | 9 +++++----
 2 files changed, 7 insertions(+), 7 deletions(-)

commit 682731fd233d33b9c8cbfb938921f9043750bf97
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Wed May 30 00:06:34 2018 +0200

    state: remove C getter/setter for affine

 rsvg_internals/src/lib.rs   |  2 --
 rsvg_internals/src/state.rs | 13 -------------
 2 files changed, 15 deletions(-)

commit b43540e207b94e6ff53e7de3bd70179de4b1888e
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Tue May 29 23:57:13 2018 +0200

    state: we do not need to store parent anymore

 rsvg_internals/src/cnode.rs |  4 +---
 rsvg_internals/src/lib.rs   |  1 -
 rsvg_internals/src/node.rs  |  2 +-
 rsvg_internals/src/state.rs | 42 +++---------------------------------------
 4 files changed, 5 insertions(+), 44 deletions(-)

commit 9c413a90efc5e760ddb7bcd557be9e69e3e88427
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 19:27:49 2018 -0500

    NodeTrait::set_overriden_attributes() - new trait method
    
    This is called after parsing the node's style properties; it is used
    for nodes which need to override any properties from the defaults.
    
    We use this from NodeMarker, because markers are always displayed,
    even if the marker element itself is set to display:none.

 librsvg/rsvg-load.c          |  2 ++
 librsvg/rsvg-private.h       |  4 ++++
 rsvg_internals/src/lib.rs    |  1 +
 rsvg_internals/src/marker.rs | 10 ++++++----
 rsvg_internals/src/node.rs   | 21 +++++++++++++++++++++
 5 files changed, 34 insertions(+), 4 deletions(-)

commit 595f255b52d467f5a481b778ffa452be99c20671
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 18:58:19 2018 -0500

    Node::draw() - Take a CascadedValues instead of a ComputedValues
    
    Same thing for Node::draw_children().  This lets nodes propagate the
    cascading mode that they got from whoever is drawing them.

 rsvg_internals/src/clip_path.rs      |  16 +++--
 rsvg_internals/src/cnode.rs          |   4 +-
 rsvg_internals/src/drawing_ctx.rs    |  16 +++--
 rsvg_internals/src/filters/mod.rs    |   7 +-
 rsvg_internals/src/filters/offset.rs |  13 +++-
 rsvg_internals/src/gradient.rs       |   2 +-
 rsvg_internals/src/image.rs          |   5 +-
 rsvg_internals/src/link.rs           |  19 +++--
 rsvg_internals/src/marker.rs         |   4 +-
 rsvg_internals/src/mask.rs           |  16 +++--
 rsvg_internals/src/node.rs           |  64 +++++++++++------
 rsvg_internals/src/pattern.rs        |   4 +-
 rsvg_internals/src/shapes.rs         |  24 +++++--
 rsvg_internals/src/stop.rs           |   3 +-
 rsvg_internals/src/structure.rs      |  35 +++++----
 rsvg_internals/src/text.rs           | 133 ++++++++++++++++++++++++-----------
 16 files changed, 244 insertions(+), 121 deletions(-)

commit 6c8d1dcf7e610b9bc7db4727af60b2ba6a736b0b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 17:30:56 2018 -0500

    CascadedValues: provide a separate get() function to actually get the &ComputedValues

 rsvg_internals/src/clip_path.rs      |  5 +--
 rsvg_internals/src/drawing_ctx.rs    |  4 ++-
 rsvg_internals/src/filter_context.rs | 15 ++++----
 rsvg_internals/src/filters/ffi.rs    |  4 +--
 rsvg_internals/src/filters/mod.rs    |  5 +--
 rsvg_internals/src/filters/offset.rs |  7 ++--
 rsvg_internals/src/gradient.rs       | 10 ++++--
 rsvg_internals/src/marker.rs         | 19 +++++-----
 rsvg_internals/src/mask.rs           | 13 +++----
 rsvg_internals/src/node.rs           | 67 +++++++++++++++++++-----------------
 rsvg_internals/src/pattern.rs        |  7 ++--
 rsvg_internals/src/text.rs           |  6 ++--
 12 files changed, 92 insertions(+), 70 deletions(-)

commit 6c15b7d7fa330beab513bec4afe13a6eed3094e7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 15:24:45 2018 -0500

    Rename Node.get_computed_values() to get_cascaded_values() since that's what it produces

 rsvg_internals/src/clip_path.rs      | 2 +-
 rsvg_internals/src/drawing_ctx.rs    | 2 +-
 rsvg_internals/src/filter_context.rs | 6 +++---
 rsvg_internals/src/filters/ffi.rs    | 4 ++--
 rsvg_internals/src/filters/mod.rs    | 2 +-
 rsvg_internals/src/filters/offset.rs | 2 +-
 rsvg_internals/src/gradient.rs       | 4 ++--
 rsvg_internals/src/marker.rs         | 2 +-
 rsvg_internals/src/mask.rs           | 2 +-
 rsvg_internals/src/node.rs           | 6 +++---
 rsvg_internals/src/pattern.rs        | 4 ++--
 rsvg_internals/src/text.rs           | 4 ++--
 12 files changed, 20 insertions(+), 20 deletions(-)

commit 1a32779a63ee4c20dd4b2234d25b38175888093b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 15:21:09 2018 -0500

    A few docs for CascadedValues

 rsvg_internals/src/node.rs | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit d5b25526d260dd81007ba9988a437eca6828500c
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 15:14:27 2018 -0500

    node::CascadedValues - return this from get_computed_values()
    
    CascadedValues will turn into something similar to Cow.  It can either
    deref to a node's own ComputedValues, or to a values that is cascaded
    on demand.
    
    The former will be for drawing elements in a normal context; they can
    just use their precomputed cascade.  The latter will be for elements
    being drawn in a <use> context, where the <use> overrides the cascade.

 rsvg_internals/src/node.rs | 21 +++++++++++++++++++--
 1 file changed, 19 insertions(+), 2 deletions(-)

commit 503c0b989fc50f4e2ea33c24815849f94a1faee2
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 13:37:01 2018 -0500

    rsvg_drawing_ctx_draw_node_from_stack(): Port to Rust
    
    We remove the "values" argument from it, since it was always being
    passed as NULL from the C code.

 librsvg/rsvg-drawing-ctx.c        | 20 +--------
 librsvg/rsvg-drawing-ctx.h        |  2 +-
 librsvg/rsvg-handle.c             |  6 +--
 librsvg/rsvg-private.h            |  4 --
 rsvg_internals/src/drawing_ctx.rs | 90 +++++++++++++++++++++++++++------------
 rsvg_internals/src/lib.rs         |  7 +--
 rsvg_internals/src/node.rs        | 79 ++++------------------------------
 rsvg_internals/src/state.rs       |  8 ++++
 rsvg_internals/src/structure.rs   | 22 ++++++----
 9 files changed, 102 insertions(+), 136 deletions(-)

commit 414813767e2beb66bda8790977a0cc72108e4be5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 13:02:46 2018 -0500

    rsvg_drawing_ctx_draw_node_from_stack(): Factor out functions to preserve the stack

 librsvg/rsvg-drawing-ctx.c | 44 +++++++++++++++++++++++++++++++++-----------
 librsvg/rsvg-drawing-ctx.h | 10 ++++++++++
 2 files changed, 43 insertions(+), 11 deletions(-)

commit a70f0abf0831031f8b8266580338edb237f37473
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 12:35:56 2018 -0500

    rsvg-test: Allow a difference of 2 for each channel on 64-bit
    
    This makes pservers-grad-13-b.svg pass again.  The gradients seems to
    be affected a bit by offsetting / not offsetting.

 tests/rsvg-test.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cdb3e625ccf6f849da2fe9da9a79cfee6bf30454
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 29 12:07:23 2018 -0500

    add_clipping_rect(): Don't take in an affine; assume the cr is already transformed

 rsvg_internals/src/draw.rs     | 15 ++++++---------
 rsvg_internals/src/image.rs    |  2 +-
 rsvg_internals/src/marker.rs   | 11 ++---------
 rsvg_internals/src/mask.rs     |  4 ++--
 rsvg_internals/src/viewport.rs | 12 ++++++------
 5 files changed, 17 insertions(+), 27 deletions(-)

commit 75ce573ab2290c16a19e437abe9a9a24b3b3149a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 20:22:37 2018 -0500

    rsvg-test.c: Restore the frame offset; this exposes offsetting bugs

 tests/rsvg-test.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4bdd560a19248b7d72aa589590adc84984d5e0a5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 20:15:25 2018 -0500

    Use the correct affine for the temporary cairo_t when rendering a node to a surface
    
    This makes filters-composite-02-b.svg pass - it's regenerated because
    of the text rendering changes.

 librsvg/rsvg-drawing-ctx.c                          |   5 +++++
 librsvg/rsvg-drawing-ctx.h                          |   3 +--
 .../reftests/svg1.1/filters-composite-02-b-ref.png  | Bin 15845 -> 16018 bytes
 3 files changed, 6 insertions(+), 2 deletions(-)

commit b6eea22f24b7129b26c62ced67a96edb871b6668
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 20:14:57 2018 -0500

    rsvg_drawing_ctx_draw_node_on_surface(): Don't pass the parent's computed values; use the child's implicitly

 librsvg/filters/image.c    | 1 -
 librsvg/rsvg-drawing-ctx.c | 5 ++---
 2 files changed, 2 insertions(+), 4 deletions(-)

commit 0765fdf9490a18bafb24af420ac6598589d65351
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 20:01:39 2018 -0500

    Pass the filter primitive's computed values to its ::render() method, not the filter context's
    
    This fixes filters-offset-01-b.svg

 rsvg_internals/src/filters/ffi.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0a2b6852dc373bf77d81039edc6984b804103cfb
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 18:57:25 2018 -0500

    clip_path.rs: Remove debug println

 rsvg_internals/src/clip_path.rs | 2 --
 1 file changed, 2 deletions(-)

commit 105ecf5246b37a0b36bd9361a95f84b433b728f8
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 18:52:23 2018 -0500

    Regenerate tests that failed due to text rendering, after seeing what's going on
    
    The old code would create/measure Pango layouts with the Cairo
    context's affine set to an identity matrix.  It would later actually
    render them with the final matrix.
    
    The new code keeps the cr's matrix always updated, so the Pango
    layouts get created for Cairo contexts that are already transformed.
    This produces slight differences in rendering.  I think this version
    is more correct, since the font machinery will have had a chance to
    make decisions about hinting/etc. for the actual size at which the
    text will be rendered, not an abstract unscaled size.

 .../bugs/777834-empty-text-children-ref.png         | Bin 8475 -> 8624 bytes
 .../reftests/svg1.1/coords-trans-02-t-ref.png       | Bin 8110 -> 8110 bytes
 .../reftests/svg1.1/coords-trans-03-t-ref.png       | Bin 7743 -> 7743 bytes
 .../reftests/svg1.1/coords-trans-04-t-ref.png       | Bin 6589 -> 6589 bytes
 .../reftests/svg1.1/coords-trans-05-t-ref.png       | Bin 7854 -> 7854 bytes
 .../reftests/svg1.1/coords-trans-06-t-ref.png       | Bin 8249 -> 8249 bytes
 .../reftests/svg1.1/paths-data-04-t-ref.png         | Bin 17803 -> 17834 bytes
 .../reftests/svg1.1/paths-data-05-t-ref.png         | Bin 15886 -> 15885 bytes
 .../reftests/svg1.1/paths-data-06-t-ref.png         | Bin 7110 -> 7112 bytes
 .../reftests/svg1.1/paths-data-07-t-ref.png         | Bin 6376 -> 6377 bytes
 .../reftests/svg1.1/paths-data-08-t-ref.png         | Bin 18904 -> 18904 bytes
 .../reftests/svg1.1/pservers-grad-08-b-ref.png      | Bin 37447 -> 37446 bytes
 12 files changed, 0 insertions(+), 0 deletions(-)

commit 68503f7959abf5c5e4282d1a958162a1377f37cc
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 15:59:11 2018 -0500

    pservers-grad-13-b-ref.png - Regenerate; this is working correctly.

 .../reftests/svg1.1/pservers-grad-13-b-ref.png      | Bin 92537 -> 92508 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 4a7481c63c718532346269470d520c4cd8393653
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 15:48:23 2018 -0500

    state_reinherit_top() - Remove, and also remove resulting unused functions

 librsvg/rsvg-styles.h             |  12 --
 rsvg_internals/src/drawing_ctx.rs |  51 +-------
 rsvg_internals/src/marker.rs      |   2 +-
 rsvg_internals/src/node.rs        |   2 -
 rsvg_internals/src/state.rs       | 267 --------------------------------------
 rsvg_internals/src/structure.rs   |   3 +-
 6 files changed, 3 insertions(+), 334 deletions(-)

commit 44f1cd397b7996aab2e4117b042ba525d1df9795
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 14:54:57 2018 -0500

    Node::draw() - Add a DrawCascade enum, to use the node's computed values or a new cascade
    
    The DrawCascade::From(values) will be used for the Use element, which
    overrides the node's natural cascade.

 rsvg_internals/src/node.rs | 48 ++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 42 insertions(+), 6 deletions(-)

commit 83413331a506778f56013d16aae485f4310d233d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 14:40:24 2018 -0500

    Remove calls to state_reinherit_top() which weren't doing anything

 rsvg_internals/src/clip_path.rs | 2 --
 rsvg_internals/src/pattern.rs   | 1 -
 rsvg_internals/src/text.rs      | 2 --
 3 files changed, 5 deletions(-)

commit 1ec67e5f0ed74324b4dedd89f40e4d994bc42a17
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 14:31:43 2018 -0500

    NodeChars: don't set node.state.cond when creating the node
    
    No idea why this was there.

 rsvg_internals/src/drawing_ctx.rs | 53 +++++++++++++++++++--------------------
 rsvg_internals/src/text.rs        | 17 ++-----------
 2 files changed, 28 insertions(+), 42 deletions(-)

commit db04afbd51943e9b1c2563df3174ffd1adfaad25
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 14:30:00 2018 -0500

    rsvg_node_get_state() - removed

 librsvg/rsvg-private.h            | 4 ----
 rsvg_internals/src/drawing_ctx.rs | 3 ---
 rsvg_internals/src/lib.rs         | 5 +----
 rsvg_internals/src/node.rs        | 8 --------
 rsvg_internals/src/text.rs        | 9 ++++-----
 5 files changed, 5 insertions(+), 24 deletions(-)

commit 74775ef5792c3c7214cbb1a0f204259c5572e866
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 14:18:36 2018 -0500

    draw_ctx->state - remove this field.  W00t!
    
    We remove state_push() and all variations of get_current_state() as well.

 librsvg/rsvg-drawing-ctx.c        | 21 +---------------
 librsvg/rsvg-drawing-ctx.h        | 10 --------
 rsvg_internals/src/drawing_ctx.rs | 51 ++-------------------------------------
 rsvg_internals/src/lib.rs         |  1 -
 4 files changed, 3 insertions(+), 80 deletions(-)

commit 4570995a70392d1bd1f34ca1bad16f1c3580f6b8
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 14:08:56 2018 -0500

    rsvg_drawing_ctx_new(): use the cr's affine as the starting affine, not the state's

 librsvg/rsvg-drawing-ctx.c | 23 +++++++----------------
 1 file changed, 7 insertions(+), 16 deletions(-)

commit 7b9475e6b70934d6de0bd4d0bf65ec8ed71a1681
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 14:04:29 2018 -0500

    rsvg_drawing_ctx_push_bounding_box(): Use the cr's affine, not the state's

 librsvg/rsvg-drawing-ctx.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 7df03149ffe7ada6c53df234ade8fc8c40d76ad7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 13:59:58 2018 -0500

    Remove calls to state_push() from nodes.
    
    We only have to remove the initial one from RsvgDrawingCtx.

 rsvg_internals/src/clip_path.rs | 2 --
 rsvg_internals/src/mask.rs      | 1 -
 rsvg_internals/src/pattern.rs   | 1 -
 rsvg_internals/src/structure.rs | 4 ----
 rsvg_internals/src/text.rs      | 3 ---
 5 files changed, 11 deletions(-)

commit 6bd862ef91b50ea5dac62efaa0eb0241a9bc01e7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 13:55:25 2018 -0500

    feImage: set the affine on the cr, not the State

 librsvg/filters/image.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 49d12d918af94121e17ecd1ce980b06381f32004
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 13:47:49 2018 -0500

    state_pop(): Removed.
    
    state_push() is just used now to create the initial State in the
    RsvgDrawingCtx, and get_current_state() is used in a couple of places
    to fetch some values that we haven't redone yet.
    
    This commit also makes state_push() only push the first time; all
    subsequent calls don't add new states to the stack.

 librsvg/rsvg-drawing-ctx.c        |  1 -
 librsvg/rsvg-drawing-ctx.h        |  2 --
 rsvg_internals/src/clip_path.rs   |  2 --
 rsvg_internals/src/drawing_ctx.rs | 18 +-----------------
 rsvg_internals/src/lib.rs         |  1 -
 rsvg_internals/src/mask.rs        |  1 -
 rsvg_internals/src/pattern.rs     |  1 -
 rsvg_internals/src/structure.rs   |  4 ----
 rsvg_internals/src/text.rs        |  4 ----
 9 files changed, 1 insertion(+), 33 deletions(-)

commit 06457b0adbfcae6e3cfb17b9de54f8212e219a46
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 13:41:33 2018 -0500

    Remove unused function

 rsvg_internals/src/drawing_ctx.rs | 11 -----------
 1 file changed, 11 deletions(-)

commit 32bf0432041573656e650cfacf5a009c5d9d602a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 28 13:34:02 2018 -0500

    baseline-shift should not inherit automatically, per the spec
    
    Also, fix which ComputedValues gets used for NodeChars.  A NodeChars
    is not a real SVG element; it's just our container for character
    data.  So, use the current node's computed values for it, instead of
    the synthesized ones for the NodeChars.

 rsvg_internals/src/property_macros.rs |  2 +-
 rsvg_internals/src/state.rs           |  3 ++-
 rsvg_internals/src/text.rs            | 16 ++++++++++++----
 3 files changed, 15 insertions(+), 6 deletions(-)

commit f17210327623f59d4b1fbec538850b145f2fc069
Author: Jordan Petridis <jordanpetridis@protonmail.com>
Date:   Sun May 27 12:48:50 2018 +0000

    node.rs: Match on reference.
    
    While rustc 1.26 is smarter and can figure it out, this was
    not able to compile on all the other rustc version librsvg
    currently supports.

 rsvg_internals/src/node.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 854b0c485f0af9081301309f37ffaa0f92ec697a
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun May 27 11:25:33 2018 +0200

    state: reimplement baseline_shift
    
    Use a custom compute implementation to calculate the the computed
    value

 rsvg_internals/src/drawing_ctx.rs     | 41 -----------------------------------
 rsvg_internals/src/property_macros.rs |  5 +++--
 rsvg_internals/src/state.rs           | 35 +++++++++++++++++++++---------
 rsvg_internals/src/text.rs            |  2 +-
 4 files changed, 29 insertions(+), 54 deletions(-)

commit edc09819c42bbd9f30f89b641aa852bcd3fe55fa
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun May 27 11:16:37 2018 +0200

    property: rename method to 'compute' and take all values as param
    
    Some properties need to know other properties' value in order to
    compute their resulting value (e.g. baseline-shift needs to know
    the parent font-size). Refactor all property macro machinery
    to be parametric on the type of the ComputedValues type, rename
    'inherit_from' to 'compute' and make it take the whole computed
    values as param instead of just the computed value of the property
    itself.
    Note: the implementation of baseline-shift is not changed yet.

 rsvg_internals/src/drawing_ctx.rs     |  18 ++--
 rsvg_internals/src/property_macros.rs |  73 ++++++++-------
 rsvg_internals/src/state.rs           | 171 ++++++++++++++++++++++------------
 3 files changed, 160 insertions(+), 102 deletions(-)

commit 308a4bd33daa68cf99cc584572bad36f474f13c3
Author: Saurav Sachidanand <sauravsachidanand@gmail.com>
Date:   Fri May 25 10:24:14 2018 +0530

    Make Node store pointers to immediate siblings, first/last child

 rsvg_internals/src/node.rs | 106 +++++++++++++++++++++++++++------------------
 1 file changed, 65 insertions(+), 41 deletions(-)

commit 9e3d70ca70316a5aaa859eab485474eafbbd03c5
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 26 16:19:13 2018 +0200

    property_macros: use ":" also for the impl params

 rsvg_internals/src/property_macros.rs | 8 ++++----
 rsvg_internals/src/state.rs           | 6 +++---
 2 files changed, 7 insertions(+), 7 deletions(-)

commit ebb5474c2597746566ba0b593345883880ce8dff
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 26 16:15:39 2018 +0200

    property_macros: pass in a parse_impl param
    
    Instead of just assuming that the Parse trait is implemented by
    the caller. This is more consistent with the property_impl param

 rsvg_internals/src/property_macros.rs | 13 ++++--
 rsvg_internals/src/state.rs           | 74 ++++++++++++++++++-----------------
 2 files changed, 49 insertions(+), 38 deletions(-)

commit fdb90d419bddf1a781430a72d1adfb56a267b677
Merge: 7736fe4f 77fb1d52
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sat May 26 00:28:05 2018 -0500

    Merge branch 'property-inheritance' of gitlab.gnome.org:pborelli/librsvg into property-inheritance

commit 7736fe4fb374099c545c460fc289b5541bf4b549
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sat May 26 00:16:51 2018 -0500

    marker: Force display=inline for markers; not quite fixed yet
    
    Markers are always displayed even if they or their ancestors are
    display:none.  We force this and this fixes the case for ancestors
    with display:none, but it doesn't work for markers with display:none
    because after this point in the code, the toplevel loading calls
    rsvg_parse_style_attrs() and overwrites our value.
    
    Partially fixes painting-marker-07-f.svg
    
    We may need some post-set-atts step...

 rsvg_internals/src/marker.rs | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit d6a752f8bc5d937e47ea05f631698d4b398ba486
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 23:55:03 2018 -0500

    mask.rs: Remove unnecessary cr.save()/restore()

 rsvg_internals/src/mask.rs | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit cee6047eae1dc6bbea52aa446c9c7c59e9fe9c53
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 23:42:00 2018 -0500

    Don't inadvertently clear the clip path during Node::draw()
    
    In Node::draw(), we were doing a cr.save()/restore() pair around the
    actual NodeTrait::draw().  This caused any clip path drawn during this
    method to be cleared.
    
    Instead, we just save the current transformation matrix and restore
    it.  I wonder if we need to follow this same pattern elsewhere.
    
    Fixes masking-path-05-f.svg.

 rsvg_internals/src/draw.rs | 12 ------------
 rsvg_internals/src/node.rs |  4 ++--
 2 files changed, 2 insertions(+), 14 deletions(-)

commit 5149dbf4efb4a909e524268e1e3f88ae5fda2ede
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 23:41:21 2018 -0500

    clip_path: No need to push/pop_discrete_layer(); they do nothing when clipping, anyway

 rsvg_internals/src/clip_path.rs | 3 ---
 1 file changed, 3 deletions(-)

commit 03ca75a1f9725f7e91e3cf5e21836cae198843a1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 23:10:25 2018 -0500

    mask.rs: Fixed affines, hopefully, and fixed endianness of the luminance computation
    
    Cairo is argb32 in platform-endian chunks, so on little-endian it
    shows up as [bb gg rr aa]

 rsvg_internals/src/mask.rs | 21 ++++++++++++---------
 1 file changed, 12 insertions(+), 9 deletions(-)

commit 42d5c94c4cf3a5e9b6a1ff2da288e7ea1f1be494
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 22:38:40 2018 -0500

    push_render_stack(): Copy the current cr's matrix when creating a new surface
    
    The new surface gets a new child_cr, and *that* one starts with an
    identity matrix.  So, preserve the current transformation matrix by
    copying it to the child_cr.
    
    This fixes a *ton* of tests; all of Adwaita passes again.

 rsvg_internals/src/drawing_ctx.rs | 1 +
 1 file changed, 1 insertion(+)

commit 5cc1d41d51a1c7b61c81b9996c0d0b8f969df27b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 20:47:05 2018 -0500

    wip: try to fix clipping

 rsvg_internals/src/clip_path.rs | 23 +++++++++++++++--------
 1 file changed, 15 insertions(+), 8 deletions(-)

commit 6d7651fa8b2594eaebce49e89347f6c16bd7d4e1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 20:18:44 2018 -0500

    text: Use each children's computed values, not our passed-down values
    
    This fixes text-align-03-b.svg.
    
    Text child nodes don't render themselves; we do that from the
    NodeText.  We may have to do a custom cascade if the <text> is inside
    a <use>.

 rsvg_internals/src/text.rs | 28 ++++++++++++++++++----------
 1 file changed, 18 insertions(+), 10 deletions(-)

commit f20212f1e2680a02a658aa150fe9ef194381e12e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 20:10:11 2018 -0500

    Make the C accessors for computed values take an RsvgComputedValues, not a node

 librsvg/filters/diffuse_lighting.c  |  2 +-
 librsvg/filters/flood.c             |  4 ++--
 librsvg/filters/specular_lighting.c |  2 +-
 librsvg/rsvg-private.h              | 12 +++++------
 rsvg_internals/src/lib.rs           |  6 +++---
 rsvg_internals/src/node.rs          | 40 -------------------------------------
 rsvg_internals/src/state.rs         | 31 ++++++++++++++++++++++++++++
 7 files changed, 44 insertions(+), 53 deletions(-)

commit e260c6d0a6ebe75d6e09322776f4062aa091ac4a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 19:57:09 2018 -0500

    Node::draw() / draw_children() - Take a ComputedValues argument
    
    It turns out that the <use> element acts as if it does a "deep clone
    of the referenced element" but the styles from the referenced
    element's ancestors are not used - the <use>'s styles are used
    instead.
    
    So, we'll need to have NodeUse do its own cascading for the purposes
    of the referenced element: we will pass a ComputedValues to
    Node::draw() and draw_children(); for NodeUse this will be a
    custom-cascaded ComputedValues, and for normal rendering it will be
    the values from the global cascade.

 librsvg/filters/blend.c              |   2 +-
 librsvg/filters/color_matrix.c       |   2 +-
 librsvg/filters/common.c             |   8 +--
 librsvg/filters/common.h             |   4 +-
 librsvg/filters/component_transfer.c |   2 +-
 librsvg/filters/composite.c          |   2 +-
 librsvg/filters/convolve_matrix.c    |   2 +-
 librsvg/filters/diffuse_lighting.c   |   6 +-
 librsvg/filters/displacement_map.c   |   2 +-
 librsvg/filters/erode.c              |   2 +-
 librsvg/filters/flood.c              |   2 +-
 librsvg/filters/gaussian_blur.c      |   2 +-
 librsvg/filters/image.c              |   7 ++-
 librsvg/filters/light_source.c       |  22 +++----
 librsvg/filters/light_source.h       |   4 +-
 librsvg/filters/merge.c              |   4 +-
 librsvg/filters/specular_lighting.c  |   6 +-
 librsvg/filters/tile.c               |   2 +-
 librsvg/filters/turbulence.c         |   2 +-
 librsvg/rsvg-drawing-ctx.c           |   6 +-
 librsvg/rsvg-drawing-ctx.h           |   2 +
 librsvg/rsvg-handle.c                |   6 +-
 librsvg/rsvg-private.h               |  11 ++--
 rsvg_internals/src/clip_path.rs      |  11 ++--
 rsvg_internals/src/cnode.rs          |   3 +-
 rsvg_internals/src/drawing_ctx.rs    |  11 +++-
 rsvg_internals/src/filters/ffi.rs    |  17 +++++-
 rsvg_internals/src/filters/mod.rs    |   5 +-
 rsvg_internals/src/filters/offset.rs |   3 +-
 rsvg_internals/src/gradient.rs       |   2 +-
 rsvg_internals/src/image.rs          |  12 +++-
 rsvg_internals/src/length.rs         |  11 ++--
 rsvg_internals/src/lib.rs            |   1 -
 rsvg_internals/src/link.rs           |  14 ++++-
 rsvg_internals/src/marker.rs         |   4 +-
 rsvg_internals/src/mask.rs           |   6 +-
 rsvg_internals/src/node.rs           |  81 ++++++++++++-------------
 rsvg_internals/src/pattern.rs        |   9 +--
 rsvg_internals/src/shapes.rs         | 114 +++++++++++++++++------------------
 rsvg_internals/src/state.rs          |   3 +
 rsvg_internals/src/stop.rs           |   3 +-
 rsvg_internals/src/structure.rs      |  66 ++++++++++++--------
 rsvg_internals/src/text.rs           |  94 +++++++++++++++++------------
 43 files changed, 327 insertions(+), 251 deletions(-)

commit bcdb697c91649cdff9a01401774758679c587c6b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 17:30:40 2018 -0500

    pattern.rs: Get the affine from the current cairo context
    
    This fixes affines in patterns.

 rsvg_internals/src/pattern.rs | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit 46ba1d9b27013985ba89972ebca7b7facdefcaf1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 17:19:37 2018 -0500

    FilterContext: store the filter node, and pass down the computed values for length normalization

 librsvg/filters/diffuse_lighting.c   |  4 +--
 librsvg/filters/light_source.c       | 24 +++++++------
 librsvg/filters/light_source.h       |  6 ++--
 librsvg/filters/specular_lighting.c  |  4 +--
 rsvg_internals/src/filter_context.rs | 65 ++++++++++++++++++++++++------------
 rsvg_internals/src/filters/ffi.rs    |  3 +-
 rsvg_internals/src/filters/mod.rs    |  6 +++-
 rsvg_internals/src/filters/offset.rs |  4 ++-
 rsvg_internals/src/state.rs          |  2 +-
 9 files changed, 75 insertions(+), 43 deletions(-)

commit 1578bad5d2b89fb7284b3cdf64f7b6fc44188d92
Merge: 5c8adbdc 26e4cb46
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 16:43:32 2018 -0500

    Merge remote-tracking branch 'origin/master' into property-inheritance

commit 5c8adbdc52090509313b0a4eb53d0e3c9e80dfe3
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 16:42:02 2018 -0500

    WIP: RsvgLength::normalize() now takes a ComputedValues, to get the current font size
    
    It used to get the current font size from the drawing_ctx's state, but
    that is going away.
    
    We also do the normalization of font size here now, instead of in
    drawing_ctx::get_normalized_font_size().

 librsvg/rsvg-private.h               |  2 +-
 rsvg_internals/src/draw.rs           |  9 ++++--
 rsvg_internals/src/drawing_ctx.rs    |  6 +---
 rsvg_internals/src/filters/offset.rs |  4 +--
 rsvg_internals/src/gradient.rs       | 34 +++++++++++---------
 rsvg_internals/src/image.rs          |  8 ++---
 rsvg_internals/src/length.rs         | 61 +++++++++++++++++++++++++-----------
 rsvg_internals/src/marker.rs         | 10 +++---
 rsvg_internals/src/mask.rs           |  8 ++---
 rsvg_internals/src/pattern.rs        | 16 ++++++----
 rsvg_internals/src/shapes.rs         | 50 ++++++++++++++++-------------
 rsvg_internals/src/structure.rs      | 16 +++++-----
 rsvg_internals/src/text.rs           | 24 +++++++-------
 13 files changed, 145 insertions(+), 103 deletions(-)

commit 26f1de4e9c06e1f424d8c35d1dc81d297e16d313
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 12:02:33 2018 -0500

    FontSize: Implement custom inheritance from the old get_normalized_font_size()

 rsvg_internals/src/state.rs | 27 ++++++++++++++++++++++++---
 rsvg_internals/src/text.rs  |  2 +-
 2 files changed, 25 insertions(+), 4 deletions(-)

commit 75f279585cf72f0e3a4d0f7b858c87bc7d3a2e69
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 25 11:28:06 2018 -0500

    make_property!() - Let the caller fully implement Property for at least one of our variants
    
    We will use this for FontSize, as it needs to be inherited in a custom
    way which is not just a clone().

 rsvg_internals/src/property_macros.rs | 70 ++++++++++++++++++++++++++++++++++-
 1 file changed, 68 insertions(+), 2 deletions(-)

commit 26e4cb4605e7055cff48694977be70f5f4101baa
Merge: 9f32fba4 c60f6456
Author: Federico Mena Quintero <federico.mena@gmail.com>
Date:   Fri May 25 14:12:27 2018 +0000

    Merge branch 'filter-get-bounds-to-rust' into 'master'
    
    rsvg_filter_primitive_get_bounds() => Rust
    
    See merge request GNOME/librsvg!66

commit ddd8d2d3a898b32c1293354b8ca8d111d99b89ef
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 21:24:00 2018 -0500

    Property: add an inherit_from() function.  This will let us derive text properties.
    
    The font-size of an element is sometimes computed with respect to
    the font-size of the parent element.  Instead of cloning the parent
    property, we'll now have a custom method to allow custom derivation of
    property values.

 rsvg_internals/src/property_macros.rs | 5 +++++
 rsvg_internals/src/state.rs           | 2 +-
 2 files changed, 6 insertions(+), 1 deletion(-)

commit f7c10b834a898cebc11f753b8275539ca3cc8973
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 21:08:22 2018 -0500

    marker.rs: Also set the affine on the inner cr
    
    Another cr gets created by the call to push_discrete_layer().  This
    is funky.
    
    But this fixes markers, apparently!
    
    The marker tests don't pass because text is broken, but the markers
    are correct.

 rsvg_internals/src/marker.rs | 3 +++
 1 file changed, 3 insertions(+)

commit e5540764f793f9816c70c8b6648ba9f1b105b460
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 21:01:14 2018 -0500

    marker.rs: Get ComputedValues from the caller
    
    Try to fix the affines in marker.render() - getting there.

 rsvg_internals/src/marker.rs | 63 +++++++++++++++++++++-----------------------
 rsvg_internals/src/shapes.rs |  2 +-
 2 files changed, 31 insertions(+), 34 deletions(-)

commit 8360d8b1d04e4d5135d824b8d4f061cb2b29e7f2
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 21:00:48 2018 -0500

    Remove unused import

 rsvg_internals/src/structure.rs | 2 --
 1 file changed, 2 deletions(-)

commit d1934b5397bba6c0d7bdf7c0fe8bd95648f7e5d4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 20:30:15 2018 -0500

    Don't have the affine in ComputedValues
    
    THIS BREAKS A LOT OF STUFF.  The idea is that each Node carries its
    own, un-aggregated transform.
    
    I'm not yet sure where to carry the aggregated transform during
    rendering.  Here I'm trying to put it implicitly in the draw_ctx.cr,
    but this means we must save/restore the cr whenever we mess with its
    transform.  Which makes sense in a Cairo-centric scheme of things, but
    breaks our assumptions that the only way to change the cr's matrix is
    through a hard cr.set_matrix().
    
    Also, since we now use node.get_transform() where we previously used
    values.affine (or even state.affine), things break because they are
    now getting un-aggregated transforms.  I guess I'll have to audit this
    at each step.

 rsvg_internals/src/draw.rs      | 48 ++++++++++++++++++++++++++++-------------
 rsvg_internals/src/image.rs     |  7 +++++-
 rsvg_internals/src/marker.rs    |  2 +-
 rsvg_internals/src/mask.rs      |  4 ++--
 rsvg_internals/src/state.rs     |  4 ----
 rsvg_internals/src/structure.rs | 16 ++++++--------
 rsvg_internals/src/viewport.rs  |  3 +--
 7 files changed, 50 insertions(+), 34 deletions(-)

commit 881ec7e46908fdc8a9721af4f8d2327b5cae0a78
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 20:29:22 2018 -0500

    rsvg-test.c: for now, don't use a non-identity transformation to start the tests
    
    This will make it easier to debug the rest.  We'll restore this in the end.

 tests/rsvg-test.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3b995da294e9250f1b9f293e57172c4e4b4d807d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 19:30:21 2018 -0500

    wip: debug transforms

 rsvg_internals/src/draw.rs | 5 +++++
 1 file changed, 5 insertions(+)

commit b36c962eec4e3b36db67c8b2b3e6e3c09f46934a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 19:02:26 2018 -0500

    wip: debug transforms

 rsvg_internals/src/clip_path.rs | 3 +++
 rsvg_internals/src/draw.rs      | 2 ++
 rsvg_internals/src/node.rs      | 2 +-
 3 files changed, 6 insertions(+), 1 deletion(-)

commit 032c95aefc061b8388da13a6bc54f1805a112c5f
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 18:48:49 2018 -0500

    wip: clip_path.rs: set the cr's transform when we are in objectBoundingBox mode

 rsvg_internals/src/clip_path.rs | 19 +++++++++----------
 1 file changed, 9 insertions(+), 10 deletions(-)

commit 00ddd0fdcdfc5fd897bd7c012eb4fa65146b4c2e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 18:26:00 2018 -0500

    text.rs: Compose the transform on the cr for the nodes that don't draw themselves
    
    NodeChars, NodeTspan, NodeTref

 rsvg_internals/src/text.rs | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit 2fb418cb52d84e87c7b32d133d65bfac2e8b27bc
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 18:13:32 2018 -0500

    Node::draw(): transform the cr with the node's transform

 rsvg_internals/src/node.rs | 18 +++++-------------
 1 file changed, 5 insertions(+), 13 deletions(-)

commit eccd749b5bc763a10be21bcbe90e538dce793f98
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 18:02:42 2018 -0500

    Node::set_atts() - Parse the transform attribute here

 rsvg_internals/src/node.rs | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

commit ce9abc65cd4dec0b788447e0c5b0665431f86b68
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 17:53:38 2018 -0500

    Node: add a "transform" field; we'll keep it here
    
    The "transform" is not a style property, it is an attribute for each
    element.  So, we'll keep it in the Node, without any extra
    transformations - unlike State, which keeps a composed affine of all
    the ancestor elements.

 rsvg_internals/src/node.rs | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 77fb1d5252810cbd739c0d7c7a2d0fa06238c38a
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Thu May 24 22:54:11 2018 +0200

    draw: remove unused C function

 librsvg/rsvg-drawing-ctx.c |  9 ---------
 rsvg_internals/src/draw.rs | 12 ------------
 rsvg_internals/src/lib.rs  |  2 --
 3 files changed, 23 deletions(-)

commit 2db48ad3ca8bc2448895fcf928489a50cc452462
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Thu May 24 22:52:43 2018 +0200

    styles: remove unused typedef

 librsvg/rsvg-styles.c | 2 --
 1 file changed, 2 deletions(-)

commit 83ef08112241a20cd3ce3a661559fdf623fec0f0
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Thu May 24 22:38:39 2018 +0200

    drawing_ctx: avoid some conversions

 rsvg_internals/src/drawing_ctx.rs | 28 +++++++++++++---------------
 1 file changed, 13 insertions(+), 15 deletions(-)

commit c60f645660e65961dee8b2bda7ebcbe43a84eb0e
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 24 19:26:06 2018 +0300

    Get rid of offset.c

 Makefile.am              |   1 -
 librsvg/filters/offset.c | 173 -----------------------------------------------
 2 files changed, 174 deletions(-)

commit f2d0468edc4bc9490985f4351ca8bd5a150789d1
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 24 19:24:55 2018 +0300

    Port rsvg_filter_primitive_get_bounds() to Rust

 librsvg/filters/common.c             | 166 +++++++++++++++++------------------
 librsvg/filters/common.h             |   3 +-
 rsvg_internals/src/filter_context.rs |  33 +++++++
 rsvg_internals/src/filters/ffi.rs    |  45 ++--------
 rsvg_internals/src/filters/mod.rs    |   2 +-
 rsvg_internals/src/lib.rs            |   1 +
 6 files changed, 129 insertions(+), 121 deletions(-)

commit 46811c89e421e6802668b1b29503cd33ee026bdf
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 24 19:23:56 2018 +0300

    Add FilterContext::compute_bounds()

 rsvg_internals/src/filter_context.rs | 103 +++++++++++++++++++++++++++--------
 rsvg_internals/src/filters/mod.rs    |  16 +-----
 2 files changed, 83 insertions(+), 36 deletions(-)

commit 0545856e85666a3d26b2c5cbe0ea7ec575e96ed5
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 11:59:48 2018 -0500

    Fix default for stop-color, per the spec.
    
    This fixes pservers-grad-23-f.svg.

 rsvg_internals/src/state.rs | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 60956ca9d34ba57de74c9902d1b92842bb682fe1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 11:50:40 2018 -0500

    State::reconstruct() / ::inherit() - Removed; they are unused now.  Yay!

 rsvg_internals/src/state.rs | 19 -------------------
 1 file changed, 19 deletions(-)

commit b872640ad03137a97453a5403dcd05cc83197037
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 11:31:21 2018 -0500

    Resolve gradient stop-color and stop-opacity at rendering time.
    
    This lets us remove the mess of calling reconstruct() in stop.rs.

 rsvg_internals/src/gradient.rs | 51 +++++++++++++++++-----------
 rsvg_internals/src/state.rs    |  4 +--
 rsvg_internals/src/stop.rs     | 76 +-----------------------------------------
 3 files changed, 34 insertions(+), 97 deletions(-)

commit 41933d110d1551f4fdb01e93daf7c5fa080d07dd
Author: Ivan Molodetskikh <yalterz@gmail.com>
Date:   Thu May 24 19:22:09 2018 +0300

    Add BoundingBox::with_rect()

 rsvg_internals/src/bbox.rs | 4 ++++
 1 file changed, 4 insertions(+)

commit b4c595a353430f74e9c1da884e44a43a0f869826
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:50:20 2018 -0500

    Remove unused rsvg_state_parse_{presentation_attributes,style_declarations}

 rsvg_internals/src/lib.rs   |  2 --
 rsvg_internals/src/state.rs | 36 ++----------------------------------
 2 files changed, 2 insertions(+), 36 deletions(-)

commit d341f115ee38eccdc0bb72432521906a338a6630
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:41:25 2018 -0500

    marker.rs: Don't reconstruct the state; use the computed values instead
    
    The affine we pass down to the children is still wrong; we'll take
    care of that soon.

 rsvg_internals/src/marker.rs | 23 ++++++-----------------
 1 file changed, 6 insertions(+), 17 deletions(-)

commit 393ff3b7c32b1c28f2d59e602587740cd9b4395d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:43:14 2018 -0500

    rsvg_state_reconstruct(): Remove; it's no longer used in the C code

 rsvg_internals/src/lib.rs   |  1 -
 rsvg_internals/src/state.rs | 10 ----------
 2 files changed, 11 deletions(-)

commit c03afa06f1ed4f0352b4673980678d8b844c2536
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:35:55 2018 -0500

    Remove unused prototypes

 librsvg/rsvg-styles.h | 8 --------
 1 file changed, 8 deletions(-)

commit 9959883d30c330baf561d30697d4f4902acaf52b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:30:53 2018 -0500

    Remove unused prototypes

 librsvg/rsvg-styles.c | 2 --
 1 file changed, 2 deletions(-)

commit 265ebc9006c641af75513a3ece7b9fcdcbb7fab6
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:28:44 2018 -0500

    flood-color / flood-opacity: Get them at rendering time from the node's computed values

 librsvg/filters/flood.c     |  7 ++-----
 librsvg/rsvg-private.h      |  8 ++++++++
 librsvg/rsvg-styles.h       |  8 --------
 rsvg_internals/src/lib.rs   |  4 ++--
 rsvg_internals/src/node.rs  | 24 ++++++++++++++++++++++++
 rsvg_internals/src/state.rs | 26 --------------------------
 6 files changed, 36 insertions(+), 41 deletions(-)

commit 6eece57c7d9cf82235b598ebb4827ad063e0d049
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:15:39 2018 -0500

    flood-color and flood-opacity should not inherit automatically, per the spec

 rsvg_internals/src/state.rs | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 895f8a4d2e32c692dfcdabb6a1e4d933f2078ed6
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 10:12:48 2018 -0500

    diffuse_lighting / specular_lighting: Get the lighting-color property from the computed styles
    
    And do it at rendering time, when we have the computed values.  This
    removes a bunch of code to resolve the lighting-color from the current
    color.
    
    This also lets us remove rsvg_state_get_current_color().

 librsvg/filters/diffuse_lighting.c  | 47 +++++++------------------------------
 librsvg/filters/specular_lighting.c | 47 +++++++------------------------------
 librsvg/rsvg-private.h              |  4 ++++
 librsvg/rsvg-styles.h               |  4 ----
 rsvg_internals/src/lib.rs           |  2 +-
 rsvg_internals/src/node.rs          | 16 +++++++++++++
 rsvg_internals/src/state.rs         | 31 +++++++++++++++++-------
 7 files changed, 59 insertions(+), 92 deletions(-)

commit b978eed219e2fcfffbcbf51e6b3fb5f96056300d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 09:29:39 2018 -0500

    rsvg_state_get_opacity(): Removed; it's unused now.

 librsvg/rsvg-styles.h       | 4 ----
 rsvg_internals/src/lib.rs   | 1 -
 rsvg_internals/src/state.rs | 7 -------
 3 files changed, 12 deletions(-)

commit 1c2c2fae2de2c6e3e939ec8794f9ce48463b766d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 09:27:03 2018 -0500

    Remove unused prototype

 librsvg/rsvg-styles.h | 4 ----
 1 file changed, 4 deletions(-)

commit e5c21759b4a8e3545a0b5071c71ea2142db841f4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 09:25:29 2018 -0500

    rsvg_state_is_visible(): Replaced with rsvg_node_values_is_visible()
    
    This uses the node's computed values instead of the state's specified
    values.

 librsvg/rsvg-drawing-ctx.c  |  5 +----
 librsvg/rsvg-private.h      |  6 ++++--
 librsvg/rsvg-styles.h       |  4 ----
 rsvg_internals/src/lib.rs   |  2 +-
 rsvg_internals/src/node.rs  | 26 +++++++++++++++++++++++++-
 rsvg_internals/src/state.rs | 17 -----------------
 6 files changed, 31 insertions(+), 29 deletions(-)

commit 4ea7126e085ec8a66f0e5323c7db1580c929d455
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 09:09:38 2018 -0500

    rsvg_cairo_clip() - port to Rust as NodeClipPath::to_cairo_context()
    
    Thanks to Paolo for providing the template for doing this in the port
    of rsvg_cairo_generate_mask().

 librsvg/rsvg-drawing-ctx.c        | 52 -----------------------------------
 librsvg/rsvg-drawing-ctx.h        |  3 --
 librsvg/rsvg-structure.h          |  4 ---
 rsvg_internals/src/clip_path.rs   | 58 +++++++++++++++++++++++++++++----------
 rsvg_internals/src/drawing_ctx.rs | 44 +++++++++++++----------------
 rsvg_internals/src/lib.rs         |  2 +-
 6 files changed, 63 insertions(+), 100 deletions(-)

commit 95b5210c28769e0c00356bcb4af9f319299d6db4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 07:45:08 2018 -0500

    mask.rs: Iterate all the pixels in each row

 rsvg_internals/src/mask.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 62a47ac2417d20cd28a87740bee0b9be40fec795
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Thu May 24 07:44:35 2018 -0500

    Mask.generate_cairo_mask() - Get the computed values from the node, not the state

 rsvg_internals/src/drawing_ctx.rs |  3 +--
 rsvg_internals/src/mask.rs        | 17 +++++++----------
 2 files changed, 8 insertions(+), 12 deletions(-)

commit 9d7158073265c68c0476dde38fe0483aa42b3e2d
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon May 21 19:05:27 2018 +0200

    mask: port generating the cairo mask to rust
    
    This is a line by line port of the C version, including the
    manual grayscale conversion of pixels

 Makefile.am                       |   1 -
 librsvg/rsvg-drawing-ctx.c        | 152 +-------------------------
 librsvg/rsvg-load.c               |   3 +-
 librsvg/rsvg-mask.h               |  70 ------------
 librsvg/rsvg-structure.h          |   8 ++
 rsvg_internals/src/drawing_ctx.rs |  27 +++--
 rsvg_internals/src/lib.rs         |  10 +-
 rsvg_internals/src/mask.rs        | 221 +++++++++++++++++++++++---------------
 8 files changed, 167 insertions(+), 325 deletions(-)

commit 37ebccad1a46d09db12357b079114d59bdad9c1f
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 19:23:52 2018 -0500

    text.rs: Obtain the computed values from the nodes; don't pass them down

 rsvg_internals/src/text.rs | 79 ++++++++++++++++++++--------------------------
 1 file changed, 35 insertions(+), 44 deletions(-)

commit 561e6392d0ad067adc32d906f1be157f3ec0bd36
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 19:06:25 2018 -0500

    Node::draw() - do not get passed a ComputedValues; obtain it from the node itself

 rsvg_internals/src/clip_path.rs      |   3 +-
 rsvg_internals/src/cnode.rs          |   3 +-
 rsvg_internals/src/filters/mod.rs    |   5 +-
 rsvg_internals/src/filters/offset.rs |   3 +-
 rsvg_internals/src/gradient.rs       |   3 +-
 rsvg_internals/src/image.rs          |  12 +---
 rsvg_internals/src/link.rs           |  10 +---
 rsvg_internals/src/marker.rs         |   7 +--
 rsvg_internals/src/mask.rs           |   3 +-
 rsvg_internals/src/node.rs           |  41 ++++----------
 rsvg_internals/src/pattern.rs        |  15 +----
 rsvg_internals/src/shapes.rs         | 106 +++++++++++++++++------------------
 rsvg_internals/src/stop.rs           |   4 +-
 rsvg_internals/src/structure.rs      |  52 +++++------------
 rsvg_internals/src/text.rs           |  17 ++----
 15 files changed, 104 insertions(+), 180 deletions(-)

commit 4d4078ade6ae904b6789c86e667da58652320097
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 13:19:25 2018 -0500

    push/pop_discrete_layer(): Take a ComputedValues argument
    
    We pass this down to push/pop_render_stack(), which fetch the
    clipping/masking values for the current node from the
    ComputedValues.

 rsvg_internals/src/draw.rs        |  4 +--
 rsvg_internals/src/drawing_ctx.rs | 59 +++++++++++++++++----------------------
 rsvg_internals/src/image.rs       |  4 +--
 rsvg_internals/src/marker.rs      |  8 ++++--
 rsvg_internals/src/node.rs        | 24 +++++++++++++---
 rsvg_internals/src/pattern.rs     | 12 ++++++--
 rsvg_internals/src/structure.rs   | 24 +++++++++++-----
 rsvg_internals/src/text.rs        |  4 +--
 rsvg_internals/src/viewport.rs    | 27 ++++++++++--------
 9 files changed, 99 insertions(+), 67 deletions(-)

commit a9a5b65ee098919e8aa408b7d59a23fb3fc17b55
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 12:52:54 2018 -0500

    push_render_stack() / pop_render_stack() - Port to Rust
    
    This lets us remove a bunch of wrappers, too.

 librsvg/rsvg-drawing-ctx.c        | 183 ------------------------
 librsvg/rsvg-drawing-ctx.h        |   5 -
 librsvg/rsvg-styles.h             |  22 ---
 rsvg_internals/src/clip_path.rs   |   2 +-
 rsvg_internals/src/coord_units.rs |   2 +-
 rsvg_internals/src/drawing_ctx.rs | 283 +++++++++++++++++++++++++++++++++++---
 rsvg_internals/src/filters/ffi.rs |   2 +-
 rsvg_internals/src/lib.rs         |   5 -
 rsvg_internals/src/node.rs        |   8 +-
 rsvg_internals/src/state.rs       |  64 ---------
 10 files changed, 274 insertions(+), 302 deletions(-)

commit 43602117e47509bc4107e4232bedba0d6defd9bd
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 12:51:48 2018 -0500

    rsvg_cairo_clip() / rsvg_cairo_generate_mask() - make public

 librsvg/rsvg-drawing-ctx.c | 4 ++--
 librsvg/rsvg-drawing-ctx.h | 6 ++++++
 2 files changed, 8 insertions(+), 2 deletions(-)

commit 408f4edf1d7df23ee9cf3d5346ed1d86d25fa619
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 11:16:31 2018 -0500

    NodeClipPath.get_units(): New function

 rsvg_internals/src/clip_path.rs | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 18fde88c0a81f9879586661b17a3c5159e024e6b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 10:44:07 2018 -0500

    rsvg-drawing-ctx.c: Make the push/pop_*() functions public
    
    This will let us port rsvg_drawing_ctx_push/pop_render_stack() to Rust.

 librsvg/rsvg-drawing-ctx.c | 90 +++++++++++++++++++++++-----------------------
 librsvg/rsvg-drawing-ctx.h | 14 ++++++++
 2 files changed, 59 insertions(+), 45 deletions(-)

commit 87570dd259354faeaabf11ae9cc3bea46aabdee9
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 10:38:23 2018 -0500

    rsvg_drawing_ctx_pop_render_stack() - Don't access draw_ctx->bbox directly

 librsvg/rsvg-drawing-ctx.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 45ba940a3c5e4c2be6dbf7570cb7762d57d45163
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 10:35:57 2018 -0500

    rsvg_drawing_ctx_push/pop_render_stack() - Don't access draw_ctx->cr directly

 librsvg/rsvg-drawing-ctx.c | 18 ++++++++++--------
 1 file changed, 10 insertions(+), 8 deletions(-)

commit ba3056ae459293f15ccc7f3b69166f7ceeda018d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 10:29:43 2018 -0500

    rsvg_drawing_ctx_push_render_stack() - Use accessors for the context's width/height

 librsvg/rsvg-drawing-ctx.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 67398bdda8378d7397a208487a012bf604316896
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 10:16:01 2018 -0500

    Make rsvg_drawing_ctx_get_offset() return nested offsets
    
    This lets the Rust code not have to take special action depending on
    whether its cr is nested or not.

 librsvg/filters/common.c          |  4 ++--
 librsvg/rsvg-drawing-ctx.c        | 36 +++++++++++++++++++++++++++---------
 librsvg/rsvg-drawing-ctx.h        |  3 +++
 rsvg_internals/src/draw.rs        |  6 +-----
 rsvg_internals/src/drawing_ctx.rs | 13 -------------
 5 files changed, 33 insertions(+), 29 deletions(-)

commit c2e9afd1bebfa6275ac5c6717cc6419ac1177e93
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 10:03:03 2018 -0500

    Factor out the cr stack from rsvg_drawing_ctx_push/pop_render_stack()
    
    And rationalize the reference counting of surfaces in the latter.

 librsvg/rsvg-drawing-ctx.c | 42 ++++++++++++++++++++++++++++++------------
 1 file changed, 30 insertions(+), 12 deletions(-)

commit d6e9a14dc050b21db3c34ec59984faa1978b48a1
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 09:38:34 2018 -0500

    rustfmt

 rsvg_internals/src/aspect_ratio.rs   | 11 ++++++-----
 rsvg_internals/src/color.rs          |  4 +++-
 rsvg_internals/src/filters/mod.rs    |  6 ++++--
 rsvg_internals/src/filters/offset.rs |  7 +++++--
 rsvg_internals/src/gradient.rs       |  4 +++-
 rsvg_internals/src/marker.rs         | 29 +++++++++++++++++------------
 rsvg_internals/src/path_parser.rs    | 19 ++++++++++++-------
 rsvg_internals/src/pattern.rs        | 14 ++++++++++----
 rsvg_internals/src/shapes.rs         | 12 ++++++++----
 rsvg_internals/src/stop.rs           |  4 +++-
 rsvg_internals/src/structure.rs      |  6 ++++--
 rsvg_internals/src/text.rs           | 12 ++++++++----
 rsvg_internals/src/transform.rs      | 36 ++++++++++++++++++++----------------
 13 files changed, 103 insertions(+), 61 deletions(-)

commit da167fe34cc66ae7be9a940e7c815b96acf59a84
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 09:37:46 2018 -0500

    rsvg_cairo_clip(): Remove obsolete checks
    
    I was using them just to assert that I hadn't broken some stuff when
    moving clipping away from its own context.

 librsvg/rsvg-drawing-ctx.c | 8 --------
 1 file changed, 8 deletions(-)

commit 160e16427965ab9e49f059f2aab1c4b4f55a17fa
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 09:34:40 2018 -0500

    Extract the surface stack handling from push/pop_render_stack()
    
    This will make it easier to port push/pop_render_stack() to Rust.

 librsvg/rsvg-drawing-ctx.c | 29 +++++++++++++++++++++++------
 1 file changed, 23 insertions(+), 6 deletions(-)

commit 9a5e0b6c1f69734e8d2dd9b32ccc93d8f5f41622
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 23 09:13:25 2018 -0500

    Wherever ComputedValues are passed, call the variable "values", not "state"

 rsvg_internals/src/aspect_ratio.rs   |  11 ++--
 rsvg_internals/src/cnode.rs          |   2 +-
 rsvg_internals/src/color.rs          |   4 +-
 rsvg_internals/src/draw.rs           |  84 +++++++++++++-------------
 rsvg_internals/src/filters/mod.rs    |   6 +-
 rsvg_internals/src/filters/offset.rs |   7 +--
 rsvg_internals/src/gradient.rs       |   4 +-
 rsvg_internals/src/image.rs          |   8 +--
 rsvg_internals/src/link.rs           |   2 +-
 rsvg_internals/src/marker.rs         |  29 ++++-----
 rsvg_internals/src/node.rs           |   2 +-
 rsvg_internals/src/path_parser.rs    |  19 +++---
 rsvg_internals/src/pattern.rs        |  14 ++---
 rsvg_internals/src/shapes.rs         |  44 +++++++-------
 rsvg_internals/src/stop.rs           |   4 +-
 rsvg_internals/src/structure.rs      |  24 ++++----
 rsvg_internals/src/text.rs           | 112 +++++++++++++++++------------------
 rsvg_internals/src/transform.rs      |  36 +++++------
 18 files changed, 185 insertions(+), 227 deletions(-)

commit 08fc90b4cbc78ec46362dd4e1fb9289f0bf62a3f
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 17:58:10 2018 -0500

    wip: debug affines in Node::draw()

 rsvg_internals/src/node.rs | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 88dbdcf34842d034bd537f33abbd170eda7129fc
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 17:34:57 2018 -0500

    State::to_computed_values() - compute the correct affine

 rsvg_internals/src/state.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f7452096cfdc8657b9e29a394ad90f129b9a3267
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 15:58:52 2018 -0500

    rsvg_defs_load_extern(): Cascade the newly-loaded RsvgHandle

 librsvg/rsvg-defs.c    |  1 +
 librsvg/rsvg-handle.c  | 10 +++++-----
 librsvg/rsvg-private.h |  3 +++
 3 files changed, 9 insertions(+), 5 deletions(-)

commit 339cc30835efbf669eea0a0fd3cc6d691841f32d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 15:48:28 2018 -0500

    Node::draw(): use the cascaded computed values, not the reinherited ones

 rsvg_internals/src/node.rs | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

commit 1629368b67baf9029951b9f2fe10a7d9594536d4
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 14:46:38 2018 -0500

    RsvgHandle: do a cascade before running the rendering process

 librsvg/rsvg-handle.c      | 13 +++++++++++++
 librsvg/rsvg-private.h     |  6 ++++++
 rsvg_internals/src/lib.rs  |  1 +
 rsvg_internals/src/node.rs | 10 ++++++++++
 4 files changed, 30 insertions(+)

commit bd052c439828643e71cf85b23b3a0dbbc5571a44
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 14:36:26 2018 -0500

    Node.cascade() - New function; takes a ComputedValues and propagates it to children

 rsvg_internals/src/node.rs  | 16 ++++++++++++++--
 rsvg_internals/src/state.rs |  8 ++++++--
 2 files changed, 20 insertions(+), 4 deletions(-)

commit 3caeca378ca8559423284c9c520555b4ee632154
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 13:45:49 2018 -0500

    Node: Add a values field for ComputedValues and a set/get_computed_values() methods
    
    We will do the cascading and store the computed values for each node
    with these.

 rsvg_internals/src/node.rs | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit 9f32fba40ce420ca024fe225cab09d44d5bc329b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 08:33:51 2018 -0500

    rsvg_node_draw_children(): Don't take a "dominate" argument

 librsvg/rsvg-drawing-ctx.c | 4 ++--
 librsvg/rsvg-private.h     | 2 +-
 rsvg_internals/src/node.rs | 3 ---
 3 files changed, 3 insertions(+), 6 deletions(-)

commit ba5d0eed032c73d02548ea04fc01dd13e787579e
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 08:30:00 2018 -0500

    rsvg_node_draw_children(): Handle dominate==0 specially here, since it's the only value used now
    
    All the C callers to rsvg_node_draw_children() pass dominate=0.
    Handle that specially in this function, so that we can remove the
    "dominate" argument downstream later.

 rsvg_internals/src/node.rs | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 96eb9c0e15533d67185db97b49f331d194562575
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 08:19:18 2018 -0500

    NodeUse: Inline the special behavior of dominate=1

 rsvg_internals/src/structure.rs | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 13bc944acf162bbe0bca1173add7ef9201714a22
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Tue May 22 08:14:01 2018 -0500

    pattern.rs: Inline the special behavior of dominate==2
    
    We are going to remove the obscure "dominate" argument gradually.
    Here, we inline the special behavior that
    node.draw_children(dominate = 2) would have, and pass -1 instead to
    make it *not* reinherit the state or push a layer.

 rsvg_internals/src/pattern.rs | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit e373d0a86f531d9642f9f30fb9050cb5513263d7
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 21 20:56:54 2018 -0500

    State: store a SpecifiedValues, not each specific field
    
    We change parse_property() to return a SpecifiedValue<T> instead of Option<T>.
    
    We tweak all the accesses as state.values.prop.unwrap_or_default() to use
    SpecifiedValue's idioms.
    
    Eventually all those accesses to state.values will go away, as
    elements get ComputedValues instead of the intermediate
    representations.

 rsvg_internals/src/drawing_ctx.rs |   9 +-
 rsvg_internals/src/marker.rs      |  34 ++-
 rsvg_internals/src/node.rs        |   4 +-
 rsvg_internals/src/state.rs       | 574 +++++++++++++++++++-------------------
 rsvg_internals/src/stop.rs        |  41 +--
 5 files changed, 335 insertions(+), 327 deletions(-)

commit fdd2a98c7dc3ee708604484708662b8db35db0b3
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 21 20:09:42 2018 -0500

    SpecifiedValues::to_computed_values() - Also inherit xml_lang and xml_space

 rsvg_internals/src/state.rs | 2 ++
 1 file changed, 2 insertions(+)

commit ecb6791d963c15a672598d0e481d1502e6216288
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 21 20:01:06 2018 -0500

    A few docs for SpecifiedValue

 rsvg_internals/src/state.rs | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 13bb8274b97f7e33490a8fd05836f2ebe6f49089
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sun May 20 13:27:37 2018 -0500

    Set overflow:hidden by default on elements that establish a new viewport
    
    Per https://www.w3.org/TR/SVG/styling.html#UAStyleSheet - now that we
    depend on proper default values, there are a few elements that need
    different "overflow" defaults that others.

 rsvg_internals/src/image.rs     | 11 ++++++++++-
 rsvg_internals/src/marker.rs    |  6 +++++-
 rsvg_internals/src/node.rs      |  7 ++++++-
 rsvg_internals/src/pattern.rs   |  4 ++++
 rsvg_internals/src/structure.rs | 10 +++++++++-
 5 files changed, 34 insertions(+), 4 deletions(-)

commit 6b6c13c66f09bf559fb5caafc7e3375c530cf0bf
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 18 19:03:05 2018 -0500

    Node::draw() - Get a ComputedValues, not a State
    
    This makes all the drawing code lose the pattern of
    
      state.some_prop.unwrap_or_default()
    
    and instead they can use
    
      state.some_prop
    
    since properties have already been resolved.
    
    We will remove the horrible get_computed_values() shortly.

 librsvg/filters/blend.c              |   1 -
 librsvg/filters/color_matrix.c       |   1 -
 librsvg/filters/common.c             |  11 --
 librsvg/filters/component_transfer.c |   2 -
 librsvg/filters/composite.c          |   1 -
 librsvg/filters/convolve_matrix.c    |   1 -
 librsvg/filters/diffuse_lighting.c   |   1 -
 librsvg/filters/displacement_map.c   |   1 -
 librsvg/filters/erode.c              |   1 -
 librsvg/filters/flood.c              |   1 -
 librsvg/filters/gaussian_blur.c      |   1 -
 librsvg/filters/image.c              |   1 -
 librsvg/filters/light_source.c       |   1 -
 librsvg/filters/merge.c              |   2 -
 librsvg/filters/offset.c             |   1 -
 librsvg/filters/specular_lighting.c  |   1 -
 librsvg/filters/tile.c               |   1 -
 librsvg/filters/turbulence.c         |   1 -
 librsvg/rsvg-filter.c                |   1 -
 librsvg/rsvg-private.h               |   7 --
 rsvg_internals/src/clip_path.rs      |   4 +-
 rsvg_internals/src/cnode.rs          |  37 ++----
 rsvg_internals/src/draw.rs           | 219 +++++++++++------------------------
 rsvg_internals/src/filters/mod.rs    |   6 +-
 rsvg_internals/src/filters/offset.rs |   4 +-
 rsvg_internals/src/gradient.rs       |   4 +-
 rsvg_internals/src/image.rs          |   4 +-
 rsvg_internals/src/link.rs           |   4 +-
 rsvg_internals/src/marker.rs         |   4 +-
 rsvg_internals/src/mask.rs           |   4 +-
 rsvg_internals/src/node.rs           |   9 +-
 rsvg_internals/src/pattern.rs        |   4 +-
 rsvg_internals/src/shapes.rs         |  18 +--
 rsvg_internals/src/state.rs          | 143 +++++++++++++++++------
 rsvg_internals/src/stop.rs           |   4 +-
 rsvg_internals/src/structure.rs      |  16 +--
 rsvg_internals/src/text.rs           | 119 +++++++++----------
 37 files changed, 285 insertions(+), 356 deletions(-)

commit 0e41a6d7a8bf78c535c4040baebe875fbefd4688
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 18 18:18:04 2018 -0500

    Stroke property: default to PaintServer::None

 rsvg_internals/src/state.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fe4c0e4e8d6bf2c899cf41979aa25685af5d4490
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Fri May 18 17:56:25 2018 -0500

    State::get_computed_values() - function to prepare for using ComputedValues in callers
    
    We will replace the State argument that we pass to Node::draw() with
    an immutable ComputedValues struct.

 rsvg_internals/src/state.rs | 53 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 53 insertions(+)

commit a5268f53b31253271671236d89e429fe223e755b
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Wed May 16 16:13:06 2018 -0500

    Add a SpecifiedValue enum, plus SpecifiedValues and ComputedValues structs
    
    The enum encodes whether a value is unspecified/inherited/specified.
    
    The structs are intended to replace the contents of the State struct.

 rsvg_internals/src/state.rs | 195 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 195 insertions(+)

commit 768a6e88a83088f8b3d4202737aa8a598bfe1837
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 21 14:13:00 2018 -0500

    rustfmt

 rsvg_internals/src/aspect_ratio.rs   | 11 ++++++-----
 rsvg_internals/src/color.rs          |  4 +++-
 rsvg_internals/src/filters/mod.rs    |  6 ++++--
 rsvg_internals/src/filters/offset.rs |  7 +++++--
 rsvg_internals/src/gradient.rs       |  4 +++-
 rsvg_internals/src/marker.rs         | 29 +++++++++++++++++------------
 rsvg_internals/src/path_parser.rs    | 19 ++++++++++++-------
 rsvg_internals/src/pattern.rs        | 14 ++++++++++----
 rsvg_internals/src/shapes.rs         | 12 ++++++++----
 rsvg_internals/src/stop.rs           |  4 +++-
 rsvg_internals/src/structure.rs      |  6 ++++--
 rsvg_internals/src/text.rs           | 12 ++++++++----
 rsvg_internals/src/transform.rs      | 36 ++++++++++++++++++++----------------
 13 files changed, 103 insertions(+), 61 deletions(-)

commit f6c21995383062a4df86fac93c9058fabcfeded1
Merge: b2b24e1c b0baafc0
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 21 12:00:33 2018 -0500

    Merge branch 'YaLTeR/librsvg-filters-to-rust'
    
    This integrates Ivan's and Paolo's work.
    
    I've regenerated filters-composite-02-b-ref.png - the old code
    incorrectly truncated the objectBoundingBox to ints; the new one
    preserves it as doubles.  In the old code, this caused the tips of the
    triangles in the test file to appear chopped off.

commit b2b24e1cfc4a5b2ceef0424d5f6177a95ffa6bf6
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 21 11:12:45 2018 -0500

    rustfmt

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9d18be829dc432c08d8ababc6357b3aaa6732e99
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon May 21 15:47:22 2018 +0200

    drawing_ctx: port rsvg_drawing_ctx_insert_bbox to rust

 librsvg/rsvg-drawing-ctx.c        |  6 ------
 librsvg/rsvg-drawing-ctx.h        |  3 ---
 rsvg_internals/src/drawing_ctx.rs | 11 +++++++----
 3 files changed, 7 insertions(+), 13 deletions(-)

commit 9c44203576826deb2104d6b9c4da0beb0c03e576
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon May 21 15:15:31 2018 +0200

    drawing_ctx: pass in the cairo surface
    
    Change the only caller of one of the methods to pass in the
    surface instead of expecting it as a return value. This allows
    us to reuse the same utility we use in other places to allocate
    the surface and it will also make it easier to port to rust
    since cairo-rs does not have an easy way to pass back a surface
    to C (there is no to_glib_full trait for cairo surface)

 librsvg/filters/image.c    |  6 +++++-
 librsvg/rsvg-drawing-ctx.c | 20 ++++++--------------
 librsvg/rsvg-drawing-ctx.h |  9 +++++----
 3 files changed, 16 insertions(+), 19 deletions(-)

commit b8b3db5f56b7b1c061124d27d7a52d70a04536e3
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Mon May 21 15:03:56 2018 +0200

    drawing_ctx: fix getters
    
    C is not rust...

 librsvg/rsvg-drawing-ctx.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit c692f805d61e69c0f5d058ccaa768646eadc1066
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Mon May 21 07:16:27 2018 -0500

    rustfmt

 rsvg_internals/src/drawing_ctx.rs | 2 +-
 rsvg_internals/src/gradient.rs    | 2 +-
 rsvg_internals/src/lib.rs         | 6 +++---
 3 files changed, 5 insertions(+), 5 deletions(-)

commit e3f242eada0835975b6c98e5ce39ca6449cfb1f1
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun May 20 15:17:00 2018 +0200

    drawing_ctx: move get_pango_context to rust
    
    Note that this requires adding the pangocairo-sys crate.

 Cargo.lock                        |  1 +
 librsvg/rsvg-drawing-ctx.c        | 30 +++----------------------
 librsvg/rsvg-drawing-ctx.h        |  6 ++---
 rsvg_internals/Cargo.toml         |  1 +
 rsvg_internals/src/drawing_ctx.rs | 46 ++++++++++++++++++++++++++++++++++-----
 rsvg_internals/src/lib.rs         |  1 +
 6 files changed, 49 insertions(+), 36 deletions(-)

commit af78c6f53d170ae515666d9a3950c09d741c9428
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun May 20 11:23:05 2018 +0200

    handle: move the test font map in the handle
    
    Instead of storing the test font map in the drawing ctx,
    change the global default font map when the handle is marked
    for testing.
    This is cleaner and additionally it removes the code conditional
    to PANGOFT2 from the drawing ctx, which makes it easier to
    move it to rust.

 librsvg/rsvg-base.c        |  46 +++++++++++++++++++
 librsvg/rsvg-drawing-ctx.c | 109 +++++----------------------------------------
 librsvg/rsvg-drawing-ctx.h |   5 ---
 librsvg/rsvg-handle.c      |  19 ++++++++
 librsvg/rsvg-private.h     |  11 ++++-
 5 files changed, 87 insertions(+), 103 deletions(-)

commit 2b012e5ec1727b6e54f8f3083a4d2df7d6cb2682
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sun May 20 11:07:52 2018 +0200

    drawing_ctx: add getters for width and height
    
    Also store a cairo rectangle internally, since it is easier to
    copy and restore

 librsvg/filters/common.c   |  3 ++-
 librsvg/rsvg-drawing-ctx.c | 54 +++++++++++++++++++++++++---------------------
 librsvg/rsvg-drawing-ctx.h |  9 ++++++--
 3 files changed, 39 insertions(+), 27 deletions(-)

commit b2cb658f43c0694fc78431971ece90c5170b0bce
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 22:00:08 2018 +0200

    bbox: store ink_box in the BoundingBox struct
    
    This allows to simplify the calling code: for instance drawing_ctx
    now only keeps one stack of bounding boxes and the drawing code
    does not need the intermediate Extents struct.

 librsvg/filters/common.c          | 12 ++++-----
 librsvg/rsvg-drawing-ctx.c        | 30 ++++------------------
 librsvg/rsvg-drawing-ctx.h        |  7 +----
 librsvg/rsvg-handle.c             |  8 ++++--
 librsvg/rsvg-private.h            |  4 +--
 rsvg_internals/src/bbox.rs        | 47 ++++++++++++++++++++++++++--------
 rsvg_internals/src/draw.rs        | 54 +++++++++++++++++----------------------
 rsvg_internals/src/drawing_ctx.rs | 10 --------
 8 files changed, 80 insertions(+), 92 deletions(-)

commit 8de999e6438ac9cb754a9be90724209c415b9738
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 17:45:47 2018 +0200

    bbox: rename the rust struct to BoundingBox
    
    Use RsvgBbox for the C pointer

 rsvg_internals/src/bbox.rs         | 37 ++++++++++++++++++++-----------------
 rsvg_internals/src/draw.rs         | 23 +++++++++++++----------
 rsvg_internals/src/drawing_ctx.rs  | 13 ++++++++-----
 rsvg_internals/src/gradient.rs     | 12 ++++++------
 rsvg_internals/src/paint_server.rs |  4 ++--
 rsvg_internals/src/pattern.rs      |  6 +++---
 6 files changed, 52 insertions(+), 43 deletions(-)

commit 17ba342429bf4d1f7ceb047cfebb1443fd4bea61
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 17:23:11 2018 +0200

    rect: make is_empty handle approximations
    
    Remove is_empty from bbox and use rect.is_empty in its
    only caller

 rsvg_internals/src/bbox.rs     |  8 --------
 rsvg_internals/src/gradient.rs | 14 ++++++++------
 rsvg_internals/src/rect.rs     |  5 +++--
 3 files changed, 11 insertions(+), 16 deletions(-)

commit da7540aaaa1e694993ac74e621825bcae3bcc779
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 17:16:36 2018 +0200

    bbox: use Option<> for the rect

 rsvg_internals/src/bbox.rs     | 53 ++++++++++++++----------------------------
 rsvg_internals/src/draw.rs     |  8 +++----
 rsvg_internals/src/gradient.rs |  9 +++----
 rsvg_internals/src/pattern.rs  | 13 +++++++----
 4 files changed, 34 insertions(+), 49 deletions(-)

commit 6b9884f501dc91c368f0869025a6bd30ac930e8d
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 16:35:43 2018 +0200

    draw: factor out an utility to get bbox from extents

 rsvg_internals/src/draw.rs | 68 +++++++++++++---------------------------------
 1 file changed, 19 insertions(+), 49 deletions(-)

commit 2a4ad194f4cf69200eb28cf4f4649a2f5f6bcd7e
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 15:21:12 2018 +0200

    drawing_ctx: add a getter for the bbox

 librsvg/rsvg-drawing-ctx.c | 6 ++++++
 librsvg/rsvg-drawing-ctx.h | 3 +++
 librsvg/rsvg-filter.c      | 4 +++-
 3 files changed, 12 insertions(+), 1 deletion(-)

commit e1cd8a0fc542deee05ab46d14a0eedad2ded8b4a
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 15:06:24 2018 +0200

    bbox: make RsvgBbox opaque

 librsvg/filters/common.c   | 21 ++++++++++--------
 librsvg/rsvg-drawing-ctx.c | 55 +++++++++++++++++++++-------------------------
 librsvg/rsvg-drawing-ctx.h |  4 ++--
 librsvg/rsvg-filter.c      |  2 +-
 librsvg/rsvg-handle.c      |  4 ++--
 librsvg/rsvg-private.h     | 16 ++++++++------
 rsvg_internals/src/bbox.rs | 32 +++++++++++++++++++--------
 rsvg_internals/src/lib.rs  | 10 ++++++++-
 8 files changed, 83 insertions(+), 61 deletions(-)

commit d8f1d7daf57a157d903f78cd0c7178d07d468efd
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 12:45:32 2018 +0200

    bbox: do not access fields directly
    
    The struct is not opaque yet because we use it as a field of the
    drawing ctx, so we must know its size

 librsvg/filters/common.c   | 77 ++++++++++++++++++++++++----------------------
 librsvg/rsvg-drawing-ctx.c | 45 ++++++++++++++++-----------
 librsvg/rsvg-handle.c      | 35 +++++++++------------
 librsvg/rsvg-private.h     | 10 ++++--
 rsvg_internals/src/bbox.rs | 22 ++++++++++++-
 rsvg_internals/src/lib.rs  |  2 +-
 6 files changed, 111 insertions(+), 80 deletions(-)

commit 78f5554c0fe6d1ccb2a39fac6947b2c6e0b1c84c
Author: Paolo Borelli <pborelli@gnome.org>
Date:   Sat May 19 11:15:06 2018 +0200

    rect: refactor to a RectangleExt trait

 rsvg_internals/src/bbox.rs        |  31 +++----
 rsvg_internals/src/drawing_ctx.rs |  16 ++--
 rsvg_internals/src/rect.rs        | 171 ++++++++++++++++++++------------------
 3 files changed, 108 insertions(+), 110 deletions(-)

commit 48b6dcf703af964445231c3ecdcde660665e204a
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sun May 20 20:54:29 2018 -0500

    gitlab#263 - Ignore errors when parsing CSS values
    
    Per the CSS spec, values which can't be parsed should be ignored.  We
    were setting the whole node to be in error.
    
    https://gitlab.gnome.org/GNOME/librsvg/issues/263

 rsvg_internals/src/state.rs | 13 ++++++++++---
 1 file changed, 10 insertions(+), 3 deletions(-)

commit f1b89576a5091684380af072ed187dbdb0d95d6d
Author: Federico Mena Quintero <federico@gnome.org>
Date:   Sun May 20 20:53:36 2018 -0500

    Add the Adwaita icon theme as reference tests
    
    These have lots of parseable stuff inside "style" attributes.

 .../reftests/adwaita/ac-adapter-symbolic-ref.png   | Bin 0 -> 327 bytes
 .../reftests/adwaita/ac-adapter-symbolic.svg       |  32 +++++
 .../accessories-calculator-symbolic-ref.png        | Bin 0 -> 179 bytes
 .../adwaita/accessories-calculator-symbolic.svg    |  31 +++++
 .../accessories-character-map-symbolic-ref.png     | Bin 0 -> 498 bytes
 .../adwaita/accessories-character-map-symbolic.svg |  33 +++++
 .../accessories-dictionary-symbolic-ref.png        | Bin 0 -> 416 bytes
 .../adwaita/accessories-dictionary-symbolic.svg    |  34 +++++
 .../accessories-text-editor-symbolic-ref.png       | Bin 0 -> 228 bytes
 .../adwaita/accessories-text-editor-symbolic.svg   |  39 ++++++
 .../adwaita/action-unavailable-symbolic-ref.png    | Bin 0 -> 495 bytes
 .../adwaita/action-unavailable-symbolic.svg        | 126 +++++++++++++++++
 .../adwaita/address-book-new-symbolic-ref.png      | Bin 0 -> 438 bytes
 .../reftests/adwaita/address-book-new-symbolic.svg |  40 ++++++
 .../adwaita/airplane-mode-symbolic-ref.png         | Bin 0 -> 371 bytes
 .../reftests/adwaita/airplane-mode-symbolic.svg    |  35 +++++
 .../reftests/adwaita/alarm-symbolic-ref.png        | Bin 0 -> 593 bytes
 tests/fixtures/reftests/adwaita/alarm-symbolic.svg |  35 +++++
 .../adwaita/applets-screenshooter-symbolic-ref.png | Bin 0 -> 372 bytes
 .../adwaita/applets-screenshooter-symbolic.svg     |  33 +++++
 .../application-certificate-symbolic-ref.png       | Bin 0 -> 345 bytes
 .../adwaita/application-certificate-symbolic.svg   |  33 +++++
 .../adwaita/application-exit-symbolic-ref.png      | Bin 0 -> 279 bytes
 .../reftests/adwaita/application-exit-symbolic.svg |  32 +++++
 .../adwaita/application-rss+xml-symbolic-ref.png   | Bin 0 -> 458 bytes
 .../adwaita/application-rss+xml-symbolic.svg       |  32 +++++
 .../adwaita/application-x-addon-symbolic-ref.png   | Bin 0 -> 289 bytes
 .../adwaita/application-x-addon-symbolic.svg       |  35 +++++
 .../application-x-appliance-symbolic-ref.png       | Bin 0 -> 489 bytes
 .../adwaita/application-x-appliance-symbolic.svg   |  44 ++++++
 .../application-x-executable-symbolic-ref.png      | Bin 0 -> 402 bytes
 .../adwaita/application-x-executable-symbolic.svg  |  31 +++++
 .../application-x-firmware-symbolic-ref.png        | Bin 0 -> 543 bytes
 .../adwaita/application-x-firmware-symbolic.svg    |  48 +++++++
 .../applications-engineering-symbolic-ref.png      | Bin 0 -> 413 bytes
 .../adwaita/applications-engineering-symbolic.svg  |  32 +++++
 .../adwaita/applications-games-symbolic-ref.png    | Bin 0 -> 409 bytes
 .../adwaita/applications-games-symbolic.svg        |  31 +++++
 .../adwaita/applications-graphics-symbolic-ref.png | Bin 0 -> 568 bytes
 .../adwaita/applications-graphics-symbolic.svg     |  33 +++++
 .../applications-multimedia-symbolic-ref.png       | Bin 0 -> 291 bytes
 .../adwaita/applications-multimedia-symbolic.svg   |  34 +++++
 .../adwaita/applications-science-symbolic-ref.png  | Bin 0 -> 522 bytes
 .../adwaita/applications-science-symbolic.svg      |  32 +++++
 .../adwaita/applications-system-symbolic-ref.png   | Bin 0 -> 411 bytes
 .../adwaita/applications-system-symbolic.svg       |  31 +++++
 .../applications-utilities-symbolic-ref.png        | Bin 0 -> 416 bytes
 .../adwaita/applications-utilities-symbolic.svg    |  33 +++++
 .../adwaita/appointment-missed-symbolic-ref.png    | Bin 0 -> 499 bytes
 .../adwaita/appointment-missed-symbolic.svg        |  33 +++++
 .../adwaita/appointment-new-symbolic-ref.png       | Bin 0 -> 467 bytes
 .../reftests/adwaita/appointment-new-symbolic.svg  |  33 +++++
 .../adwaita/appointment-soon-symbolic-ref.png      | Bin 0 -> 451 bytes
 .../reftests/adwaita/appointment-soon-symbolic.svg |  33 +++++
 .../reftests/adwaita/audio-card-symbolic-ref.png   | Bin 0 -> 309 bytes
 .../reftests/adwaita/audio-card-symbolic.svg       |  36 +++++
